2025-06-14  Aidan Kehoe  <kehoea@parhasard.net>

	* XEmacs 21.5.36 "leeks" is released.

2025-06-11  Alan Mackenzie  <acm@muc.de>

	Enhance the handling of syntax-table properties.  This enables C-u
	C-x = (`what-cursor-position') to work on, for example,
	unterminated string delimiters in C Mode.

	* syntax.el (modify-syntax-entry): Add documentation for ! =
	comment-fence and | = string-fence in the doc string.

	* syntax.el (describe-syntax-code): In the array of syntax textual
	descriptions, replace the ?obsolete "extended-word-constituent"
	with "comment-fence", and append "string-fence".

2025-06-11  Alan Mackenzie  <acm@muc.de>

	Fontify also the last character of an unterminated string.

	* font-lock.el (font-lock-fontify-syntactically-region): Before
	subtracting 1 from the second argument to font-lock-set-face (for
	the closing double quote), check the string was actually closed.

2025-06-06  Alan Mackenzie  <acm@muc.de>

	Correct the value of regexp-opt on being given an empty list.

	* regexp-opt.el (regexp-opt): Return a regexp which doesn't match
	anything when the STRINGS argument is the empty list.

2025-06-05  Alan Mackenzie  <acm@muc.de>

	Purge the package-suppress mechanism from XEmacs.

	Make the versions of easy-mmode.el and regexp-opt.el in
	.../xemacs/lisp the active ones.

	* easy-mmode.el:
	Restore the commented out ;;;###autoload cookies.

	* packages.el:
	* packages.el (package-suppress): Removed.

2025-06-05  Aidan Kehoe  <kehoea@parhasard.net>

	Remove support for emacs implementations without #'add-timeout,
	itimer.el, significantly simplifying the file.

	* itimer.el:
	* itimer.el (itimer-version): Bump this.
	* itimer.el (itimer-timer): Update the docstring here.
	* itimer.el (itimer-process): Removed.
	* itimer.el (set-itimer-value): Just use #'itimer-timer-wakeup
	here, not #'itimer-driver-wakeup.
	* itimer.el (activate-itimer): Ditto.
	* itimer.el (list-itimers): In passing revise this to make
	#'itimer-truncate-string a label and to traverse the list of
	itimers in a more post-1990 way.
	* itimer.el (edit-itimers): Call #'itimer-timer-wakeup here.
	* itimer.el (itimer-truncate-string): Moved to being a label
	within #'list-itimers.
	* itimer.el (itimer-run-expired-timers):
	last-command-event-time, last-input-time will both always be
	bound, don't check for that.
	* itimer.el (itimer-process-filter): Removed.
	* itimer.el (itimer-disable-timeout): Removed, now equivalent to
	#'disable timeout.
	* itimer.el (itimer-process-sentinel): Removed.
	* itimer.el (itimer-timer-driver): Just call #'disable-timeout
	within this.
	* itimer.el (itimer-process-start): Removed.
	* itimer.el (itimer-driver-start): Removed.
	* itimer.el (itimer-driver-wakeup): Removed.
	* itimer.el (itimer-process-wakeup): Removed.

2025-05-26  Aidan Kehoe  <kehoea@parhasard.net>

	Support text/plain, text/plain;charset=utf-8 when cutting and
	pasting under X11, needed for more recent clients that are not
	interested in longstanding standards (Libreoffice and the terminal
	emulator Terminology in my use).
	* select.el:
	* select.el (selection-preferred-types): Add them to this.
	* select.el ('selected-text-type): Remove this obsolete name in
	passing.
	* select.el (own-selection): Fix some indentation in passing.
	* select.el (select-convert-from-undecided-text): New. Now used when
	supplied text/plain, use our coding detection to work out what
	encoding is in use.
	* select.el (selection-converter-out-alist): Add the new entries
	here. 
	* select.el (selection-converter-in-alist): And here.
	* select.el (selection-coercible-types): Fix some indentation
	here.

2025-05-25  Alan Mackenzie  <acm@muc.de>

	* regexp-opt.el (regexp-opt):
	Handle a PAREN value of `symbols' which now wraps the inner
	regular expression in the symbol brackets "\\_<" and "\\_>".

2025-05-25  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-compile-unfold-lambda):
	No longer call #'fetch-bytecode in this, quiet a warning.

2025-05-25  Aidan Kehoe  <kehoea@parhasard.net>

	Take an optional TEST argument, #'assoc, as does GNU. Revise
	related compiler macros to reflect this.

	* cl-macs.el:
	* cl-macs.el (assoc):
	Handle the optional TEST argument in this compiler macro. Still
	transform to an #'assq call if we can tell at compile time that
	#'eq is the appropriate test.
	* cl-macs.el (assoc*): New explicit compiler macro for this
	function, can't handle #'assoc* in the define-star-compiler-macros
	macro any more.
	* cl-macs.el (define-star-compiler-macros): Remove handling of
	#'assoc* from here.
	* custom.el (custom-current-group): This is called very early when
	#'assoc is not available, use #'assoc* instead.
	* custom.el (custom-declare-group): Ditto.
	* subr.el (assoc): New. Moved here from sequence.c.

2025-05-24  Alan Mackenzie  <acm@muc.de>

	Make "\\_<" and "\\_>" work in regexp buffer searches.

	* isearch-mode.el (isearch-search):
	Translate an error message from regex.c beginning with "Invalid "
	into "invalid input" rather than "incomplete input".

2025-05-24  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-lambda):
	Don't double-compile a compiled function supplied as the argument
	to (interactive ...), thank you Alan Mackenzie.

2025-05-11  Aidan Kehoe  <kehoea@parhasard.net>

	* update-elc.el:
	Correct the dependency checks when --with-dump-in-exec here.
	In passing, short circuit the checks for .el and .elc files being
	out of date with regard to the dump files, once it has been t once
	there's no need to do a stat(2) for any further files.

2025-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el (coding-system-for-read)): defvar removed.
	* files.el (buffer-file-coding-system)): defvar removed.
	No need for these declarations now the non-mule option is gone.
	* files.el (hack-one-local-variable):
	Update a comment here.

2025-05-04  Aidan Kehoe  <kehoea@parhasard.net>

	* obsolete.el:
	* obsolete.el (cl-delete-duplicates): Removed.
	No longer needed, and conflicts with GNU's cl-lib function name
	(calling convention is distinct), better gone.

2025-04-26  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (true-list-p):
	* subr.el (safe-length):
	Make both of these 15% faster, use Lisp boolean negation and the
	associated bytecodes for advancing the tortoise rather than
	calling #'logand on the counter
	(#'logand has no byte code).

2025-04-10  Aidan Kehoe  <kehoea@parhasard.net>

	* loadhist.el (feature-file):
	* loadhist.el (file-symbols):
	* loadhist.el (unload-feature):
	Modernize loadhist.el; return structured errors, use
	#'file-system-ignore-p to determine the comparison function when
	testing, use #'remove* instead of #'delete + #'copy-sequence.
	No need to wrap #'unload-module in #'declare-fboundp given
	HAVE_SHLIB is the default.

2025-04-10  Aidan Kehoe  <kehoea@parhasard.net>

	* loadup.el (member):
	No need to explicitly set stack-trace-on-error, debug-on-error to
	nil before dump.

2025-03-11  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (replace-list):
	Correct a bug in this implementation just elicited in frame.c,
	thank you Stephen Turnbull.

2025-03-08  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (replace-list): New. Moved here from fns.c.
	* subr.el ('substring): Removed. Alias now created in sequence.c.

2025-03-06  Aidan Kehoe  <kehoea@parhasard.net>

	* unicode.el:
	Move some code that tested unicode-error-default-translation-table
	and unicode-invalid-sequence-regexp-range to
	../tests/automated/regexp-tests.el.

2025-03-01  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el (early-error-handler):
	Move #'force-debugging-signal inside the binding of STREAM, fix a
	bug and avoid a compile-time warning.

2025-02-24  Aidan Kehoe  <kehoea@parhasard.net>

	Remove checks for (featurep 'mule) from core Lisp, making our code
	a little more maintainable. The Lisp side of eed34ee08c9b . 

	* autoload.el (autoload-featurep-protect-autoloads):

	* bytecomp.el (byte-recompile-ignore-uncompilable-mule-files):
	Removed. No longer needed with removal of support for non-Mule.

	* bytecomp.el (byte-recompile-directory):
	Always execute the Mule-specific code.
	* bytecomp.el (byte-recompile-file): Ditto.
	* bytecomp.el (byte-compile-file): Ditto.
	* bytecomp.el (byte-compile-maybe-reset-coding): Ditto.
	* code-init.el:
	* code-init.el (eol-detection-enabled-p): Default this to
	t. Remove docstring commentary that is no longer true.
	* code-init.el (set-eol-detection):
	Remove docstring commentary that is no longer true.
	* code-init.el (coding-system-current-system-configuration):
	Remove the non-Mule options for this.
	* code-init.el (define-coding-system-default-configuration):
	Remove the no-mule-no-eol-detection, no-mule-eol-detection,
	windows-no-mule calls for this.
	* code-init.el (reset-coding-categories-to-default):
	Correct indentation here. Always execute the Mule code.

	* coding.el: Remove some non-Mule code, no longer needed.
	* compose.el:
	Use Unicode character literals instead of load time #'decode-char
	calls. No need to construct a big if statement at load time
	depending on whether characters can be decoded.

	* dumped-lisp.el (preloaded-file-list):
	Always load the Mule-relevant files.

	* fill.el (fill-move-forward-to-break-point):
	* fill.el (fill-region-as-paragraph):
	Always call the kinsoku processing in this file.

	* finder.el (finder-known-keywords):
	Always include Mule in the keywords.
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* gtk-font-menu.el (gtk-font-menu-font-data):
	Don't check (featurep 'mule) here.
	* help.el:
	* help.el (tutorial-supported-languages): Removed.
	This has actually been basically unused for decades, information
	taken from the language environment.
	* help.el (help-with-tutorial):
	Use #'read-language-name unconditionally when reading args.
	Trust the coding cookies in the tutorial files, just added, don't
	bind coding-system-for-read.
	* iso8859-1.el:
	Remove some non-Mule code.
	* menubar-items.el (default-menubar):
	Unconditionally include entries relevant to Mule.
	* menubar-items.el (tutorials-menu-filter):
	Ditto.

	* msw-font-menu.el (mswindows-font-menu-font-data):
	Don't check (featurep 'mule) here.
	* newcomment.el (comment-indent-new-line):
	Always call kinsoku processing here.
	* package-get.el (package-get):
	Never error because of no Mule support.
	* packages.el (packages-package-hierarchy-directory-names):
	Unconditionally include the Mule packages.

	* paragraphs.el (sentence-end-without-space):
	Update this to assume Mule is always available.
	* paragraphs.el (sentence-end-base): Ditto.
	* select.el (selection-preferred-types):
	Always include COMPOUND_TEXT here.

	* simple.el (do-auto-fill):
	Always call kinsoku processing here.
	* startup.el (command-line):
	* startup.el (splash-screen-window-body):
	* startup.el (startup-setup-paths):
	* startup.el (startup-setup-paths-warning):
	* startup.el (startup-load-autoloads):
	Always call the Mule code in this file. Remove non-Mule code.
	* syntax.el (describe-char-table): Ditto.
	* unicode.el: Ditto.
	* update-elc-2.el:
	* update-elc-2.el (update-elc-ignored-dirs):
	Never include "mule/" in this .
	* update-elc-2.el (batch-update-elc-2):
	Always call the Mule code within this.
	* update-elc.el:
	* update-elc.el (update-elc-files-to-compile):
	Ditto.
	* version.el (emacs-version):
	Always include ", Mule" in the version string.
	* x-font-menu.el (x-reset-device-font-menus-core):
	Remove non-Mule code.
	* x-font-menu.el (x-font-menu-font-data-xft): Ditto.
	* x-font-menu.el (x-font-menu-font-data-core): Ditto.

2025-02-22  Aidan Kehoe  <kehoea@parhasard.net>

	Remove byte-compile-dynamic from the byte compiler, no longer
	worth the decrease in speed and difficulties with files being
	recompiled and offsets getting incorrect with with RAM sizes as
	they are.
	* bytecomp.el:
	* bytecomp.el (byte-compile-dynamic-docstrings): Default this to
	t. Document that it is not currently implemented for files with
	character or string literals with numeric value above ?\xFF.
	* bytecomp.el (byte-compile-dynamic): Removed.
	* bytecomp.el (byte-compile-close-variables):
	Remove byte-compile-dynamic from here.
	* bytecomp.el (byte-compile-from-buffer): Ditto.
	* bytecomp.el (byte-compile-maybe-reset-coding): Ditto.
	* bytecomp.el (byte-compile-output-docform): Ditto.
	* bytecomp.el (byte-compile-file-form-defmumble): Ditto.
	* obsolete.el (fetch-bytecode): New. Moved here from bytecode.c.

2025-02-03  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (kill-forward-chars): Removed.
	This has always been supplied a fixnum argument by #'delete-char
	as far back as our version control goes, so it adds no value
	beyond #'delete-char calling #'kill-region directly.
	Unsurprisingly it is not used in packages.

2025-02-02  Aidan Kehoe  <kehoea@parhasard.net>

	* obsolete.el (make-local-handler):
	Add a handler that errors on attempting
	`make-variable-buffer-local' on before-change-function,
	after-change-function.

2025-02-02  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el (self-insert-internal): New.
	Move this here from cmds.c, never called frequently enough to
	merit being in C.

2025-01-13  Aidan Kehoe  <kehoea@parhasard.net>

	* minibuf.el (read-number):
	Call (ding nil ...) for symmetry with the completing-read code,
	don't abort keyboard macros as does (beep) without arguments.

2025-01-12  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el (early-error-handler):
	If (featurep 'debug-exemacs) and otherwise about to exit, call
	#'force-debugging-signal within this function and not from C.

2025-01-06  Aidan Kehoe  <kehoea@parhasard.net>

	* obsolete.el:
	* obsolete.el (before-change-function):
	* obsolete.el (after-change-function):
	Move the implementation of these obsolete variables to Lisp, using
	symbol-value handlers.

2024-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	No longer GC after loading every file when dumping, there is no
	benefit to this with pdump.
	Rationalise things with this, no longer make a #'pureload function
	available at any point, examine the output of (emacs-run-status)
	instead.
	* auto-show.el:
	Fix a bug with this, turn on auto-show-mode if we are currently
	dumping, rather than if the symbol pureload is bound as a
	variable.

	* cus-face.el (custom-declare-face):
	* dumped-lisp.el (preloaded-file-list):
	Remove mention of #'pureload from comments in these files.

	* loadup.el:
	Don't bind gc-cons-threshold within code to load those files in
	preloaded-file-list.
	Rationalise things a bit, print the load path as it is actually
	determined, not before it is set.
	Remove some debugging code that will now never be called, since
	#'load errors rather than returning nil.

	* site-load.el:
	* site-load.el (file-exists-p):
	Just (mapc #'load site-load-packages), no need for a pureload
	macro.
	* update-elc.el (preloaded-file-list):
	Modernise some error-handling code here, now #'format is not
	built-in.

2024-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	* loadup.el (member):
	#'really-free is never bound these days, remove mention of it.

2024-12-20  Aidan Kehoe  <kehoea@parhasard.net>

	* setup-paths.el (paths-emacs-root-p):
	Remove autodetection of exec-directory including /libexec/, since
	we are tightening up allowed paths with the dump file
	--without-dump-in-exec.

2024-12-17  Aidan Kehoe  <kehoea@parhasard.net>

	* glyphs.el (toolbar-button-p): New. Moved here from toolbar.c,
	keep it available on non-toolbar builds.
	* specifier.el (toolbar-specifier-p): New. Moved here from
	toolbar.c, keep it available on non-toolbar builds.
	* loadup.el:
	Remove stub implementations of these functions from loadup.el.

2024-11-30  Aidan Kehoe  <kehoea@parhasard.net>

	* info.el (Info-extract-dir-entry-from):
	Use #'Info-insert-file-contents' rather than
	#'insert-file-contents in this file, handling compressed files
	appropriately. Thank you for the bug report, Mats Lidell.

2024-10-14  Aidan Kehoe  <kehoea@parhasard.net>

	* loadhist.el (symbol-file):
	Return the C source file for symbols loaded from modules, now that
	is available.

2024-10-14  Aidan Kehoe  <kehoea@parhasard.net>

	* loadhist.el (unload-feature):
	Do a better job within this function, check for defun as the first
	element of a cons entry in load-history and #'fmakunbound
	appropriately.

2024-10-14  Aidan Kehoe  <kehoea@parhasard.net>

	* help.el (describe-function-1):
	Simplify this function a little.
	* loadhist.el (symbol-file):
	Handle subrs and vars loaded from modules better within this
	function.

2024-10-13  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (max, min):
	Move these here from data.c, for the sake of mantainability and no
	loss of speed.
	We have been returning markers from these functions since 2018
	without problems; change things slightly to never convert the
	arguments.

2024-08-18  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el (find-file-noselect-1):
	* gutter-items.el (clear-progress-feedback):
	* gutter-items.el (abort-progress-feedback):
	* gutter-items.el (raw-append-progress-feedback):
	* simple.el (clear-message):
	* simple.el (remove-message):
	* simple.el (raw-append-message):
	`inhibit-read-only' is a local variable in the minibuffer (see
	Kyle Jone's commit of 1997-11-16) and so binding it and then
	calling #'erase-buffer without making the relevant buffer current
	can fail. Correct this, avoid wedging the echo area with
	blink-matching-open and read-only duplicable extents.

2024-06-20  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp-runtime.el (byte-compile-annotate-interactive): New.
	Return a list to aid #'call-interactively in constructing
	command-history, analysing its argument S-expression and returning
	a list that documents which arguments in an interactive form
	should be replaced by explicit calls to (point), (mark) and
	friends in the command history.
	Called both at compile time and at runtime.
	* bytecomp.el (byte-compile-lambda): Use it. Always compile and
	save the interactive spec, as a compiled function that returns a
	cons comprising the metadata as its car and the result of
	calling the S-expression as its cdr.

2024-06-25  Aidan Kehoe  <kehoea@parhasard.net>

	* apropos.el (apropos-internal):
	Move this here from symbols.c, add an autoload cookie. There is
	minimal speed advantage now to having this in Lisp and this file
	is a better place for it than symbols.c.

2024-05-06  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (current-command-is-motion):
	Make the value for xemacs-mod-shift more robust, work it out by
	generating an event with the shift modifier at byte-compile time
	and querying it for its modifier bits.

2024-04-15  Aidan Kehoe  <kehoea@parhasard.net>

	* info.el (Info-find-file-node):
	Ensure buffer-file-coding-system reflects the coding system of the
	current Info file by killing its local value on loading a fresh
	Info superfile. This makes the anchor handling more reliable.
	* info.el (Info-load-subfile):
	Force the coding system determined for the superfile to apply to
	the subfile (since the superfile routinely has coding cookies that
	the subfile lacks.)

2024-05-01  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el (maybe-display-char): New.
	If #'read-char, #'read-char-exclusive, #'read-quoted-char are
	supplied a PROMPT argument, echo the character read for better
	user feedback and for symmetry with #'read-string and friends.  Do
	not echo if PROMPT is nil.

2024-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	Add support for anchors within #'Info-find-file-node, by means of
	triangulating back from the previous or next nodes. Thank you for
	the bug report, Mats Lidell.
	* info.el:
	* info.el (Info-tag-table-marker): Removed.
	* info.el (Info-tag-table-buffer): Removed.
	* info.el (Info-tag-table): New variable.
	* info.el (Info-tag): New structure.
	* info.el (Info-subfiles): New variable.
	* info.el (Info-load-tag-table): New function. To be called at the
	time of loading of an info file, parses the textual tag table into
	a list documenting tag names, subfile names, and byte offsets.
	* info.el (Info-find-file-node):
	Revise to use the tag table parsed at the time the file is
	loaded.
	* info.el (Info-read-subfile): Removed. This no longer fits our
	needs.
	* info.el (Info-load-subfile): New. Similar function to previous,
	explicitly takes the file name to be loaded. 
	* info.el (Info-build-node-completions):
	Use Info-tag-table when constructing the node completions.
	* info.el (Info-search):
	Use Info-subfiles when iterating through the subfiles when
	searching.
	* info.el (Info-mode):
	* info.el (Info-cease-edit):
	Remove use of variables that are no longer in use in these functions.

2024-03-01  Richard Hopkins  <xemacs@unbit.co.uk>

	* term/xterm.el: Define Insert + Delete with modifiers in
	`function-key-map'.

2024-02-29  Richard Hopkins  <xemacs@unbit.co.uk>

	* term/xterm.el: Define Page Up + Page Down keys
	(prior, next) with all modifier combinations in
	`function-key-map'.

2023-10-24  Richard Hopkins  <xemacs@unbit.co.uk>

	* font.el (font-lookup-rgb-components): Inhibit
	"Note: file is write protected" - we're only doing lookups in a
	hidden buffer.

2023-10-21  Richard Hopkins  <xemacs@unbit.co.uk>

	* tty-init.el (make-device-late-tty-entry-point): Register
	standard XTerm 256 colors when the device supports 256 colors.
	The color names are "color-N" which is based on the the XTerm
	number and is also used on GNU Emacs.

2023-10-18  Richard Hopkins  <xemacs@unbit.co.uk>

	* font.el (font-parse-rgb-components): Add and use
	scale-rgb-components to correct scaling of rgb:hex/hex/hex
	variants and the 3 digit per component #hex string.

2023-10-17  Richard Hopkins  <xemacs@unbit.co.uk>

	* font.el (font-parse-rgb-components): Correct scaling of colors
	with a single hex digit per component.

2023-10-16  Richard Hopkins  <xemacs@unbit.co.uk>

	* font.el (font-parse-rgb-components): Correct scaling of colors
	in #fefefe format.  This also fixes usages of
	#'font-color-rgb-components with input strings having a component
	range of

	a) [0.0, 1.0]
	b) [0, 255]

	as it uses the #fefefe format as an intermediary.

2023-10-15  Richard Hopkins  <xemacs@unbit.co.uk>

	* font.el (font-lookup-rgb-components): Correct scaling of an rgb
	component read from rgb.txt.  This is easily shown using "white"
	which should return (65535 65535 65535).

2023-10-14  Richard Hopkins  <xemacs@unbit.co.uk>

	* font.el (font-tty-find-closest-color): Use
	#'find-tty-closest-color instead.  Add optional device arg for use
	by #'find-tty-closest-color.

	* font.el (font-normalize-color): Pass along device to
	#'font-tty-find-closest-color.

2023-08-11  Richard Hopkins  <xemacs@unbit.co.uk>

	* term/xterm.el: Define motion keys (left,right,up,down,home,end)
	with all modifier combinations in `function-key-map'.

2023-08-05  Richard Hopkins  <xemacs@unbit.co.uk>

	* tty-init.el (make-device-late-tty-entry-point): Provide RGB
	values to #'register-tty-color for the basic 16 colors.

2023-08-06  Aidan Kehoe  <kehoea@parhasard.net>

	* events.el (key-press-event-p):
	Make this into a defsubst*, for the sake of
	#'handle-pre-motion-command.
	* simple.el (motion-keys-for-shifted-motion):
	Update the default value (and the suggested values) of this to put
	the keys in their canonical form, so #'canonicalize-keysym has no
	need to cons.
	* simple.el (current-command-is-motion): New. The following, moved
	to being a label with a shorter name.
	* simple.el (current-command-is-motion): New. The following, moved
	to being a label with a shorter name.
	* simple.el (handle-pre-motion-command-current-command-is-motion):
	Removed.
	* simple.el (command-event-is-shifted): New label, for the use of
	#'handle-pre-motion-command, #'handle-post-motion-command;
	reworked to avoid consing for both these very commonly called
	functions.
	* simple.el (handle-pre-motion-command): Rework this to delay
	calling #'current-command-is-motion as late as possible, and to
	use #'command-event-is-shifted.
	* simple.el (handle-post-motion-command):
	Ditto.

2023-08-05  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (motion-keys-for-shifted-motion):
	Adjust the docstring of this for readability, adjusts its
	suggested custom values to include the defaults.
	* simple.el (handle-pre-motion-command-current-command-is-motion):
	Examine last-command-event, not last-input-event, in this
	function, avoiding issues with function-key-map and TTY consoles
	which make end, home, etc available via it.
	* simple.el (handle-pre-motion-command):
	* simple.el (handle-post-motion-command):
	Examine this-command-keys-shift-translated in these functions,
	newly made available in event-stream.c

2023-07-22  Richard Hopkins  <xemacs@unbit.co.uk>

	* tty-init.el (make-device-early-tty-entry-point): Move color
	registration to #'make-device-late-tty-entry-point as it needs to
	know which device it's for.
	* tty-init.el (make-device-late-tty-entry-point): New.

2023-05-13  Aidan Kehoe  <kehoea@parhasard.net>

	* XEmacs 21.5.35 "kohlrabi" is released.

2023-05-08  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-optimize-zerop):
	Don't use #'byte-optimize-zerop incorrectly in this function, use
	#'cl-safe-expr-p instead, which also checks that subforms do not
	have side effects.
	* byte-optimize.el (byte-optimize-side-effect-free-p):
	Add a docstring to this function, all going well preventing the
	above bug going forward.

2023-04-16  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/compiled-unicode-tables.el (unicode-ignore-first-column):
	* mule/compiled-unicode-tables.el (harvest-unicode-files):
	* mule/compiled-unicode-tables.el (search-for-unicode-path-strings):
	* mule/compiled-unicode-tables.el (match-all-unicode-files):
	Revise these functions to respect directory-sep-char,
	necessary for building for win32-native.

2023-01-29  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (display-call-tree):
	Don't error within this when dealing with anonymous functions.

2022-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	* info.el (Info-find-file-node):
	Info-tag-table-marker is buffer-local, and we need to
	#'set-marker on the value in the original buffer, not the tag
	table buffer. Avoid error with C-u F1 i ../info/lispref.info RET
	with this change.

2022-12-18  Aidan Kehoe  <kehoea@parhasard.net>

	* compat.el:
	* diagnose.el:
	* dialog-gtk.el:
	* dialog-items.el:
	* dump-paths.el:
	* font-menu.el:
	* font.el:
	* gdk.el:
	* generic-widgets.el:
	* glade.el:
	* gnome-widgets.el:
	* gnome.el:
	* gpm.el:
	* gtk-compose.el:
	* gtk-extra.el:
	* gtk-faces.el:
	* gtk-ffi.el:
	* gtk-file-dialog.el:
	* gtk-init.el:
	* gtk-mouse.el:
	* gtk-package.el:
	* gtk-password-dialog.el:
	* gtk-select.el:
	* gtk-widget-accessors.el:
	* gtk-widgets.el:
	* gtk.el:
	* gutter.el:
	* hash-table.el:
	* help-macro.el:
	* itimer.el:
	* loadup-el.el:
	* msw-faces.el:
	* msw-init.el:
	* msw-select.el:
	* mule/compiled-unicode-tables.el:
	* mule/general-early.el:
	* mule/iso-with-esc.el:
	* mule/kinsoku.el:
	* mule/mule-category.el:
	* mule/mule-coding.el:
	* mule/mule-composite-stub.el:
	* mule/mule-msw-init-late.el:
	* mule/mule-win32-init.el:
	* mule/windows.el:
	* next-error.el:
	* occur.el:
	* package-net.el:
	* post-gc.el:
	* printer.el:
	* raw-process.el:
	* resize-minibuffer.el:
	* term/bobcat.el:
	* term/cygwin.el:
	* term/linux.el:
	* term/scoansi.el:
	* term/tvi970.el:
	* term/vt102.el:
	* term/vt125.el:
	* term/vt200.el:
	* term/vt201.el:
	* term/vt220.el:
	* term/vt240.el:
	* term/vt300.el:
	* term/vt320.el:
	* term/vt400.el:
	* term/vt420.el:
	* unicode.el:
	* widgets-gtk.el:
	Add missing ";;; FILE.el ends here" lines at the end of all these
	Lisp files, a good practice that I want to encourage.

2022-11-06  Aidan Kehoe  <kehoea@parhasard.net>

	* info.el (Info-find-file-node):
	Avoid provoking a warning when calling #'match-end in a buffer
	that is distinct from the current-buffer at the time of
	#'looking-at, something usually suggestive of a bug but actually
	OK in this context.

2022-11-04  Aidan Kehoe  <kehoea@parhasard.net>

	* fill.el (fill-region-as-paragraph):
	* simple.el (do-auto-fill):
	If fill-column is most-positive-fixnum, (1+ fill-column) can be
	negative on non-bignum builds. Avoid passing this negative number
	to #'move-to-column when filling.

2022-08-31  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el (set-auto-mode):
	Use #'file-system-ignore-case-p now it is available. Remove a
	comment from 2000 basically regretting that it was not available.
	Switch to #'string-match-p throughout this function in passing,
	reducing match data conflicts.

2022-08-31  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el (file-relative-name): 
	Correct a bug introduced into this function by the last commit,
	the length of the filename examined by #'mismatch should be at
	most two.
	Compare using #'equalp in passing for case-insensitivity,
	appropriate for drive letters under Windows.

2022-08-29  Aidan Kehoe  <kehoea@parhasard.net>

	Deprecate #'string-equal, #'string-equal-ignore-case, encourage
	use of #'equal, #'equalp instead, with or without the caller's own
	type checking. Some small other changes in passing.

	* build-report.el (build-report-make-output-get):
	Revise this slightly, (eql (length build-report-make-output-dir)
	0) is equivalent to checking it against "" and nil.	

	* byte-optimize.el:
	* byte-optimize.el (byte-compile-side-effect-free-ops):
	Remove the optimizers from #'string=, #'string-equal, now they are
	marked as GNU Emacs compatible and deprecated for other uses.

	* bytecomp.el:
	* bytecomp.el (152): Keep the byte-defop of byte-string= for the
	sake of the disassembler.
	Comment out the corresponding byte-defop-compiler statements.

	* cmdloop.el (yes-or-no-p-minibuf):
	Use #'canoncase rather than #'downcase, as is more correct for
	this use case.

	* dragdrop.el (experimental-dragdrop-drop-mime-default):
	Switch from string= to equal in this function, as is done
	elsewhere in this changeset.
	* dragdrop.el (dragdrop-is-some-url):
	Revise the checking that we correspond to some METHOD to avoid
	#'string-equal and to use a CL function that doesn't allocate
	dynamic memory.
	* find-paths.el:
	* find-paths.el (paths-decode-directory-path):
	Be a bit more sensible in this function, use #'mapcan instead of
	(delete "" (mapcar ...)), switch to #'equal instead of
	#'string-equal.

	* files.el (kill-some-buffers):
	Make this a bit more idiomatic, use #'dolist, avoid #'string-equal.

	* obsolete.el:
	* obsolete.el (string-equal): New.
	* obsolete.el (string-equal-ignore-case): New.
	Move the implementation of these functions here from fns.c.
	* obsolete.el (canonicalize-string-equal-argument): New. Used by
	the implementation of the above.

	* replace.el (perform-replace):
	Switch to #'canoncase from #'downcase in this function, which is
	more appropriate for this use case.

	* shadow.el (find-emacs-lisp-shadows):
	Use #'file-name-sans-extension instead of re-implementing it.

	* subr.el (string-equal-ignore-case): Removed.
	* subr.el ('string=): Removed.
	Move these to obsolete.el

	* x-font-menu.el:
	* x-font-menu.el (x-font-menu-load-font-core):
	Make this a bit more idiomatic, #'return-from the function rather
	than using #'catch, 

	* x-init.el (x-initialize-keyboard):
	Use #'string-match-p in this function given the match data are not
	used.
	
	* abbrev.el (define-abbrev):
	* autoload.el (generate-autoload-type-section):
	* autoload.el (update-file-autoloads):
	* autoload.el (update-autoload-files):
	* cus-edit.el (customize-set-value):
	* cus-edit.el (customize-set-variable):
	* cus-edit.el (customize-save-variable):
	* cus-edit.el (customize):
	* cus-edit.el (customize-other-window):
	* cus-edit.el (custom-browse-insert-prefix):
	* cus-file.el:
	* cus-file.el (make-custom-file-name):
	* etags.el (visit-tags-table):
	* etags.el (complete-symbol):
	* etags.el (display-tag-info):
	* files.el (create-file-buffer):
	* files.el (find-buffer-visiting):
	* files.el (find-file-noselect):
	* files.el (set-visited-file-name):
	* files.el (write-file):
	* files.el (file-relative-name):
	* files.el (delete-auto-save-file-if-necessary):
	* files.el (file-newest-backup):
	* files.el (rename-uniquely):
	* files.el (rename-auto-save-file):
	* fill.el (maybe-adapt-fill-prefix):
	* fill.el (fill-region-as-paragraph):
	* fill.el (justify-current-line):
	* fill.el (unjustify-current-line):
	* font-menu.el (font-menu-family-constructor):
	* font-menu.el (font-menu-weight-constructor):
	* font.el (font-spatial-to-canonical):
	* font.el (x-font-create-object):
	* gtk-faces.el (gtk-convert-font-slant-from-xlfd):
	* gtk-faces.el (gtk-convert-font-size-from-xlfd):
	* gtk-ffi.el (gtk-ffi-check-function):
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* gtk-font-menu.el (gtk-font-menu-load-font):
	* gtk-marshal.el (define-marshaller):
	* hyper-apropos.el (hyper-apropos):
	* indent.el (beginning-of-line-text):
	* info.el (Info-find-file-node):
	* info.el (Info-follow-reference):
	* info.el (Info-menu):
	* isearch-mode.el (isearch-update-ring):
	* ldap.el (ldap-decode-boolean):
	* lisp.el (lisp-complete-symbol):
	* list-mode.el (choose-completion-delete-max-match):
	* make-docfile.el (done):
	* minibuf.el (defun):
	* minibuf.el (minibuffer-do-completion-1):
	* minibuf.el (minibuffer-do-completion):
	* minibuf.el (completing-read):
	* minibuf.el (exit-minibuffer):
	* minibuf.el (read-file-name-internal):
	* minibuf.el (append-expand-filename):
	* msw-font-menu.el (mswindows-font-menu-load-font):
	* mule/ethio-util.el (ethio-tilde-escape):
	* mule/ethio-util.el (ethio-flag-to-language):
	* mule/ethio-util.el (i):
	* mule/korea-util.el (quail-hangul-switch-symbol-ksc):
	* mule/mule-cmds.el (activate-input-method):
	* mule/mule-cmds.el (inactivate-input-method):
	* mule/mule-cmds.el (describe-language-environment):
	* newcomment.el (comment-normalize-vars):
	* newcomment.el (comment-quote-nested):
	* newcomment.el (comment-padright):
	* newcomment.el (comment-padleft):
	* newcomment.el (comment-region-internal):
	* newcomment.el (comment-region):
	* newcomment.el (comment-dwim):
	* newcomment.el (comment-auto-fill-only-comments):
	* occur.el (multi-occur):
	* package-admin.el (package-admin-find-top-directory):
	* package-get.el (package-get-interactive-package-query):
	* package-get.el (package-get):
	* package-get.el (package-get-info-version):
	* package-get.el (package-get-info-prop):
	* packages.el (packages-split-path):
	* regexp-opt.el (regexp-opt-charset):
	* regexp-opt.el (regexp-opt):
	* simple.el:
	* simple.el (delete-indentation):
	* simple.el (interprogram-paste-function):
	* startup.el (command-line-early):
	* startup.el (load-user-init-file):
	* startup.el (command-line-1):
	* startup.el (splash-screen-window-body):
	* subr.el (insert-face):
	* view-less.el (view-search-forward):
	* view-less.el (view-search-backward):
	* wid-edit.el (widget-prompt-spaceify):
	* wid-edit.el (widget-checklist-prompt-value):
	* wid-edit.el (widget-file-complete):
	* wid-edit.el (widget-color-complete):
	* x-faces.el (x-color-list-internal):
	* x-font-menu.el (x-reset-device-font-menus-core):
	Mechanically change from #'string-equal to #'equal in these files.
	
2022-08-19  Aidan Kehoe  <kehoea@parhasard.net>

	* isearch-mode.el (isearch-fix-case):
	* isearch-mode.el (isearch-complete1):
	Small changes to modernize this code; call #'string-match-p
	instead of wrapping #'string-match with #'save-match-data, no need
	to cons up an alist to pass to #'try-completion, the latter now
	accepts lists of strings without problems.

2022-08-02  Aidan Kehoe  <kehoea@parhasard.net>

	Abstract out the list of things to be saved and restored in
	#'isearch-push-state, using #'macrolet and #'setf.
	* isearch-mode.el:
	* isearch-mode.el (isearch-state-places): New. Symbol macro
	expanding to a list of those PLACEs to be manipulated for the
	isearch state stack.
	* isearch-mode.el (isearch-setf-state-places): New. Macro using
	isearch-state-places, for use in isearch-top-state.
	* isearch-mode.el (isearch-make-state-object): New. Macro using
	isearch-state-places, for use in isearch-push-state.

	* isearch-mode.el (isearch-top-state): Move within the
	#'macrolet. Use #'isearch-setf-state-places.
	* isearch-mode.el (isearch-pop-state): Move within the #'macrolet.
	* isearch-mode.el (isearch-push-state): Move within the #'macrolet.

2022-08-04  Jaakko Salomaa  <jaakko.salomaa@iki.fi>

	* setup-paths.el (paths-emacs-root-p):
	* setup-paths.el (paths-find-emacs-roots):
	* setup-paths.el (paths-find-site-lisp-directory):
	* setup-paths.el (paths-find-site-module-directory):
	* setup-paths.el (paths-find-lisp-directory):
	* setup-paths.el (paths-find-mule-lisp-directory):
	* setup-paths.el (paths-find-module-directory):
	* setup-paths.el (paths-construct-info-path):
	* setup-paths.el (paths-find-doc-directory):
	* setup-paths.el (paths-find-exec-directory):
	* setup-paths.el (paths-find-data-directory):
	* setup-paths.el (paths-construct-data-directory-list):
	Make all of these functions respect the -no-configured-paths command
	line flag and disregard the configured and built in paths.

	* startup.el (command-line-do-help):
	Document -no-configured-paths in the command line help text.

2022-08-03  Jaakko Salomaa  <jaakko.salomaa@iki.fi>

	* startup.el (startup-setup-paths):
	Clean up the path debugging code by replacing all clunky
	([if/when] debug-paths (princ (format "...))) invocations with code
	from...

	* startup.el (startup-setup-paths-debug-vars):
	...this new macro that prints variable names and values one per line
	in "variable name: variable value" format.

	The debugging output changes a little, splitting the "this-var and
	that-var\nvalue of this-var\nvalue of that-var\n" messages to easier
	to read multiple lines that all start with the name of the variable.

	* startup.el (startup-setup-paths-debug-dump-info):
	* startup.el (startup-setup-paths-missing-emacs-roots-warning):
	...and these functions that move the error and debug messaging wholly
	out of #'startup-setup-paths.

	Print a newline after the "Couldn't find an obvious default for the
	root of the XEmacs hierarchy." message.

2022-07-29  Jaakko Salomaa  <jaakko.salomaa@iki.fi>

	* mule/compiled-unicode-tables.el:
	Use #'push instead of open coding with #'setq and #'cons.

2022-07-28  Jaakko Salomaa  <jaakko.salomaa@iki.fi>

	* cl-macs.el (apply-partially):
	Fix support for &rest lambdas.

	* subr.el (apply-partially):
	Use #'list* instead of #'list and #'append.

2022-07-24  Jaakko Salomaa  <jaakko.salomaa@iki.fi>

	* mule/compiled-unicode-tables.el:
	A new mechanism for packing the used Unicode translation tables from
	etc/unicode to a compiled .elc.

	At compile time, harvest from the Lisp codebase all files that could
	possibly be used in etc/unicode, dump them with
	unicode.c:Fdump_unicode_mapping_table() and create a search table out
	of them. unicode.c:Fload_unicode_mapping_table() will then call this
	file's #'set-compiled-unicode-file-search-table to make the compiled
	data available to it.

	* unicode.el:
	* mule/latin.el:
	* mule/mule-charset.el:
	The mapping files under etc/unicode/unicode-consortium/ISO8859 were
	renamed to make their filenames unambiguous for the Unicode table
	compiler. Change these files to reflect that.

2022-07-25  Aidan Kehoe  <kehoea@parhasard.net>

	* wid-edit.el (widget-sublist): Removed. Equivalent to #'subseq,
	but less general.
	* wid-edit.el (widget-remove-if): Removed.
	Usually equivalent to #'remove-if, always equivalent to (delete-if
	PREDICATE (copy-sequence LIST)), not used in the XEmacs packages,
	no indication to keep it.
	* wid-edit.el (widget-item-match-inline): Adjust this not to use
	widget-sublist, and to cons a little less.	

2022-07-23  Aidan Kehoe  <kehoea@parhasard.net>

	* pcase.el (pcase--u1):
	Suppress a warning about an unused variable bound by
	#'destructuring-bind, by not binding it and modifying EXPR
	appropriately.

2022-07-23  Aidan Kehoe  <kehoea@parhasard.net>

	* pcase.el: New. Imported from GNU, a version before the
	introduction of lexical binding there.
	The reasoning to put it here rather than xemacs-base is that it is
	completely routine for the GNU Emacs core code to use these
	macros, and as we synch our core files going forward we will need
	to have it available.
	The following relevant ChangeLog entries are taken from GNU's
	ChangeLog.15:

    2011-02-28  Juanma Barranquero  <lekktu@gmail.com>

	* emacs-lisp/pcase.el (pcase, pcase--u1, pcase--q1):
	Fix typos in docstrings.

    2011-02-27  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el (pcase--if): Try to invert test to reduce depth.
	(pcase-mutually-exclusive-predicates): New var.
	(pcase--split-consp, pcase--split-pred): Use it.
	(pcase--split-equal, pcase--split-member): When splitting against
	a pure predicate, run it to know the outcome.
	(pcase--u1): Mark vars that are actually used.
	(pcase--q1): Avoid introducing unused vars.

    2011-02-18  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el (pcase--u1): Understand non-linear patterns.

    2010-11-24  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el: Improve pcase-let.  Use "pcase--" prefix.
	(pcase--dontcare-upats): New var.
	(pcase-let, pcase-let*): Generate better code.
	Accept the same bodies as `let'.
	(pcase-dolist): New macro.
	(pcase--trivial-upat-p): New helper function.
	(pcase--expand): Strip leading "(let nil" if any.

    2010-11-12  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el (pcase-let*, pcase-let): Add debug and
	indentation specs.

    2010-10-29  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el (pcase): New `string' and `guard' patterns.
	(pcase-if): Add one minor optimization.
	(pcase-split-equal): Rename from pcase-split-eq.
	(pcase-split-member): Rename from pcase-split-memq.
	(pcase-u1): Add strings to the member optimization.
	Add `guard' variant of predicates.
	(pcase-q1): Add string patterns.

    2010-09-26  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el (pcase-let*, pcase-let): plet -> pcase-let.

    2010-09-01  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el (pcase-split-memq):
	Fix overenthusiastic optimization.
	(pcase-u1): Handle the case of a lambda pred.

    2010-08-10  Stefan Monnier  <monnier@iro.umontreal.ca>

	* emacs-lisp/pcase.el: New file.

2022-07-20  Jaakko Salomaa  <jaakko.salomaa@iki.fi>

	* subr.el (apply-partially):
	For a &rest argumented lambda, construct one in return in
	#'apply-partially instead of returning a lambda with an empty argument
	list and make it append together the pre-applied and provided &rest
	arg lists.

2022-07-18  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-optimize-zerop):
	#'numberp has a byte code, and so it's fine to transform (zerop
	OBJECT) into (if (numberp OBJECT) (= OBJECT 0)
	(signal 'wrong-type-argument 'number OBJECT).
	This avoids correctness problems introducted by the
	byte-compile-delete-errors option, revealed in
	tests/automated/lisp-tests.el.

2022-07-11  Aidan Kehoe  <kehoea@parhasard.net>

	* update-elc.el (do-autoload-commands):
	If we just need to rebuild the module autoloads, load autoload.el,
	something that wasn't done before.
	* update-elc.el (preloaded-file-list):
	full-arg-dir was not used, remove it, thank you the byte compiler.

2022-07-09  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (format):
	Update the documentation of the integer length modifiers, now that
	?z has been added.

2022-06-30  Aidan Kehoe  <kehoea@parhasard.net>

	* finder.el (finder-compile-keywords):
	Correct a thinko in c6966a009d0d , insert a coding cookie that
	reflects buffer-file-coding-system.

2022-06-30  Aidan Kehoe  <kehoea@parhasard.net>

	* update-elc.el (source-modules): New.
	Document where the C source is for modules, which differs from
	module-directory when --srcdir is specified. This is relevant when
	deciding whether to build auto-autoloads.el for modules.
	* update-elc.el (preloaded-file-list):
	Use this when examining for outdatedness of auto-autoloads.el.
	* update-elc.el (do-autoload-commands):
	Correct the code to build the modules' auto-autoload.el, which
	cannot just use batch-update-directory-autoloads, since that
	doesn't recurse.  Thank you Stephen Turnbull, Mats Lidell, and the
	Gentoo users.
	* update-elc-2.el (batch-update-elc-2):
	Don't wrap errors loading the auto-autoloads for the modules, if
	that fails, whatever caused it to fail should be fixed.

2022-06-27  Stephen J. Turnbull  <turnbull@sk.tsukuba.ac.jp>

	* update-elc-2.el (batch-update-elc-2):
	Trap missing file errors for autoloads in modules.  Currently
	there are none, and the build process apparently doesn't produce
	an empty file in this case.

2022-06-27  Aidan Kehoe  <kehoea@parhasard.net>

	* finder.el (finder-compile-keywords):
	Don't use the save-buffer infrastructure when generating
	finder-inf.el, since that leads to lock files, making parallel
	builds less likely to work. Thank you Mats Lidell and the Gentoo
	users!

2022-06-23  Aidan Kehoe  <kehoea@parhasard.net>

	* x-faces.el (:compile-toplevel):
	Only (require 'fontconfig) at compile time, meaning that file is
	not dumped on non-Xft builds.

2022-06-17  Aidan Kehoe  <kehoea@parhasard.net>

	* code-process.el:
	* code-process.el (:compile-toplevel):
	Silence compiler warnings about variables provided by starttls.el,
	functions provided by format-spec.el.
	* code-process.el (network-stream-open-starttls):
	Fix a bug in this function, thank you the byte compiler
	(#'make-network-process is not available on XEmacs, use
	#'open-network-stream-internal instead.)
	* x-faces.el (fontconfig):
	Silence byte compile warnings, just (require 'fontconfig)
	unconditionally, which works even if fontconfig support is not
	compiled in.

2022-06-16  Aidan Kehoe  <kehoea@parhasard.net>

	* update-elc-2.el (batch-update-elc-2):
	Remove the code to update auto-autoloads from this file.
	(It was buggy (e.g. it updated mule/auto-autoloads.el and then
	immediately compiled auto-autoloads.el) and caused dependency
	problems.)
	Load the module auto-autoloads when byte-compiling,
	which we didn't previously.
	* update-elc.el:
	* update-elc.el (need-to-rebuild-module-autoloads): New.
	* update-elc.el (need-to-recompile-module-autoloads): New.
	* update-elc.el (module-directory): Make this available when
	updating module auto-autoloads.
	* update-elc.el (aa-modules): New.
	* update-elc.el (aac-modules): New.
	The path to the module auto-autoloads.el, auto-autoloads.elc
	* update-elc.el
	(lisp-files-ignored-when-checking-for-autoload-updating):
	Add finder-inf.el to this list.
	* update-elc.el (or):
	Check explictly whether module/auto-autoloads.el is out of date in
	this file, which we did not do previously.
	* update-elc.el (do-autoload-commands):
	If there are no files to be byte-compiled but auto-autoloads need
	updated, do that here (using run-temacs with the byte-compiled
	files) rather than signalling to update-elc-2.el using
	../src/REBUILD_AUTOLOADS. This should avoid dependency problems
	with massively parallel builds.

2022-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	* custom.el:
	No need to #'require widget, both it and this file are dumped, and
	doing so makes the output of the dump a little more confusing.
	* dumped-lisp.el (preloaded-file-list):
	Move menubar, menubar-items, font-menu ahead of x-font-menu to
	avoid the latter forcing load of the former.
	* files.el (file-remote-p):
	Use and-boundp when checking for efs-path-regexp.
	* help.el (add-log-current-defun):
	Use and-fboundp when calling this function, provided as an
	autoload in xemacs-base.
	* mule/cyrillic.el:
	* mule/greek.el:
	Tell the byte-compiler where to find #'setup-case-pairs in these
	files.
	* mule/mule-charset.el:
	Tell the byte-compiler where to find #'init-windows-glyph-list-4
	in this file.
	* obsolete.el (define-obsolete-function-alias):
	* obsolete.el (define-compatible-function-alias):
	* obsolete.el (define-obsolete-variable-alias):
	* obsolete.el (define-compatible-variable-alias):
	Declare the WHEN argument special to avoid compiler warnings when
	using these functions.
	* unicode.el:
	Un-obsolete #'split-char, portable to GNU and very widely used
	(and not too bad of an API).

2022-03-19  Aidan Kehoe  <kehoea@parhasard.net>

	* apropos.el (apropos-documentation-check-doc-file):
	* buff-menu.el (Buffer-menu-toggle-read-only):
	* buff-menu.el (Buffer-menu-popup-menu):
	* compose.el (electric-diacritic):
	* cus-edit.el (custom-buffer-create-internal):
	* cus-edit.el (custom-variable-value-create):
	* cus-edit.el (custom-face-value-create):
	* cus-edit.el (custom-group-value-create):
	* files.el (insert-directory):
	* finder.el (finder-insert-at-column):
	* mode-motion.el (mode-motion-highlight-sexp):
	* mode-motion.el (mode-motion-add-help-echo):
	* mule/china-util.el (decode-hz-region):
	* mule/devan-util.el (indian-to-devanagari-region):
	* mule/devan-util.el (devanagari-to-indian-region):
	* mule/ethio-util.el (ethio-sera-to-fidel-english):
	* mule/ethio-util.el (ethio-sera-to-fidel-ethio):
	* mule/ethio-util.el (ethio-process-language-flag):
	* mule/ethio-util.el (ethio-tilde-escape):
	* mule/ethio-util.el (ethio-convert-digit):
	* mule/ethio-util.el (ethio-fidel-to-sera-buffer):
	* mule/ethio-util.el (ethio-modify-vowel):
	* mule/ethio-util.el (ethio-fidel-to-tex-buffer):
	* mule/ethio-util.el (ethio-tex-to-fidel-buffer):
	* mule/ethio-util.el (ethio-fidel-to-java-buffer):
	* mule/ethio-util.el (ethio-find-file):
	* mule/ethio-util.el (ethio-insert-space):
	* mule/ethio-util.el (ethio-gemination):
	* mule/japan-util.el (japanese-katakana-region):
	* mule/japan-util.el (japanese-hiragana-region):
	* mule/japan-util.el (japanese-hankaku-region):
	* mule/japan-util.el (japanese-zenkaku-region):
	* mule/kinsoku.el (kinsoku-process-shrink):
	* mule/tibet-util.el (tibetan-compose-region):
	* mule/tibet-util.el (tibetan-decompose-region):
	* mule/viet-util.el (viet-encode-viqr-region):
	* picture.el (move-to-column-force):
	* view-less.el (cleanup-backspaces):
	* wid-browse.el (widget-browse):
	* wid-edit.el (widget-after-change):
	* wid-edit.el (widget-default-format-handler):
	* wid-edit.el (widget-checklist-add-item):
	* wid-edit.el (widget-radio-add-item):
	* wid-edit.el (widget-group-value-create):
	Migrate #'following-char, #'preceding-char to #'char-after,
	#'char-before in these files.

2022-03-19  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	Document that the byte-following-char, byte-preceding-char defops
	are only kept around for the sake of the disassembler. 
	Remove the corresponding byte-defop-compiler, compile both the
	functions as normal calls, so the warning that they are obsolete
	comes through, and so there is no speed upside to calling them.

	* obsolete.el:
	* obsolete.el (following-char): New.
	* obsolete.el (preceding-char): New.  Move the implementations of
	these functions to this file from C.

2022-03-21  Aidan Kehoe  <kehoea@parhasard.net>

	* loadup.el:
	We can no longer just (store-match-data nil) to clear the extent
	information for strings known to the search code before dumping;
	pass in an extent with its SEARCH property set to DISCARD
	instead.

2022-03-06  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (byte-compile-default-warnings):
	Disable the format-not-constant warning by default, after
	discussion with Stephen Turnbull, thank you Steve.

2022-01-31  Aidan Kehoe  <kehoea@parhasard.net>

	#'check-type gives a clearer error message than
	#'check-argument-type (it lists PLACE in the error message). It is
	also better style.  Prefer it in dumped Lisp except in those
	places where startup dependencies make it not available.

	* auto-save.el (recover-all-files):
	* coding.el:
	* coding.el (unencodable-char-position):
	* coding.el (check-coding-systems-region):
	* descr-text.el (unidata-initialize-unicodedata-database):
	* descr-text.el (unidata-initialize-unihan-database):
	* dialog.el (popup-dialog-box):
	* events.el:
	* events.el (set-character-of-keysym):
	* events.el (get-character-of-keysym):
	* files.el (file-system-ignore-case-p):
	* gui.el (insert-gui-button):
	* menubar.el (find-menu-item):
	* modeline.el (add-minor-mode):
	* mule/mule-category.el (define-category):
	* mule/mule-category.el (undefine-category):
	* mule/mule-category.el (category-doc-string):
	* mule/mule-category.el (modify-category-entry):
	* mule/mule-category.el (char-category-list):
	* mule/mule-charset.el (set-charset-registry):
	* mule/mule-charset.el (charset-after):
	* mule/mule-charset.el (find-translation-table):
	* mule/mule-charset.el (define-charset-tag):
	* mule/mule-charset.el (charset-tag-to-charset-list):
	* simple.el (warning-level-<):
	* simple.el (display-warning):
	* specifier.el (let-specifier):
	* subr.el (replace-in-string):
	* unicode.el (frob-unicode-errors-region):
	* widget.el (define-widget):
	* window-xemacs.el (display-buffer):

2021-11-09  Aidan Kehoe  <kehoea@parhasard.net>

	* info.el (Info-find-file-node):
	makeinfo(1) constructs its tag table using byte positions, and
	with significant non-ASCII contents info files it is routine for
	this to get out of synch with our character positions.
	This gave difficult-to-pin-down "No such node" errors with the
	Lispref.
	Take the discrepancy between byte and character positions on board
	when deciding where to start looking for a node.
	Thank you for the investigation and bug report, Henry Thompson!
	In passing there is no need to restrict the range of the position
	passed to #'goto-char, it has always limited its movement to the
	visible portion of the buffer.

2021-10-20  Aidan Kehoe  <kehoea@parhasard.net>

	* descr-text.el (describe-char-unicodedata-file):
	Only delete a trailing newline if one is present, avoiding
	build-time problems now mule/make-digit.el has (require
	'descr-text).

2021-10-23  Aidan Kehoe  <kehoea@parhasard.net>

	* backquote.el (backquote):
	Document that the support for the old-style backquote syntax is
	obsolete and will be removed soon.

2021-10-09  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/make-digit.el:
	New. File to generate digit.el from UnicodeData.txt.
	* mule/digit.el:
	Regenerate this reflecting the same version of UnicodeData of last
	commit, last modification on unicode.org 2021-07-06 12:31, md5
	c98cbeae07758b826ef080c65b9d4d61.

2021-10-09  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/uni-case-conv.el:
	Update this file to reflect current UnicodeData.txt, last
	modification on unicode.org 2021-07-06 12:31, md5
	c98cbeae07758b826ef080c65b9d4d61.

2021-07-15  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el:
	* files.el (file-remote-p):
	If EFS is loaded, use efs-path-regexp to work out if FILE is remote.
	* minibuf.el (minibuffer-complete-and-exit):
	* minibuf.el (exit-minibuffer):
	Fix some indentation in these two functions.
	* minibuf.el (minibuffer-smart-mouse-tracker):
	Ignore ange-ftp, long deprecated.
	Trust that #'file-remote-p will recognise EFS pathnames if EFS is
	loaded.
	Use the newer #'test-completion, which always gives t for an exact
	match, rather than the older #'try-completion, where this is not
	guaranteed.
	* minibuf.el (minibuffer-smart-select-kludge-filename):
	ange-ftp is long deprecated, ignore it.
	Use the new support of #'file-remote-p for EFS, don't implement
	that ourselves.

2021-06-10  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (cl-do-prettyprint):
	Fix a bug in a regexp here, can't start a subexpression within a
	character set.

2021-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (zerop):
	Error if NUMBER is a character or a marker in this function, as
	the C code did previously.

2021-05-06  Aidan Kehoe  <kehoea@parhasard.net>

	* easymenu.el (easy-menu-add):
	* easymenu.el (easy-menu-remove):
	In the normal course of events #'easy-menu-remove is called before
	#'easy-menu-add, and so the code in the latter to save any
	existing non-default mode-popup-menu fails. Add corresponding code
	to #'easy-menu-remove too.

2021-05-11  Aidan Kehoe  <kehoea@parhasard.net>

	* gtk-marshal.el (get-marshaller-type-info): New.
	Summarize the type info (so return type and argument type) of RVAL
	and ARGS as a string.
	* gtk-marshal.el (get-marshaller-name): Implement this using
	#'get-marshaller-type-info.
	* gtk-marshal.el (define-marshaller):
	Add a newline and appropriate indentation to the C definition of
	the function.
	Push the now-defined marshal function onto defined-marshallers.
	* gtk-marshal.el:
	When creating emacs-marshal.c, instead of creating a long list of
	puthash() calls to be called the first time any function is
	imported, create a table mapping the lower 16 bits of the type
	string hash to the corresponding function, which is faster in my
	testing (with 10,000 gtk-import-function-internal calls), and has
	more predictable performance than the old approach.

2021-02-14  Aidan Kehoe  <kehoea@parhasard.net>

	* replace.el (perform-replace): Update a
	(save-match-data ... (string-match "[[:upper:]]" ...)) call to
	call `string-match-p' without the encloding `save-match-data'
	instead, now `string-match-p' is available.

2021-02-14  Aidan Kehoe  <kehoea@parhasard.net>

	Minor changes to deal with moving the match data to being extents.
	
	* cl-extra.el (cl-prettyprint):
	Call #'replace-match instead of accessing the match data after
	deleting the relevant text in this function.
	* loadup.el:
	Clear the match data before dumping, now we use string extent info
	for it and that is not dumpable.
	* replace.el (perform-replace): Use the more exhaustive
	#'match-data-canonical instead of #'match-data when saving the
	match data associated with the real match in this function.
	Don't pass the INTEGERS argument to #'match-data given its
	performance issues with large buffers.
	* subr.el (save-match-data):
	Update this to save the match data with the more exhaustive
	#'match-data-canonical, and to explicitly detach any extents in
	the saved data once done with them.
	* subr.el (match-string): Moved to C, now its algorithmic
	complexity is better there.
	* subr.el (match-string-no-properties):
	Implement in terms of #'match-string.

2021-01-28  Aidan Kehoe  <kehoea@parhasard.net>

	* code-files.el (load):
	Revise my change of 2021-01-10 looking for unwanted duplicate
	extensions to strip directory information before calling #'equal,
	something which will give us fewer false-positives.

2021-01-21  Aidan Kehoe  <kehoea@parhasard.net>

	* x-init.el (pseudo-canonicalize-keysym):
	Document why there's no need to call #'canonicalize-keysym in this
	function.

2021-01-11  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (bignump): New.
	* cl-extra.el (ratiop): New.
	* cl-extra.el (rationalp): New.
	* cl-extra.el (bigfloatp): New.
	* cl-extra.el (floatingp): New.
	* cl-extra.el (realp): New.
	Move all these from number.c.
	They are very short and mostly translate to one funcall +/- a
	couple of bytecodes, make them available with defsubst*.
	* make-docfile.el (docfile-out-of-date):
	#'integerp no longer available on bare-metal XEmacs, and it is only
	relevant if STATUS is zero; use #'fixnump instead.

2021-01-11  Aidan Kehoe  <kehoea@parhasard.net>

	Move some further simple functions to Lisp from C.
	* subr.el:
	* subr.el (integerp): New.
	* subr.el (car-safe): New.
	* subr.el (cdr-safe): New.
	* subr.el (copy-sequence): New.
	* subr.el (wrong-type-argument): New.
	All of these are from data.c.

2021-01-11  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-file-form-eval-boundary): Removed.
	* bytecomp.el (byte-compile-file-form-require): New.
	Use a more sensible name for #'require's byte hunk handler, also
	used by GNU.  Only evaluate the call to require if
	byte-compile-eval-when-seen is non-nil, allowing users to
	explicitly avoid compile time evaluation if that is needed.

2021-01-10  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-file):
	When loading TARGET-FILE, pass a non-nil NOSUFFIX argument to
	#'load, avoiding issues when FILENAME.elc.elc exists in the target
	directory.
	* code-files.el (load):
	Warn if FILENAME.elc was supplied, NOSUFFIX is nil, and
	#'locate-file returned FILENAME.elc.elc.
	Don't error, this is rare and there may be compatibility issues if
	we do that.

2020-12-28  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (delete-backward-char):
	Both COUNT and KILLP are optional in this function, declare them
	as such.

2020-11-24  Aidan Kehoe  <kehoea@parhasard.net>

	* device.el (get-device): New.
	Moved here from device.c, no need for it to be in C.
	* simple.el (delete-backward-char): New.
	Moved here from cmds.c, no need for it to be in C.

2020-11-17  Aidan Kehoe  <kehoea@parhasard.net>

	* events.el (keyboard-translate):
	Use `canonicalize-keysym' here, just introduced, so the keyboard
	translate processing is more reliable.

2020-11-17  Aidan Kehoe  <kehoea@parhasard.net>

	* events.el (keyboard-translate):
	* events.el (set-character-of-keysym):

2020-11-03  Aidan Kehoe  <kehoea@parhasard.net>

	* minibuf.el (read-coding-system):
	Correct the spelling in the docstring here.
	* subr.el (format):
	CONTROL-STRING isn't optional in #'format, correct the arglist
	here.

2020-09-01  Aidan Kehoe  <kehoea@parhasard.net>

	Some style, efficiency changes to wid-edit.el.

	* wid-edit.el:
	* wid-edit.el (widget-shadow-subrs): Removed.
	No longer necessary.
	* wid-edit.el (widget-princ-to-string):
	Remove the commented old implementation.
	* wid-edit.el (widget-member):
	Use #'plist-get rather than #'widget-plist-member (which
	ultimately calls #'plist-get).
	No need for a final clause that returns nil, that's what #'cond
	does by default.
	* wid-edit.el (widget-default-menu-tag-get):
	Call #'prin1-to-string rather than #'widget-princ-to-string, which
	calls #'prin1-to-string anyway.	

2020-08-25  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp-runtime.el (eval-when-feature): Removed.
	This never worked (the after-load-alist entry syntax was
	incorrect), it is not used in packages and GNU have removed it. No
	indication to continue with it in XEmacs.

2020-03-25  Aidan Kehoe  <kehoea@parhasard.net>

	* code-cmds.el (universal-coding-system-argument):
	Use the DEFAULT argument to #'read-coding-system, trust it to
	rewrite the prompt rather than doing it ourselves.
	* code-files.el (set-buffer-file-coding-system):
	Call #'read-coding-system expicitly, take a default from
	coding-system-history.
	* code-files.el (set-buffer-file-coding-system-for-read):
	Call #'check-coding-system rather than #'get-coding-system, which
	is clearer for what we want.
	* code-files.el (insert-file-contents):
	Ditto.
	* code-process.el:
	* code-process.el (set-buffer-process-coding-system):
	Explicitly call #'read-coding-system in the (interactive) spec
	here, so we can pass in the existing default-process-coding-system
	as a DEFAULT argument.
	* coding.el (set-keyboard-coding-system):
	Explicitly call #'read-coding-system in the (interactive) spec
	here, displaying keyboard-coding-system as the default.
	* coding.el (set-terminal-coding-system):
	Explicitly call #'read-coding-system in the (interactive) spec
	here, displaying terminal-coding-system as the default.
	* minibuf.el (coding-system-history): New.
	* minibuf.el (read-file-name):
	Backslash some parentheses in the first column for the sake of
	fontification. 
	* minibuf.el (read-directory-name):
	Ditto.
	* minibuf.el (read-coding-system):
	Revise this to use coding-system-history, to adjust PROMPT
	depending on DEFAULT-CODING-SYSTEM, to ignore case (as does GNU).
	* minibuf.el (read-non-nil-coding-system):
	Revise this to use coding-system-history and to ignore case.

2020-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (kill-line-1): Implement this with #'macrolet rather
	than keeping around a function in the dumped Lisp.
	* simple.el (kill-entire-line): Use the macro.
	* simple.el (kill-line): Use the macro.
	* simple.el (backward-kill-line): Use the macro. This function
	differs from the other two in that it previously did not use
	#'kill-line-1.

2020-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (digit-argument):
	Use #'digit-char-p in this function rather than re-implementing
	it.

2020-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el:
	#'prefix-numeric-value is a pure function, optimise it as such.

2020-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (with-trapping-errors):
	If RESIGNAL is non-nil and ERROR-FORM is nil, don't wrap the
	#'call-with-condition-handler with #'condition-case.
	If ERROR-FORM is nil and RESIGNAL is nil, use `block' to return
	control to the caller.

2020-03-20  Aidan Kehoe  <kehoea@parhasard.net>

	Further reduce potential match data corruption bugs by avoiding
	#'string-match when the match data isn't used, mostly using
	#'string-match-p instead but sometimes the CL sequence functions
	for particularly trivial regexps.

	* finder.el:
	* finder.el (finder-select):
	* font-lock.el (font-lock-set-defaults-1):
	As well as the above, use a label instead of binding a symbol's
	value to a lambda and then funcalling that.
	* newcomment.el (comment-indent-new-line):
	Use #'search instead of #'string-match for a trivial regexp.
	* package-admin.el (package-admin-get-install-dir):
	Ditto.
	* register.el (describe-register-1):
	* startup.el (load-terminal-library):
	* startup.el (find-init-file-1):
	* startup.el (command-line-1):
	Use #'string-match-p in these four functions.
	* startup.el (splash-screen-window-body):
	Use #'search instead of #'string-match for a trivial regexp.
	* syntax.el (syntax-string-to-code):
	* test-harness.el (test-harness-from-buffer):
	* test-harness.el (batch-test-emacs):
	* update-elc-2.el (do-update-elc-2):
	* update-elc.el:
	* update-elc.el (update-elc-chop-extension):
	* version.el (emacs-version):
	* wid-browse.el (widget-browse-sexp):
	* wid-edit.el (widget-field-use-before-change):
	Searching `emacs-version' for the string XEmacs is not the way to
	check whether this emacs is XEmacs, use featurep instead.
	* wid-edit.el (widget-field-validate):
	* wid-edit.el (widget-field-value-create):
	* window-xemacs.el (display-buffer):
	* x-scrollbar.el (x-init-scrollbar-from-resources):
	Use #'string-match-p for the last four.

2019-10-18  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (with-trapping-errors):
	Revise this to use the Common Lisp keyword parsing
	infrastructure, which will accept :allow-other-keys t and explicitly
	have the trailing keyword override.
	Declare its indentation using (declare (indent ...)) rather than
	using #'put.

2020-01-24  Aidan Kehoe  <kehoea@parhasard.net>

	* wid-edit.el (widget-parsing-escapes): New.
	Macro to do most of the work of parsing %-escapes in widget format
	strings, refactored out.
	* wid-edit.el (widget-value-convert-widget):
	Use it. 
	Adjust the order of frequency of the value escape in passing, that
	is much more common in the customize code than in the about-xemacs
	code which I had been testing on.
	* wid-edit.el (widget-checklist-add-item, widget-radio-add-item):
	Use `widget-parsing-escapes' in these functions.

2020-01-22  Aidan Kehoe  <kehoea@parhasard.net>

	* wid-edit.el (widget-default-create):
	* wid-edit.el (widget-checklist-add-item):
	* wid-edit.el (widget-radio-add-item):
	* wid-edit.el (widget-editable-list-entry-create):
	Move away from code using #'re-search-forward to parse format
	strings within all these functions, use #'position instead.

	In #'widget-default-create, use the more reasonable and readable
	(case escape ...) rather than funcalling an uncompiled lambda
	which is in a vector indexed according to a string offset, which
	offset is produced using #'string-match.

2019-04-22  Aidan Kehoe  <kehoea@parhasard.net>

	* process.el (setenv):
	Sync the API of this function with GNU.
	Remove UNSET as an argument, giving nil for VALUE always has been
	equivalent.
	Add SUBSTITUTE-ENV-VARS in its stead, 
	Check that VARIABLE, VALUE can be encoded in the coding system of
	the system, error if they can't.	

2019-04-14  Aidan Kehoe  <kehoea@parhasard.net>

	* misc.el:
	* misc.el (make-weak-box):
	* misc.el (weak-box-ref):
	* misc.el (:load-toplevel):
	Remove #'weak-box-ref-1 from the dumped Lisp binary, using
	(eval-when (:load-toplevel) ...) to ensure a reasonable docstring.

2019-03-28  Aidan Kehoe  <kehoea@parhasard.net>

	* x-init.el (pseudo-canonicalize-keysym):
	* x-init.el (x-keysym-on-keyboard-sans-modifiers-p):
	* x-init.el (x-keysym-on-keyboard-p):
	Accept characters as keysyms in these functions, as well as
	strings and symbols. This is needed since changeset a69c6e871607
	of 2017-12-20, which applied to the C code.

2019-03-21  Jerry James  <james@xemacs.org>

	* startup.el (startup-setup-paths): Silence startup warnings due to
	mismatched format strings and arguments.  Patch thanks to Tim
	Landscheidt <tim@tim-landscheidt.de>.

2019-03-21  Aidan Kehoe  <kehoea@parhasard.net>

	Move several more functions, not loop hotspots and easily
	implemented in Lisp, from C to Lisp.

	* abbrev.el:
	* abbrev.el (insert-abbrev-table-description): New.
	Move this back to Lisp, now there's a penalty for it being in C
	with NEWGC.
	Remove comment with old Lisp implementation.

	* cmdloop.el:
	* cmdloop.el (prefix-numeric-value): New.
	Move this here from callint.c.
	* loadup.el:
	* loadup.el (really-early-error-handler):
	Use #'format-into rather than (princ (format ...)), now #'format
	is not available on a bare-metal XEmacs.
	* setup-paths.el (paths-default-info-directories):
	Use (string directory-sep-char) rather than (char-to-string
	directory-sep-char), now the latter is not available on a
	bare-metal XEmacs.
	* simple.el:
	* simple.el (backward-char): New.
	* simple.el (beginning-of-line): New.
	* simple.el (end-of-line): New.
	Move these three from cmds.c.
	* subr.el:
	* subr.el (format): New.
	Move this from doprnt.c
	* subr.el (arrayp): New.
	* subr.el (sequencep): New.
	* subr.el (natnump): New.
	* subr.el (nonnegativep): New.
	Move all these from data.c
	* subr.el (identity):
	Give this a better argument name and docstring.
	* subr.el (char-to-string): New.
	* subr.el (string-to-char): New.
	* subr.el (char-equal): New.
	Move these three from editfns.c.
	* x-misc.el:
	* x-misc.el (default-x-device): New.
	Move this from device-x.c.

2019-03-27  Aidan Kehoe  <kehoea@parhasard.net>

	* minibuf.el (read-file-name-internal-1):
	Revise this now #'user-name-completion returns two values and
	#'user-name-completion-1 is no longer available.

2011-03-05  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (byte-compile-default-warnings):
	* bytecomp.el (byte-compiler-legal-options):
	* bytecomp.el (byte-compile-format): New.
	* bytecomp.el (byte-compile-message): New.
	Introduce `byte-compile-format', which warns if CONTROL-STRING is
	not constant, something that is reasonably often a security
	issue. Suppress this warning for calls to #'gettext, or
	if-statements both branches of which are constant strings.

2018-10-07  Aidan Kehoe  <kehoea@parhasard.net>

	* font-lock.el (font-lock-fontify-syntactically-region):
	Careful here, font-lock-cache-position can be a marker that
	doesn't point anywhere; thanks for the bug report, Michael
	Sperber!

2018-10-01  Aidan Kehoe  <kehoea@parhasard.net>

	* code-files.el (insert-file-contents):
	* cus-edit.el (custom-redraw):
	* font-lock.el (font-lock-fontify-syntactically-region):
	* help.el (Help-princ-face):
	* help.el (Help-prin1-face):
	* help.el (help-symbol-regexp):
	* indent.el (increase-left-margin):
	* indent.el (decrease-left-margin):
	* info.el (Info-find-file-node):
	* info.el (Info-cease-edit):
	* mouse.el (default-mouse-track-deal-with-down-event):
	* select.el (select-convert-to-lineno):
	* select.el (select-convert-to-sourceloc):
	* simple.el (kill-region):
	* simple.el (pop-global-mark):
	* simple.el (signal-error-on-buffer-boundary):
	* wid-edit.el (widget-setup):
	* window-xemacs.el (restore-saved-window-parameters):
	Don't call #'marker-position in the core Lisp code, as we have
	just advised in its docstring.

2018-09-28  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-optimize-car):
	* byte-optimize.el (byte-optimize-cdr):
	Leave erroring on zero arguments and returning nil on nil
	arguments to #'byte-optimize-predicate within these functions.

2018-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* alist.el: Remove this.
	It's indifferent to poor code, nothing uses it in core, and the
	file is in APEL already.

2018-09-05  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-const-expr-p):
	Recognise that keywords are constant symbols within this
	function.
	* byte-optimize.el:
	* byte-optimize.el (byte-compile-trueconstp): Removed.
	* byte-optimize.el (byte-optimize-car):
	* byte-optimize.el (byte-optimize-cdr):
	* byte-optimize.el (byte-optimize-or):
	* byte-optimize.el (byte-optimize-if):
	* byte-optimize.el (byte-optimize-letX):
	Use `byte-compile-constp' instead in the places this macro was
	used, which recognises that keywords are constant symbols too, and
	so reduces the number of places this bug can happen.

2018-09-02  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el:
	* byte-optimize.el (:execute):
	* bytecomp.el (:execute):
	* cl-extra.el:
	* cl-extra.el (:execute):
	* cl-extra.el (streamp):
	* cl-macs.el:
	* cus-face.el:
	* cus-face.el (:compile-toplevel):
	* easy-mmode.el:
	* help.el:
	* help.el (:execute):
	* info.el (:compile-toplevel):
	* info.el (unless):
	* regexp-opt.el (regexp-opt-group):
	* syntax-ppss.el (font-lock-beginning-of-syntax-function):
	* syntax-ppss.el (syntax-ppss-depth):
	* wid-browse.el:
	* wid-browse.el (widget-browse):
	* x-init.el (:compile-toplevel):
	Now #'eval-when is in bytecomp-runtime, use it in those places
	where it is clearer than #'eval-when-compile.
	Many of the places #'eval-when-compile were used were actually
	unnecessary; remove them.
	* bytecomp-runtime.el (eval-when):
	Document #'eval-when in a little more detail.

2018-09-02  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-initial-macro-environment):
	Correct a comment here, there's no bug in defstruct or defsetf.

2018-09-02  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp-runtime.el:
	* bytecomp-runtime.el (eval-when): Move the runtime part of this
	here from cl-macs.el.
	* bytecomp.el:
	* bytecomp.el (byte-compile-eval):
	* bytecomp.el (byte-compile-eval-when-seen): New.
	* bytecomp.el (byte-compile-initial-macro-environment):
	Implement the bulk of #'eval-when in the compiler, where it belongs.
	* cl-macs.el:
	* cl-macs.el (cl-not-toplevel): Removed.
	* cl-macs.el (eval-when): Removed.
	* cl-macs.el (arguments): Removed.
	* cl-macs.el (cl-compile-time-too): Removed.
	* cl-macs.el (define-setf-method):
	* cl-macs.el (defstruct):
	* cl-macs.el (deftype):
	* cl-macs.el (define-compiler-macro):
	* cl.el (declaim):
	Use the ANSI CL syntax for the stages in WHEN with #'eval-when.
	No need to worry about delaying loading cl-macs.el when using that
	syntax.
	* cl.el (cl-random-time):
	* ldap.el (:load-toplevel):
	Correct the syntax of this #'eval-when call.

2018-08-25  Aidan Kehoe  <kehoea@parhasard.net>

	* autoload.el (generate-file-autoloads):
	* autoload.el (generate-custom-defines):
	* autoload.el (generate-custom-defines-1):
	* bytecomp.el:
	* bytecomp.el (byte-compile-dest-file): New.
	* bytecomp.el (byte-compile-inline-expand):
	* disass.el (disassemble-1):
	* files.el:
	* files.el (parse-colon-path):
	* files.el (set-auto-mode):
	* files.el (hack-local-variables):
	* files.el (hack-local-variables-last-page):
	* files.el (hack-local-variables-prop-line):
	* files.el (file-relative-name):
	* files.el (revert-buffer):
	* files.el (recover-session):
	* files.el (file-expand-wildcards):
	* files.el (shell-quote-wildcard-pattern):
	* files.el (insert-directory):
	* files.el (insert-directory-adj-pos):
	* find-paths.el (paths-find-recursive-path):
	* font-lock.el (font-lock-lisp-like):
	* font-lock.el (font-lock-match-java-declarations):
	* font-mgr.el:
	* font-mgr.el (xlfd-font-name-p):
	* gutter-items.el (buffers-tab-omit-some-buffers):
	* gutter-items.el (select-buffers-tab-buffers-by-mode):
	Call #'string-match, #'looking-at much less often, preferring
	#'string-match-p and #'looking-at-p instead for fewer side-effects.
	* cus-edit.el:
	* cus-edit.el (customize-version-lessp):
	Use the much cheaper #'parse-integer instead of #'read here.
	* files.el (convert-standard-filename):
	Redefine this to act as identity on non-windows-nt systems.

2018-08-14  Aidan Kehoe  <kehoea@parhasard.net>

	* misc.el (make-weak-box):
	Make this code work when run interpreted too, not that it will come
	up much.

2018-08-13  Aidan Kehoe  <kehoea@parhasard.net>

	* misc.el (make-weak-box):
	Have distinct weak boxes print distinctly; remove information on
	the type of the one-time contents from the weak box, it doesn't
	add anything and will be inaccurate once the contents are nil.

2018-08-12  Aidan Kehoe  <kehoea@parhasard.net>

	* misc.el:
	* misc.el (weak-box-p):
	* misc.el (make-weak-box):
	* misc.el (weak-box-ref):
	Improve the implementation here; make #'weak-box-ref free in terms
	of garbage, make weak boxes that reference distinct objects print
	distinctly, give information as to the type of CONTENTS stored.
	Document some more on the performance and debugging implications
	of the Lisp implementation.

2018-08-12  Aidan Kehoe  <kehoea@parhasard.net>

	* misc.el:
	* misc.el (weak-box-p): New.
	* misc.el (make-weak-box): New.
	* misc.el (weak-box-ref): New.
	Move all these functions here from data.c.

2018-07-17  Aidan Kehoe  <kehoea@parhasard.net>

	* backquote.el (bq-process):
	* backquote.el (bq-process-2):
	* backquote.el (bq-comma):
	* backquote.el (bq-process-1):
	Style improvements in this file:
	1. Give structured errors on encountering invalid syntax.
	2. Call member* when interpreted, which #'memq was doing anyway,
	and which will translate to the memq bytecode in the old way when
	compiled.
	3. Indent if statements as Emacs Lisp, not Common Lisp.

2018-07-17  Aidan Kehoe  <kehoea@parhasard.net>

	* backquote.el (bq-process-2):
	Be better about handling vectors here; pass through constants,
	call #'vector, #'vconcat directly at runtime if appropriate. Call
	#'atom (which translates to bytecode) rather than #'vectorp first
	within this function.
	New #'bq-process-2 flag, vector*, which means "call apply
	#'vector in the old way"
	* backquote.el (bq-comma):
	Don't check for numberp here, leave that to #'bq-process-1.
	* backquote.el (bq-process-1):
	Implement vector*.  Call #'quote-maybe when appropriate, giving
	more readable output.

2018-07-05  Aidan Kehoe  <kehoea@parhasard.net>

	Silence an extensive list of byte compile warnings, chiefly
	through use of #'globally-declare-fboundp and
	#'globally-declare-boundp.

	Also prefer (default-device 'x) to (default-x-device), since the
	former always exists when byte compiling.

	* autoload.el:
	* autoload.el (make-autoload):
	* autoload.el (autoload-make-autoload-operators): New.
	* autoload.el (autoload-make-autoload-complex-operators): New.
	Be a bit better about silencing byte compile warnings regarding
	autoload-make-autoload-operators here

	* behavior.el:
	* behavior.el (unless):
	* buff-menu.el:
	* buff-menu.el (unless):
	* cmdloop.el:
	* cmdloop.el (unless):
	* cmdloop.el (yes-or-no-p):
	* cmdloop.el (y-or-n-p):
	* cus-edit.el:
	* cus-edit.el (unless):
	* custom.el (custom-theme-reset-internal-face):
	* custom.el (custom-define-hook):
	* dialog-items.el:
	* dialog-items.el (unless):
	* dialog.el:
	* easymenu.el:
	* easymenu.el (unless):
	* font-menu.el:
	* font-menu.el (unless):
	* font.el:
	* font.el (fontconfig):
	* font.el (font-xft-font-regexp):
	* font.el (font-xft-font-regexp)): New.
	* font.el (x-font-build-cache):
	* font.el (xft-font-create-object):
	* fontconfig.el (fc-try-font):
	* fontconfig.el (fc-find-available-font-families):
	* fontconfig.el (fc-find-available-weights-for-family):
	* gnuserv.el:
	* gnuserv.el (unless):
	* gtk-faces.el:
	* gtk-faces.el (unless):
	* gtk-faces.el (gtk-convert-font-from-xlfd):
	* help.el:
	* help.el (unless):
	* help.el (help):
	* hyper-apropos.el:
	* hyper-apropos.el (unless):
	* info.el:
	* info.el (unless):
	* lisp-mode.el:
	* lisp-mode.el (unless):
	* menubar-items.el:
	* menubar-items.el (unless):
	* menubar.el:
	* menubar.el (unless):
	* minibuf.el:
	* minibuf.el (unless):
	* minibuf.el (insert-default-directory):
	* mode-motion.el:
	* mode-motion.el (mouse):
	* modeline.el:
	* modeline.el (unless):
	* mouse.el:
	* mouse.el (unless):
	* mouse.el (shift):
	* msw-select.el:
	* msw-select.el (unless):
	* mule/mule-charset.el (do-define-charset-tags):
	* mule/mule-charset.el (script):
	* mwheel.el:
	* mwheel.el (unless):
	* occur.el:
	* occur.el (unless):
	* package-ui.el:
	* package-ui.el (unless):
	* picture.el:
	* picture.el (unless):
	* printer.el:
	* printer.el (unless):
	* scrollbar.el:
	* scrollbar.el (unless):
	* select.el:
	* select.el (unless):
	* startup.el:
	* startup.el (unless):
	* toolbar-items.el:
	* toolbar-items.el (unless):
	* toolbar.el:
	* toolbar.el (unless):
	* userlock.el:
	* userlock.el (unless):
	* userlock.el (ask-user-about-lock-minibuf):
	* wid-edit.el:
	* wid-edit.el (unless):
	* x-faces.el (x-make-font-bold-xft):
	* x-faces.el (x-make-font-unbold-xft):
	* x-faces.el (x-make-font-italic-xft):
	* x-faces.el (x-make-font-unitalic-xft):
	* x-faces.el (x-font-size-xft):
	* x-faces.el (x-find-xft-font-of-size):
	* x-font-menu.el:
	* x-font-menu.el (unless):
	* x-init.el:
	* x-init.el (unless):
	* x-mouse.el:
	* x-mouse.el (unless):
	* x-scrollbar.el:
	* x-scrollbar.el (unless):
	* x-scrollbar.el (x-init-scrollbar-from-resources):
	* x-win-sun.el:
	* x-win-sun.el (unless):
	* x-win-sun.el (x-win-init-sun):
	* x-win-xfree86.el:
	* x-win-xfree86.el (unless):

2018-07-05  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (defsubst*):
	Document that within BODY the variable names within ARGLIST may
	not have dynamic binding.
	Don't check BODY for side effects, our check is inaccurate and the
	result was used, inaccurately, within cl-defsubst-expand to decide
	whether argument names needed binding.
	* cl-macs.el (cl-defsubst-expand):
	Don't bind arguments using let if the UNSAFE argument is supplied,
	that gives byte-compile warnings that don't help anyone.

2018-07-05  Aidan Kehoe  <kehoea@parhasard.net>

	* map-ynp.el (normalize-menu-text): Add an autoload for this
	function, now it's available in Lisp when C menubar support isn't
	available. 
	* menubar.el (normalize-menu-text): Implement this function, moved
	from C.

2018-07-04  Aidan Kehoe  <kehoea@parhasard.net>

	* loadup.el (source-lisp):
	* make-docfile.el (source-lisp):
	* update-elc.el (source-lisp):
	#'nth no longer available on a bare-metal XEmacs, use its
	implementation.
	* subr.el:
	* subr.el (identity): New.
	* subr.el (nth): New.
	Move these functions here from fns.c.

2018-07-01  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-normal-call):
	When examining the :test, :key, etc arguments, be aware that a
	quoted symbol may be a data placeholder, and take that into
	account before warning.
	* cl-extra.el (cl-macroexpand-all):
	Only close around variables that are actually *used* in the
	lambda, when dealing with lambdas and lexical scope.

2018-07-01  Aidan Kehoe  <kehoea@parhasard.net>

	* easymenu.el:
	* easymenu.el (easy-menu-do-define):
	* easymenu.el (easy-menu-change):
	* easymenu.el (easy-menu-add):
	* easymenu.el (easy-menu-remove):
	* easymenu.el (easy-menu-add-item):
	* easymenu.el (easy-menu-item-present-p):
	* easymenu.el (easy-menu-remove-item):
	* lisp-mode.el (emacs-lisp-mode):
	* lisp-mode.el (lisp-interaction-mode):
	* startup.el (command-line):
	If running noninteractively (e.g. byte-compiling Lisp when
	building), don't bother to add menubar entries.

2018-07-01  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (cl-macroexpand-all):
	Use #'apply-partially to create closures with lambdas and lexical
	variables.
	* cl-macs.el (apply-partially):
	#'function-max-args can give nil, handle this OK.
	#'error doesn't take a format string, correct calls to it.
	* subr.el (apply-partially):
	Don't use a (&rest args) arglist for the constructed function if
	we've been supplied an explicit lambda. Parse the supplied arglist
	and construct one that reflects it, something that allows the byte
	compiler to give more useful warnings with labels.
	Do the check for the number of args passed correctly.
	If we haven't been supplied an explicit lambda, use an uninterned
	symbol for the argument list name, avoiding problems with dynamic
	scope.

2018-06-30  Aidan Kehoe  <kehoea@parhasard.net>

	* gtk-widgets.el:
	Avoid duplicate function imports in this file.
	* gtk-faces.el:
	Silence warnings about unbound symbols within this file when
	byte-compiling.
	* gtk-file-dialog.el:
	Silence warnings about #'gtk-dialog-get-content-area not being
	#'fboundp.
	* gtk-init.el:
	Silence warnings about #'gtk-load-css not having a function
	binding.

2018-06-14  Aidan Kehoe  <kehoea@parhasard.net>

	* test-harness.el (test-harness-from-buffer):
	Use the correct number of #'format arguments in calls to
	Print-Failure here, avoiding log chatter when XEmacs warns about
	too many arguments to #'format.

2018-05-25  Aidan Kehoe  <kehoea@parhasard.net>

	* events.el:
	* events.el (key-or-mouse-event-p): New.
	* events.el (timeout-or-eval-event-p): New.
	* events.el (char-or-event-p): New.
	Make these available, the C code has been calling them from
	wrong_type_argument() for years, despite their not existing.

2018-04-27  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (ignore):
	* bytecomp.el (byte-compile-ignore): New.
	Add a byte-compile method for #'ignore, marking all its arguments
	as for-effect, and returning nil.

2018-04-25  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (not): New.
	* subr.el (null): New.
	* subr.el (atom): New.
	* subr.el (listp): New.
	* subr.el (nlistp): New.
	* subr.el (bitp): New.
	* subr.el (zerop): New.
	* subr.el (true-list-p): New.	
	Move all these functions from C, they're not loop hotspots,
	they're easily implemented in Lisp, and implementing them in C
	costs less memory with NEWGC.
	* bytecomp.el (byte-compile-throw):
	#'null is no longer in C, don't include its code in
	byte-compile-checks-on-load.
	* dumped-lisp.el:
	* dumped-lisp.el (preloaded-file-list):
	* loadup.el (gc-cons-threshold):
	* loadup.el (really-early-error-handler):
	* loadup.el (fboundp):
	* make-docfile.el (done):
	* make-docfile.el (process-args):
	* make-docfile.el (preloaded-file-list):
	* make-docfile.el (site-file-list):
	* packages.el (packages-add-suffix):
	* packages.el (packages-list-autoloads-path):
	* update-elc.el:
	* update-elc.el (preloaded-file-list):
	* update-elc.el (or):
	* update-elc.el (featurep):
	* update-elc.el (do-autoload-commands):
	Don't use those functions when running a bare-metal XEmacs binary.

2018-04-25  Aidan Kehoe  <kehoea@parhasard.net>

	* make-docfile.el (docfile-out-of-date):
	#'call-process can return a non-integer if the underlying process
	signaled, and exited for that reason. Handle this more gracefully.

2018-04-10  Aidan Kehoe  <kehoea@parhasard.net>

	* code-files.el (write-region):
	Document that APPEND can now be a numeric offset, indicating a
	point to seek to.

2018-02-18  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (no-case-regexp-p):
	* simple.el (with-search-caps-disable-folding):
	* simple.el (with-interactive-search-caps-disable-folding):
	* simple.el (log-message-filter):
	Use `string-match-p' in these functions, no need to save the match
	data with same.
	* simple.el (clone-process):
	* simple.el (clone-buffer):
	* simple.el (clone-indirect-buffer):
	Ditto; use the same idiom throughout the file when stripping
	trailing <DIGIT+> patterns from strings.

2017-12-25  Aidan Kehoe  <kehoea@parhasard.net>

	* hyper-apropos.el (hyper-apropos-grok-variables):
	User variables' docstrings do not necessarily start with *, check
	for one before removing the first character from the output.

2017-12-24  Aidan Kehoe  <kehoea@parhasard.net>

	* test-harness.el (test-harness-from-buffer):
	Error in `Skip-Test-Unless' if BODY is not specified.

2017-12-22  Aidan Kehoe  <kehoea@parhasard.net>

	* descr-text.el (describe-char-unicodedata-file):
	The UnicodeData.txt installed with Perl no longer serves our
	needs. Use that installed by TeX instead, if available.
	
2017-12-22  Aidan Kehoe  <kehoea@parhasard.net>

	* compose.el: Rename from x-compose.el, it's not
	platform-specific.
	(decide-on-bindings):
	Remove the last of the X11-specific code, don't use the UABCD
	keysyms for some exotic composed base characters.
	* gtk-compose.el (gtk-compose): Require the new feature.
	* isearch-mode.el (isearch-pre-command-hook):
	* keymap.el (for):
	Update documentation, references to x-compose.el to reference the
	new name.

2017-12-01  Aidan Kehoe  <kehoea@parhasard.net>

	* about.el (about): New custom group for this file.
	* about.el (about-headline-face):
	* about.el (about-link-face):
	Provide and use a custom group for these faces, avoiding a
	distracting warning when viewing the about page.

2017-11-16  Aidan Kehoe  <kehoea@parhasard.net>

	* x-faces.el (x-library-search-path):
	Update this variable to include share/ subdirectories of all the
	potential prefixes, since rgb.txt is usually now in share/X11.
	* x-faces.el (x-color-list-internal):
	Use #'canoncase, not #'downcase when adding completion for the
	lowercase form, avoiding problems with Turkish locales.

2017-11-14  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/cyrillic.el ("Cyrillic-ISO"):
	* mule/cyrillic.el ("Russian"):
	* mule/cyrillic.el ("Cyrillic-ALT"):
	Remove cyril-util from the features list of these language
	environments; `standard-display-cyrillic-translit' is the only
	function in that file, and it has an autoload entry
	already. Removing it from the features list is helpful in buildbot
	tests without installed packages.

2017-11-14  Aidan Kehoe  <kehoea@parhasard.net>

	* gutter-items.el (buffers-tab-items):
	Add a missing parenthesis after Stephen's last change, get things
	building again.

2017-11-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* gutter-items.el (buffers-tab-items):
	Sort list before truncating it.  Clarify logic, remove comment.

2017-11-13  Aidan Kehoe  <kehoea@parhasard.net>

	* unicode.el (decode-char):
	Return nil instead of erroring when CODE cannot be encoded, as did
	this function pre-unicode-internal and as does (did) GNU's
	version.

2017-11-09  Aidan Kehoe  <kehoea@parhasard.net>

	Ben's approach in lib-src/make-case-conv.el didn't work, there are
	107 entries in CaseFolding.txt as of today where the first column
	is a lowercase letter, not an uppercase one. Parse UnicodeData.txt
	instead.

	* mule/make-case-conv.el: New.
	Replacement for lib-src/make-case-conv.py, parsing UnicodeData.txt
	instead.
	* mule/uni-case-conv.el:
	Update this file to reflect output from make-case-conv.el with
	recent UnicodeData.txt instead.

2017-10-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (cl-macroexpand-all):
	When processing a let binding, and an existing symbol macro has
	the same symbol name as the let binding, delay shadowing until all
	bindings are processed.	

2017-10-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/japanese.el (shift_jis): Correct comment.

2017-10-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* gutter-items.el (buffers-tab-omit-function):
	(buffers-tab-omit-list):
	(buffers-tab-selection-function):
	(buffers-tab-filter-functions):
	(buffers-tab-sort-function):
	(buffers-tab-grouping-regexp):
	(buffers-tab-format-buffer-line-function):
	(format-buffers-tab-line):
	(buffers-tab-items):
	(add-tab-to-gutter):
	(update-tab-in-gutter):
	Clarify docstrings.

2017-10-12  Aidan Kehoe  <kehoea@parhasard.net>

	* frame.el (frame-utmost-window-2): Made into a label.
	* frame.el (frame-utmost-window-1): Use the label.
	Remove #'frame-utmost-window-2 from the global namespace.

2017-10-06  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/chinese.el:
	* mule/chinese.el (for):
	* mule/chinese.el (chinese-big5/list):
	* mule/chinese.el (find-charset):
	* mule/mule-category.el (predefined-category-list):
	* mule/mule-charset.el:
	Remove Ben's attempt under unicode-internal to make Big5 into one
	charset. This is incompatible with byte-compiled code from 21.4,
	which uses the hackish chinese-big5-1, chinese-big5-2 charsets
	with ISO-2022 escapes to encode these characters.
	If at some point in the future where we use UTF-8 for compiled
	code this could be revisited.

2017-09-30  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/thai.el:
	* mule/thai.el (thai-tis620):
	* mule/thai.el (tis-620):
	The charset thai-iso8859-11 is identical to thai-tis620 for our
	purposes, and its presence makes the digit-char test code fail on
	non-mule. Remove it.  Use tis-620, the preferred IANA name for
	related coding system, as the related coding system name. Provide
	iso-8859-11, not actually an IANA name, as an alias.

2017-09-25  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (concat):
	This function hasn't accepted individual fixnums as arguments in
	twenty years, and GNU's version of the function doesn't
	either. Remove all mention of it.
	Clarify the types of the elements accepted in the argument sequences.
	* subr.el (bvconcat):
	Clarify the types of the elements accepted in the argument sequences.

2017-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el:
	Remove `keyboard-type', which has been present since 1991 and
	never used. Don't do a make-compatible with it, since though it is
	present in GNU code it is not set or examined there. The byte
	compiler warning should be enough.

2017-09-07  Aidan Kehoe  <kehoea@parhasard.net>

	* rect.el (delete-extract-rectangle-line):
	Use (format "%*s" N "") instead of (spaces-string N) in this
	function.
	* rect.el (extract-rectangle-line): Ditto.
	* rect.el (spaces-strings): Removed.
	* rect.el (spaces-string): Removed.
	These aren't needed, (format "*s" N "") does the same job.
	* rect.el (apply-on-rectangle):
	* rect.el (delete-rectangle-line):
	* rect.el (open-rectangle-line):
	* rect.el (string-rectangle-line):
	* rect.el (clear-rectangle-line):
	* rect.el (rect):
	Fixup whitespace in this file.

2017-06-28  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (char-width): Move this to C, necessary as part of the
	unicode-internal support.

2017-05-30  Aidan Kehoe  <kehoea@parhasard.net>

	* about.el (about-xemacs):
	Correct a recently-introduced bug here, give the correct bounding
	keywords to #'parse-integer when working out the month of the
	release date.
	Don't check for xemacs-extra-name, xemacs-release-date being
	#'boundp, we control src/emacs.c, and can ensure they always are.

2017-03-15  Aidan Kehoe  <kehoea@parhasard.net>

	* make-docfile.el:
	Don't bother working around a berkeley-unix and next-mach bug
	that is likely long fixed anyway.
	Print the stderr of make-docfile to the terminal instead of simply
	discarding it.
	Pass through make-docfile's exit code.

2017-03-13  Aidan Kehoe  <kehoea@parhasard.net>

	* ChangeLog:
	* data.c:
	Update mid.gmane.org to mid.xemacs.org. We miss you, Gmane.

2017-03-12  Aidan Kehoe  <kehoea@parhasard.net>

	Replace calls to #'string-match, where the match data isn't used,
	with calls to #'string-match-p. This will lead to fewer
	undesired interactions (= bugs) with other code.

	* abbrev.el (define-abbrev):
	* auto-save.el (auto-save-file-name-p):
	* auto-save.el (auto-save-original-name):
	* buff-menu.el (list-buffers-internal):
	* byte-optimize.el (byte-compile-log-lap-1):
	* bytecomp-runtime.el (error-unless-tests-match):
	* bytecomp-runtime.el (byte-compile-file-being-compiled):
	* bytecomp.el (byte-recompile-directory):
	* bytecomp.el (byte-recompile-file):
	* bytecomp.el (batch-byte-compile-one-file):
	* cl-extra.el (names):
	* cmdloop.el:
	* cmdloop.el (keyboard-escape-quit):
	* code-files.el (find-file-coding-system-for-read-from-filename):
	* code-files.el (find-file-coding-system-for-write-from-filename):
	* code-process.el (call-process):
	* code-process.el (start-process):
	* code-process.el (network-stream-open-starttls):
	* code-process.el (open-network-stream):
	* cus-edit.el (custom-guess-type):
	* cus-edit.el (customize-apropos):
	* custom.el (custom-group-of-mode):
	* custom.el (custom-load-symbol):
	* derived.el (derived-mode-make-docstring):
	* descr-text.el (describe-text-sexp):
	* etags.el (get-tag-table-buffer):
	* etags.el (add-to-tag-completion-table):
	* faces.el (face-complain-about-font):
	* files.el:
	* files.el (file-chase-links):
	* files.el (find-file-noselect):
	* files.el (set-auto-mode):
	* files.el (hack-local-variables):
	* files.el (hack-one-local-variable):
	* files.el (file-name-sans-versions):
	* files.el (make-backup-file-name-1):
	* files.el (backup-file-name-p):
	* files.el (backup-extract-version):
	* files.el (file-relative-name):
	* files.el (rename-uniquely):
	* files.el (wildcard-to-regexp):
	* files.el (shell-quote-wildcard-pattern):
	* files.el (insert-directory):
	* files.el (file-name-non-special):
	* files.el (file-system-ignore-case-p):
	* fill.el:
	* fill.el (fill-context-prefix):
	* finder.el (finder-edit):
	* finder.el (finder-view):

2017-03-12  Aidan Kehoe  <kehoea@parhasard.net>

	Clean up auto-save.el, extend the functionality of
	#'auto-save-{un,}escape-name.

	* auto-save.el:
	* auto-save.el (efs-auto-save-remotely):
	Always provide a defvar for this, since this file is dumped efs.el
	will not be loaded before auto-save.el.
	* auto-save.el (auto-save-checked-directory):
	Fix some indentation; remove some long-commented code, avoiding
	distraction.
	* auto-save.el (auto-save-name-in-fixed-directory):
	We have DOC now, it's not expensive of RAM to have function
	docstrings, uncomment this one.
	* auto-save.el (auto-save-name-in-same-directory):
	Ditto.
	* auto-save.el (auto-save-reserved-chars):
	Expand the docstring of this a little.
	* auto-save.el (auto-save-escape-name):
	Preserve those characters which wouldn't be preserved by
	file-name-coding-system in this function.
	* auto-save.el (auto-save-unescape-name):
	Do the inverse of the newly-added functionality of
	#'auto-save-escape-name.
	* auto-save.el (auto-save-cyclic-hash-14):
	Uncomment the docstring for this function.

2017-03-12  Aidan Kehoe  <kehoea@parhasard.net>

	* auto-save.el (auto-save-unescape-name):
	Fix a bug in this, limit the hex parsing correctly.

2017-03-09  Aidan Kehoe  <kehoea@parhasard.net>

	
	* disp-table.el (standard-display-g1):
	* disp-table.el (standard-display-graphic):
	* disp-table.el (standard-display-underline):
	* files.el (make-backup-file-name-1):
	* files.el (wildcard-to-regexp):
	* gtk-file-dialog.el (gtk-file-dialog-update-dropdown):
	* info.el (Info-all-case-regexp):
	* info.el (Info-scroll-next):
	* map-ynp.el (map-y-or-n-p):
	* menubar.el (menu-item-generate-accelerator-spec):
	* menubar.el (menu-max-items):
	* minibuf.el (get-user-response):
	* package-admin.el (package-admin-check-manifest):
	In contexts like (concat ... (char-to-string x) ...), (list x) is
	a more idiomatic and faster way to construct a sequence. Use it.

	* autoload.el (autoload-featurep-protect-autoloads):
	The fixnum-char mapping for values less than #x100 is stable, no
	need to construct the string "\x00-\xff" at runtime.

2017-03-04  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el (normal-top-level):
	Bind an uninterned #:buffer, rather than #:ntl-buffer, which is
	less distracting in backtraces.
	(Commit chiefly done to help get the xemacs-commit hook posting
	again.)

2017-02-20  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (with-hash-table-iterator): New.
	Make this Common Lisp special form available, the relevant C
	runtime support has just been added.

2017-02-13  Aidan Kehoe  <kehoea@parhasard.net>

	* autoload.el (make-autoload):
	* cl-macs.el (get-setf-method):
	* files.el (abbreviate-file-name):
	* regexp-opt.el (regexp-opt-depth):
	* simple.el (delete-trailing-whitespace):
	Replace (save-match-data (string-match ...)), detected
	algorithmically, with (string-match-p ...). Similarly for the one
	instance of (save-match-data (looking-at ...)).

2017-02-09  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (safe-length): New. Moved here from data.c, there's no
	indication to have this in C.

2017-01-15  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (with-output-to-string):
	Sigh, despite that we did not document that standard-output would
	always be a Lisp buffer, a decent amount of code depends on that
	behaviour, and so we cannot implement this in terms of
	#'make-string-output-stream. Thanks for the bug report, Jerry James!

2017-01-14  Aidan Kehoe  <kehoea@parhasard.net>

	* minibuf.el (mouse-rfn-setup-vars): Move this to being a label.
	* minibuf.el (mouse-read-file-name-1):
	Define, use the label.

2017-01-14  Aidan Kehoe  <kehoea@parhasard.net>

	* cus-face.el:
	* cus-face.el (custom-face-attributes):
	Merge GNU's :height, equivalent to :size if a fixnum, providing a
	scale factor if a float, and transforming in some way if a
	function.
	* cus-face.el (custom-set-face-font-height): New.
	Implementation to set :height.
	* faces.el:
	* faces.el (make-face-family):
	* faces.el (make-face-size):
	Use #'apply-partially in these two functions, so the byte compiler
	can check the lambda bodies for sanity.
	* faces.el (make-face-height): New.
	Do the bulk of the work of implementing the :height keyword. Not
	done yet; code to make a proportional font size update on changing
	of the font size from the font menu.

2017-01-14  Aidan Kehoe  <kehoea@parhasard.net>

	* cus-face.el (custom-face-inherit):
	Whoops Ben in 7efd3a9bbcfb, (vector spec) does not check whether
	SPEC is a vector, do it properly.

2017-01-14  Aidan Kehoe  <kehoea@parhasard.net>

	* font-menu.el:
	* font-menu.el (font-menu-change-face): Renamed.
	* font-menu.el (font-menu-maybe-change-face): New name for
	#'font-menu-change-face.
	Also give it a more comprehensive docstring, to avoid the sort of
	mistake of 30118fdc4f1f.
	No need for #'string-equal (there is on balance usually no need
	for #'string-equal, #'equal has a bytecode).

	* font-menu.el (font-menu-set-font):
	Revert part of 30118fdc4f1f of 20021112, which meant the font menu
	no longer worried about whether a given face was equivalent to the
	current default face when deciding whether to change it.
	Only message about changing a font if it is changed.

	* cl-macs.el (assert):
	Remove the artificial restriction that FORM must be a cons.
	This restriction is also present in Common Lisp, but keeping it
	adds no value for us.

2016-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (cl-macroexpand-all):
	Shadow symbol macros when the corresponding symbols are
	encountered in lambda argument lists with the symbol macro body.
	Previously this was buggy in that the lambda argument lists were
	left alone and the expansion was applied to the body of the
	lambda, which no-one intended.
	Implement a new SHADOW option for individual symbol macros,
	specifying the Common Lisp behaviour.

	* cl-macs.el (symbol-macrolet):
	Document this shadowing in the docstring. Document the
	transformation of `let', `let*' to `letf', `letf*'.
	Document the new SHADOW option.

	* cl-macs.el (cl-defsubst-expand): 
	Use the new SHADOW option in our symbol macros, to avoid problems
	with argument substitution inside let bindings or lambda
	expressions where that would be inappropriate.
	
2016-12-29  Aidan Kehoe  <kehoea@parhasard.net>

	Remove duplicate (and silently overridden) buffers tab Lisp code,
	buff-menu.el.

	* buff-menu.el:
	* buff-menu.el (buffers-tab): Removed.
	* buff-menu.el (buffers-tab-max-size): Removed.
	* buff-menu.el (buffers-tab-switch-to-buffer-function): Removed.
	* buff-menu.el (buffers-tab-omit-function): Removed.
	* buff-menu.el (buffers-tab-selection-function): Removed.
	* buff-menu.el (buffers-tab-filter-functions): Removed.
	* buff-menu.el (buffers-tab-sort-function): Removed.
	* buff-menu.el (buffers-tab-face): Removed.
	* buff-menu.el (buffers-tab-grouping-regexp): Removed.
	* buff-menu.el (buffers-tab-format-buffer-line-function): Removed.
	* buff-menu.el (buffers-tab-default-buffer-line-length): Removed.
	* buff-menu.el (buffers-tab-max-buffer-line-length): Removed.
	* buff-menu.el (buffers-menu-omit-function): New.
	* buff-menu.el (buffers-tab-switch-to-buffer): Removed.
	* buff-menu.el (select-buffers-tab-buffers-by-mode): Removed.
	* buff-menu.el (format-buffers-tab-line): Removed.
	* buff-menu.el (buffers-tab-items): Removed.

	* files.el (switch-to-next-buffer):
	* files.el (switch-to-previous-buffer)
	Use the usually-equivalent buffers-menu-omit-function in
	#'switch-to-{next,previous}-buffer, since these functions are
	always dumped and the buffers tab omit-function may well not be.

	* files.el (switch-to-next-buffer-in-group): Removed.
	* files.el (switch-to-previous-buffer-in-group): Removed.
	Move #'switch-to-{next,previous}-buffer-in-group to
	gutter-items.el, given they rely on the buffer tab grouping being
	available. 

	* gutter-items.el:
	* gutter-items.el (buffers-tab): New.
	* gutter-items.el (buffers-tab-omit-some-buffers): New.
	* gutter-items.el (select-buffers-tab-buffers-by-mode):
	* gutter-items.el (switch-to-next-buffer-in-group): New.
	* gutter-items.el (switch-to-previous-buffer-in-group): New.

	* keydefs.el:
	Only give #'switch-to-{next,previous}-buffer-in-group a keybinding
	if the gutter is available.

2016-12-27  Aidan Kehoe  <kehoea@parhasard.net>

	* about.el (about-xemacs):
	* auto-save.el (auto-save-unescape-name):
	* cl-extra.el:
	* cl-extra.el (upper-case-p):
	* descr-text.el (unidata-initialize-unihan-database):
	* files.el:
	* files.el (backup-extract-version):
	* font.el (font-parse-rgb-components):
	Use (parse-integer ... :radix 16) rather than (string-to-number
	(match-string ...) 16) where appropriate, creating less garbage
	strings.

2016-11-28  Aidan Kehoe  <kehoea@parhasard.net>

	* minibuf.el (read-from-minibuffer):
	Bind `help-form' within this function rather than using
	help-keymap-with-help-key.

	* help.el (function-really-at-point):
	Rename this label from #'function-at-point, which should fix the
	build (the file byte-compiled and ran fine, which is usually
	enough). Thank you Mats Lidell and the buildbot.

2016-11-27  Aidan Kehoe  <kehoea@parhasard.net>

	* help.el (function-at-point): New.
	* help.el (function-at-event): New.
	* help.el (function-called-at-point): Reworked.
	* help.el (function-at-point): Reworked.
	* help.el (help-keymap-with-help-key): Removed, long obsolete.
	Add support for detecting the current Lisp function if we are in
	the context of a C file.

2016-11-23  Aidan Kehoe  <kehoea@parhasard.net>

	* dumped-lisp.el (preloaded-file-list):
	Restore mule/digit.el to the list of dumped files, dropped
	accidentally in the Unicode merge.

2016-11-21  Aidan Kehoe  <kehoea@parhasard.net>

	* obarray.el (obarray-map):
	Correct the spelling of #'maphash when marking this for
	compatibility.

2016-11-20  Aidan Kehoe  <kehoea@parhasard.net>

	* abbrev.el:
	* abbrev.el (defining-abbrev-turns-on-abbrev-mode):
	* abbrev.el (make-abbrev-table):
	* abbrev.el (clear-abbrev-table):
	* abbrev.el (define-abbrev-table):
	* abbrev.el (define-abbrev):
	* abbrev.el (inverse-add-abbrev):
	* abbrev.el (expand-region-abbrevs):
	Implement abbrev tables as hash-table objects, not as vectors.

	* derived.el:
	* derived.el (derived):
	Ditto.

	* obarray.el: New.
	* obarray.el (xemacs-intern-in-vector):
	* obarray.el (xemacs-intern-soft-in-vector):
	* obarray.el (xemacs-unintern-in-vector):
	* obarray.el (xemacs-mapatoms-in-vector):
	* obarray.el (xemacs-next-iteration-in-vector):
	For compatibility with all the emacs code out there that expects
	that #'intern and friends can take vector arguments, provide a
	non-dumped but autoloaded implementation of traditional emacs
	obarrays, with the buckets implemented as individual slots in a
	non-resizing vector and each entry in a bucket chained through a
	symbol's next pointer.

	* obarray.el (obarray-default-size): New.
	* obarray.el (obarray-make): New.
	* obarray.el (obarrayp): New.
	* obarray.el (obarray-get): New.
	* obarray.el (obarray-put): New.
	* obarray.el (obarray-remove): New.
	* obarray.el (obarray-map): New.
	Import these ill-conceived GNU functions, mark them compatible.

	* obsolete.el:
	Provide autoloads for the traditional-obarray compatibility
	functions.

2016-11-19  Aidan Kehoe  <kehoea@parhasard.net>

	* fontconfig.el (fc-define-property):
	Supply the right number of arguments to #'format when creating the
	fc-pattern-del- functions, now we have diagnostics that complain
	when too many arguments are supplied.

2016-11-15  Aidan Kehoe  <kehoea@parhasard.net>

	* about.el (about-finish-buffer):
	Restore an omitted arglist here.
	* bytecomp.el (byte-compile-output-docform):
	No need for char= here, use #'eql which will compile to a byte code.
	* bytecomp.el (byte-compile-lambda):
	Check for a likely interactive spec when examining the arglist
	here, warn if encountered, the programmer probably omitted the
	arglist (see the above about.el change for context).

2016-11-07  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (char-int-p): New.
	* subr.el (char-or-char-int-p): New.
	* subr.el (char-or-string-p): New.
	* subr.el (integer-or-marker-p): New.
	* subr.el (integer-or-char-p): New.
	* subr.el (integer-char-or-marker-p): New.
	* subr.el (number-or-marker-p): New.
	* subr.el (number-char-or-marker-p): New.
	Move these basic predicates to subr.el from data.c

2016-10-30  Aidan Kehoe  <kehoea@parhasard.net>

	* dumped-lisp.el (preloaded-file-list):
	Dump (preload) "font-menu" when the menubar is available,
	"x-font-menu" when X and the menubar is available.
	* font-menu.el (font-menu-family-constructor):
	* font-menu.el (font-menu-size-constructor):
	* font-menu.el (font-menu-weight-constructor):
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* gtk-font-menu.el (gtk-font-menu-font-data):
	* msw-font-menu.el (mswindows-reset-device-font-menus):
	* msw-font-menu.el (mswindows-font-menu-font-data):
	* x-font-menu.el (x-reset-device-font-menus-core):
	* x-font-menu.el (x-font-menu-font-data-xft):
	* x-font-menu.el (x-font-menu-font-data-core):
	Use #'assoc, which has a native implementation, instead of
	#'vassoc, which is implemented in non-dumped Lisp, for the font
	menu device cache.
	Dump the font menu implementation code when the relevant features
	are compiled in.
	Makes the font face menu a little faster, though the bottleneck is
	still loading the faces from the X server.

2016-09-11  Aidan Kehoe  <kehoea@parhasard.net>

	* abbrev.el (abbrev-symbol):
	Use a label rather than binding a lambda when examining the local
	and global tables.
	* about.el (about-finish-buffer):
	Use a label instead of binding a lambda.
	* gtk-password-dialog.el (gtk-password-dialog-new):
	Ditto.
	* minibuf.el (minibuffer-complete-word):
	Use a label rather than binding a lambda here; don't needlessly
	bind something to the value of last-command-char.
	* minibuf.el (read-file-name-internal-1):
	Use #'file-name-absolute-p here, as an old comment suggested.
	* minibuf.el (read-directory-name-internal):
	Use a label rather than binding a lambda here.
	* minibuf.el (mouse-read-file-name-1):
	Ditto.
	* mouse.el (default-mouse-track-cleanup-hook):
	Ditto.
	* mouse.el (default-mouse-track-cleanup-extent):
	Ditto.

2016-11-04  Aidan Kehoe  <kehoea@parhasard.net>

	* select.el:
	* select.el (select-convert-in):
	Pass through VALUE if it is non-nil and there is no handler, don't
	discard it.  Useful for TARGETS, timestamps.
	* select.el (select-convert-from-cf-unicodetext):
	Supply this with an implementation even when mswindows-unicode
	isn't available as a coding system.
	* select.el (selection-converter-out-alist):
	* select.el (selection-converter-in-alist):
	Only include CF_TEXT in these alists conditionally (at dump time),
	if the relevant coding system is available.

2016-09-11  Aidan Kehoe  <kehoea@parhasard.net>

	* gutter-items.el (buffers-tab-switch-to-buffer):
	Don't walk windows and cons up the windows-of-buffers list twice,
	needlessly, we only need one window and #'get-buffer-window does
	the same thing without consing.
	* gutter-items.el (select-buffers-tab-buffers-by-mode):
	Use the regexp engine a little less in this function.
	* gutter-items.el (format-buffers-tab-line):
	Don't use the regexp engine in this function. Don't repeatedly
	call #'buffer-name, save its result.
	* gutter-items.el (build-buffers-tab-internal): Move this to being
	a label within #'buffers-tab-items.
	* gutter-items.el (buffers-tab-items):
	Be more idiomatic in checking buffers-tab-filter-function, no need
	to traverse the list twice.
	Improve the algorithmic complexity of the code to implement the
	buffers-tab-max-size functionality.
	* menubar.el (check-menu-syntax):
	* menubar.el (menu-item-strip-accelerator-spec):
	Don't use the regexp engine in this function, we're called a good
	deal in long menus and it's easy to implement it with functions
	that have bytecodes.
	* menubar.el (menu-item-generate-accelerator-spec):
	Make this function's implementation faster in the common case
	where OMIT-CHARS-LIST is nil.

2016-08-19  Aidan Kehoe  <kehoea@parhasard.net>

	* mwheel.el:
	Sync functionality (though surprisingly little code) from
	GNU. Thank you GNU.
	Remove some unneeded compatibility code.
	
	* mwheel.el (mwheel-scroll-amount): Removed.
	* mwheel.el (mouse-wheel-scroll-amount): New.
	Use GNU's newer, more sensible name for this variable.
	
	* mwheel.el (mouse-wheel-click-event): New.
	Event to ignore for a brief period after using the mouse wheel.
	* mwheel.el (mouse-wheel-inhibit-click-time): New.
	Numbeer of seconds to inhibit `mouse-wheel-click-event' after
	using the mouse wheel.

	* mwheel.el (mouse-wheel-progressive-speed): New.
	Should the mouse wheel scroll more quickly if it is moved more
	energetically?
	
	* mwheel.el (mwheel-follow-mouse): Removed.
	* mwheel.el (mouse-wheel-follow-mouse): New.
	Rename the former to the latter.

	* mwheel.el (mouse-wheel-scroll-up-function): New variable, the
	command to call when scrolling up using the wheel, defaulting to
	#'scroll-up-command.
	* mwheel.el (mouse-wheel-scroll-down-function): New variable,
	defaulting to #'scroll-down-command.
	* mwheel.el (mwheel-install):
	Support
	* mwheel.el (mwheel-scroll): 
	* mwheel.el (mouse-wheel-scroll): Rename `mwheel-scroll' to
	`mouse-wheel-scroll', something GNU (oddly) haven't, but something
	that is clearer and more sensible.

	* mwheel.el (mouse-wheel-scroll, mwheel-install):
	Add autoload forms for these, since the auto-autoload code doesn't
	understand how to parse symbol-macrolet.

	* obsolete.el:
	* obsolete.el ('mwheel-scroll): Make this available as an obsolete
	alias for #'mouse-wheel-scroll.
	* obsolete.el ('mwheel-scroll-amount): New.
	Make this available as an obsolete variable alias for
	mouse-wheel-scroll-amount.
	* obsolete.el ('mwheel-follow-mouse): New.
	Make this available as an obsolete variable alias for
	mouse-wheel-follow-mouse.

	* behavior-defs.el:
	* behavior-defs.el (mwheel): Move the mwheel behavior here from
	mwheel.el, so users can disable it from their init file.
	* keydefs.el:
	Be a little clearer in the implementation of this, bind the mouse
	wheel events to #'mouse-wheel-scroll, which is autoloaded.

	Incorporates the following GNU changes:

    2002-12-02  Andreas Schwab  <schwab@suse.de>

	* mwheel.el (mouse-wheel-scroll-amount): Fix customize type.

    2002-11-29  Markus Rost  <rost@math.ohio-state.edu>

	* mwheel.el (mouse-wheel-inhibit-click-time): Fix custom type.

    2002-11-29  Kim F. Storm  <storm@cua.dk>

	* mwheel.el: Avoid accidental yanking of text while scrolling with
	the mouse wheel.  This adds a short period after each mouse wheel
	scroll event where a click on the mouse wheel button is ignored.
	(mouse-wheel-click-event, mouse-wheel-inhibit-click-time): New customs.
	(mouse-wheel-click-button, mwheel-inhibit-click-event-timer): New vars.
	(mwheel-inhibit-click-timeout, mwheel-filter-click-events): New defuns.
	(mwheel-scroll): Add mwheel-filter-click-events as pre-command-hook.
	Start mwheel-inhibit-click-event-timer with timeout handler
	mwheel-inhibit-click-timeout.

    2002-11-11  Markus Rost  <rost@math.ohio-state.edu>

	* mwheel.el (mouse-wheel-down-button, mouse-wheel-up-button):
	Declare with defvar, not with defcustom.

    2002-08-29  John Paul Wallington  <jpw@shootybangbang.com>

	* mwheel.el (mouse-wheel-up-button): Doc fix.

    2002-06-27  Stefan Monnier  <monnier@cs.yale.edu>

	* mwheel.el (mouse-wheel-change-button): Deactivate before changing.
	(mouse-wheel-up-button, mouse-wheel-down-button): Obsolete.
	(mouse-wheel-up-event, mouse-wheel-down-event): New vars.
	(mouse-wheel-follow-mouse): Change default to t.
	(mwheel-event-button): Return the basic event symbol.
	(mwheel-scroll): Work with non-mouse events.
	(mouse-wheel-mode): Use the new vars.
	(mwheel-install): Obey `uninstall'.

    2002-06-24  Stefan Monnier  <monnier@cs.yale.edu>

	* mwheel.el (mouse-wheel-scroll-amount, mwheel-scroll)
	(mouse-wheel-mode): Don't require the first element to be modifier-free.

    2002-02-19  Sam Steingold  <sds@gnu.org>

	* mwheel.el (mouse-wheel-scroll-amount): Can specify different
	scroll amounts for different modifiers now.
	(mwheel-scroll): Handle the new `mouse-wheel-scroll-amount'
	format properly.
	(mouse-wheel-mode): Ditto.

    2001-11-19  Stefan Monnier  <monnier@cs.yale.edu>

	* mwheel.el (mouse-wheel-scroll-amount): Allow float values.
	(mouse-wheel-progressive-speed): New var.
	(mwheel-scroll): Use it and handle float values.

    2004-11-11  Stefan Monnier  <monnier@iro.umontreal.ca>

	* mwheel.el (mouse-wheel-scroll-amount): Allow float values.
	(mouse-wheel-progressive-speed): New var.
	(mwheel-scroll): Use it and handle float values.

    2006-02-14  Juanma Barranquero  <lekktu@gmail.com>

	* help.el (where-is): Fix message for remapped commands.

	* mwheel.el (mouse-wheel-click-event, mouse-wheel-mode):
	Fix typos in docstrings.

    2006-02-11  Martin Rudalics  <rudalics@gmx.at>

	* mwheel.el (mouse-wheel-up-event): Doc fix.

    2008-06-12  Glenn Morris  <rgm@gnu.org>

	* mwheel.el (mouse-wheel-follow-mouse, mwheel-event-window):
	Evaluate definitions when compiling.  Reverse tests.

    2009-11-25  Juri Linkov  <juri@jurta.org>

	Mouse-wheel scrolling for DocView Continuous mode.  (Bug#4896)

	* mwheel.el (mwheel-scroll-up-function)
	(mwheel-scroll-down-function): New defvars.
	(mwheel-scroll): Funcall `mwheel-scroll-up-function' instead of
	`scroll-up', and `mwheel-scroll-down-function' instead of
	`scroll-down'.

    2000-11-06  Miles Bader  <miles@lsi.nec.co.jp>

	* mwheel.el (mouse-wheel-scroll-amount): Rename from
	`mwheel-scroll-amount'.
	(mouse-wheel-follow-mouse): Rename from `mwheel-follow-mouse'.
	(mouse-wheel-mode): Use (featurep 'xemacs) instead of
	string-matching against the version string.
	
2016-07-30  Aidan Kehoe  <kehoea@parhasard.net>

	* menubar-items.el (build-buffers-menu-internal): Move to being a
	label within #'buffers-menu-filter.
	* menubar-items.el (buffers-menu-filter):
	Implement #'build-buffers-menu-filter as an inlined label. Remove
	a compatibility hack in its implementation.
	Use backquotes to construct the individual menu items, making
	things a little clearer.
	Avoid uselessly calling #'length a few times, where #'nthcdr is
	appropriate to determine if a list's length is larger than a given
	value.
	Avoid uselessly calling #'nreverse twice if dealing with groups.
	* menubar-items.el (coding-system-menu-filter):
	Correct a docstring in passing.
	* menubar-items.el (buffers-menu-format-buffer-line-function):
	Update the documentation of this function to document that we've
	removed a compatibility hack.

2016-08-17  Aidan Kehoe  <kehoea@parhasard.net>

	* gnuserv.el (gnuserv-string): Removed.
	* gnuserv.el (gnuserv-request-stream): New.
	Replace gnuserv-string with gnuserv-request-stream, now we have
	native support for string output streams.
	* gnuserv.el (gnuserv-process-filter):
	Avoid using the regexp engine in this function. Avoid using the
	Lisp reader, use #'parse-integer, it's cheaper when parsing
	integers.
	* gnuserv.el (gnuserv-start-1):
	Use #'clear-output here.
	* subr.el (with-output-to-string):
	Implement this using #'make-string-output-stream.

2016-07-06  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (terpri): Move this here from print.c.
	* cl-macs.el: Document why there's no benefit to a compiler macro
	for #'terpri.
	* make-docfile.el:
	* make-docfile.el (message):
	* make-docfile.el (docfile-out-of-date):
	Don't use #'terpri at build time, it's no longer available,
	(write-char ?\n) instead.

2016-06-30  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (concatenate): Implement #'concatenate in
	sequence.c, implement #'concat, #'vconcat, #'bvconcat in terms of
	it rather than the other way around.

	* find-paths.el (paths-no-lisp-directory-regexp):
	* find-paths.el (paths-construct-path):
	* find-paths.el (paths-construct-emacs-directory):
	* find-paths.el (construct-emacs-version-name):
	* find-paths.el (paths-directories-which-exist):
	* loadup.el (really-early-error-handler):
	* make-docfile.el (process-args):
	* packages.el (packages-add-suffix):
	* packages.el (packages-list-autoloads-path):
	* update-elc.el (preloaded-file-list):
	* update-elc.el (do-autoload-commands):
	Use #'concatenate rather than #'concat in these files run at build
	time, where #'concat's new implementation from subr.el is not
	available.
	* subr.el:
	* subr.el (concat): Moved here from fns.c.
	* subr.el (vconcat): Moved here from fns.c.
	* subr.el (bvconcat): Moved here from fns.c.
	Implement all three in terms of #'concatenate. Maintain the
	#'concat bytecode for the moment.

2016-01-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* cl-seq.el (delete-if): Fix typo in docstring.

2015-09-26  Michael Sperber  <mike@xemacs.org>

	* info.el (Info-read-subfile): Follow change in Makeinfo 5.0 with
	arithmetic of node positions.

2015-06-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* itimer-autosave.el (auto-save-timeout): Customize in group 'auto-save.

2015-06-11  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (equalp):
	Fix a bug in this compiler macro when passed constants in a
	certain order.

2015-06-03  Aidan Kehoe  <kehoea@parhasard.net>

	* code-files.el (load):
	Revise this to respect load-ignore-out-of-date-elc-files, rather
	than leaving that to #'load-internal. Avoids a corner case where
	the source and the compiled file have different, incompatible
	encodings.
	Move the call to #'substitute-in-file-name here.
	No longer check for a zero-length filename, since #'load-internal
	no longer chokes on same and errors correctly.

2015-05-15  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el:
	* simple.el (line-number): Moved to buffer.c; we have an existing
	line number cache in C, it's a shame not to have it available.

2015-05-29  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (side-effect-free-fns):
	Add #'integer-length, #'logcount here.
	* cl-extra.el:
	* cl-extra.el (integer-length):
	Update this to avoid allocating memory.
	* cl-extra.el (logcount): New. Return the number of one bits in
	INTEGER, if non-negative. Function from Common Lisp.

2015-04-11  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-cmds.el (set-locale-for-language-environment):
	Bind `position' as a local variable here, as was the original
	intention.

2015-04-11  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (check-type):
	Correct the sense of the type test here when PLACE is not
	setf'able, something which gave confusing errors with literal
	fixnums or, e.g., (+ 30 40).

2015-04-04  Aidan Kehoe  <kehoea@parhasard.net>

	* gutter-items.el (append-progress-feedback):
	* gutter-items.el (abort-progress-feedback):
	Correct comments in both these functions, it's the progress stack
	being adjusted, not the message stack.
	* simple.el (message-stack):
	Describe my recent change in the structure of this.
	* simple.el (current-message):
	Adjust the implementation of this to always return the string
	displayed.

2015-04-03  Aidan Kehoe  <kehoea@parhasard.net>

	* gnuserv.el (gnuserv-edit-files):
	No need to memorise the device created for the sake of C-x #, if
	the client is not waiting for us.
	Fixes a bug in the following situation:
	-- Start gnuserv from an XEmacs within screen
	-- Call gnuclient with an X11 display available, connecting
	   successfully to that XEmacs and creating an X11 frame
	-- Then call gnuclient file-name.txt, save the file, then type C-x
	#; this deletes all the frames on the device, which it shouldn't.

2015-04-01  Aidan Kehoe  <kehoea@parhasard.net>

	When calling #'string-match with a REGEXP without regular
	expression special characters, call #'search, #'mismatch, #'find,
	etc. instead, making our code less likely to side-effect other
	functions' match data and a little faster.

	* apropos.el (apropos-command):
	* apropos.el (apropos):
	Call (position ?\n ...) rather than (string-match "\n" ...) here.
	* buff-menu.el:
	* buff-menu.el (buffers-menu-omit-invisible-buffers):
	Don't fire up the regexp engine just to check if a string starts
	with a space.
	* buff-menu.el (select-buffers-tab-buffers-by-mode):
	Don't fire up the regexp engine just to compare mode basenames.
	* buff-menu.el (format-buffers-tab-line):
	* buff-menu.el (build-buffers-tab-internal): Moved to being a
	label within the following.
	* buff-menu.el (buffers-tab-items): Use the label.
	* bytecomp.el (byte-compile-log-1):
	Don't fire up the regexp engine just to look for a newline.
	* cus-edit.el (get):
	Ditto.
	* cus-edit.el (custom-variable-value-create):
	Ditto, but for a colon.
	* descr-text.el (describe-text-sexp):
	Ditto.
	* descr-text.el (describe-char-unicode-data):
	Use #'split-string-by-char given that we're just looking for a
	semicolon.
	* descr-text.el (describe-char):
	Don't fire up the regexp engine just to look for a newline.
	* disass.el (disassemble-internal):
	Ditto.
	* files.el (file-name-sans-extension):
	Implement this using #'position.
	* files.el (file-name-extension):
	Correct this function's docstring, implement it in terms of
	#'position.
	* files.el (insert-directory):
	Don't fire up the regexp engine to split a string by space; don't
	reverse the list of switches, this is actually a longstand bug as
	far as I can see.
	* gnuserv.el (gnuserv-process-filter):
	Use #'position here, instead of consing inside #'split-string
	needlessly.
	* gtk-file-dialog.el (gtk-file-dialog-update-dropdown):
	Use #'split-string-by-char here, don't fire up #'split-string for
	directory-sep-char. 
	* gtk-font-menu.el (hack-font-truename):
	Implement this more cheaply in terms of #'find,
	#'split-string-by-char, #'equal, rather than #'string-match,
	#'split-string, #'string-equal.
	* hyper-apropos.el (hyper-apropos-grok-functions):
	* hyper-apropos.el (hyper-apropos-grok-variables):
	Look for a newline using #'position rather than #'string-match in
	these functions.
	* info.el (Info-insert-dir):
	* info.el (Info-insert-file-contents):
	* info.el (Info-follow-reference):
	* info.el (Info-extract-menu-node-name):
	* info.el (Info-menu):
	Look for fixed strings using #'position or #'search as appropriate
	in this file.
	* ldap.el (ldap-decode-string):
	* ldap.el (ldap-encode-string):
	#'encode-coding-string, #'decode-coding-string are always
	available, don't check if they're fboundp.
	* ldap.el (ldap-decode-address):
	* ldap.el (ldap-encode-address):
	Use #'split-string-by-char in these functions.
	* lisp-mnt.el (lm-creation-date):
	* lisp-mnt.el (lm-last-modified-date):
	Don't fire up the regexp engine just to look for spaces in this file.
	* menubar-items.el (default-menubar):
	Use (not (mismatch ...)) rather than #'string-match here, for
	simple regexp.
	Use (search "beta" ...) rather than (string-match "beta" ...)
	* menubar-items.el (sort-buffers-menu-alphabetically):
	* menubar-items.el (sort-buffers-menu-by-mode-then-alphabetically):
	* menubar-items.el (group-buffers-menu-by-mode-then-alphabetically):
	Don't fire up the regexp engine to check if a string starts with
	a space or an asterisk.
	Use the more fine-grained results of #'compare-strings; compare
	case-insensitively for the buffer menu.
	* menubar-items.el (list-all-buffers):
	* menubar-items.el (tutorials-menu-filter):
	Use #'equal rather than #'string-equal, which, in this context,
	has the drawback of not having a bytecode, and no redeeming
	features.
	* minibuf.el:
	* minibuf.el (un-substitute-in-file-name):
	Use #'count, rather than counting the occurences of $ using the
	regexp engine.
	* minibuf.el (read-file-name-internal-1):
	Don't fire up the regexp engine to search for ?=.
	* mouse.el (mouse-eval-sexp):
	Check for newline with #'find.
	* msw-font-menu.el (mswindows-reset-device-font-menus):
	Split a string by newline with #'split-string-by-char.
	* mule/japanese.el:
	* mule/japanese.el ("Japanese"):
	Use #'search rather than #'string-match; canoncase before
	comparing; fix a bug I had introduced where I had been making case
	insensitive comparisons where the case mattered.
	* mule/korea-util.el (default-korean-keyboard):
	Look for ?3 using #'find, not #'string-march.
	* mule/korea-util.el (quail-hangul-switch-hanja):
	Search for a fixed string using #'search.
	* mule/mule-cmds.el (set-locale-for-language-environment):
	#'position, #'substitute rather than #'string-match,
	#'replace-in-string.
	* newcomment.el (comment-make-extra-lines):
	Use #'search rather than #'string-match for a simple string.
	* package-get.el (package-get-remote-filename):
	Use #'position when looking for ?@
	* process.el (setenv):
	* process.el (read-envvar-name):
	Use #'position when looking for ?=.
	* replace.el (map-query-replace-regexp):
	Use #'split-string-by-char instead of using an inline
	implementation of it.
	* select.el (select-convert-from-cf-text):
	* select.el (select-convert-from-cf-unicodetext):
	Use #'position rather than #'string-match in these functions.
	* setup-paths.el (paths-emacs-data-root-p):
	Use #'search when looking for simple string.
	* sound.el (load-sound-file):
	Use #'split-string-by-char rather than an inline reimplementation
	of same.
	* startup.el (splash-screen-window-body):
	* startup.el (splash-screen-tty-body):
	Search for simple strings using #'search.
	* version.el (emacs-version):
	Ditto.
	* x-font-menu.el (hack-font-truename):
	Implement this more cheaply in terms of #'find,
	#'split-string-by-char, #'equal, rather than #'string-match,
	#'split-string, #'string-equal.
	* x-font-menu.el (x-reset-device-font-menus-core):
	Use #'split-string-by-char here.
	* x-init.el (x-initialize-keyboard):
	Search for a simple string using #'search.

2015-03-16  Aidan Kehoe  <kehoea@parhasard.net>

	* tty-init.el (make-frame-after-init-entry-point):
	Some parentheses were placed badly here with the last change,
	thank you Mats for pointing it out; in passing, change to a
	version of the code that doesn't create a string for garbage, not
	that it matters.

2015-03-16  Aidan Kehoe  <kehoea@parhasard.net>

	* obsolete.el (max-char):
	Make this available for compatiblity with GNU, implement it in
	terms of char-code-limit.

2015-03-15  Aidan Kehoe  <kehoea@parhasard.net>

	* tty-init.el (make-frame-after-init-entry-point):
	Behave better when TERM was not set; use
	#'console-tty-terminal-type instead of (getenv "TERM") so we get
	the value that reflects the current console. Thank you Uwe Brauer!

	* mule/mule-tty-init.el (mule-tty-win-initted): Removed.
	* mule/mule-tty-init.el (init-mule-tty-win): Removed.
	* mule/mule-tty-init.el: Remove this file in its entirety.
	* mule/mule-x-init.el (x-use-halfwidth-roman-font): Removed.
	* mule/mule-x-init.el: Remove this file in its entirety.
	* dumped-lisp.el (preloaded-file-list): Remove them from the
	dumped file list. The functions within haven't been used since
	they were imported from Mule in 1999, and the functionality of
	init-mule-tty-win was already in tty-init.el. If someone wants to
	automatically use a halfwidth roman font, they can go hunting for
	the code, but there are no users on http://searchco.de/ as of
	20150315. Leaving them around is confusing and distracting.

2015-03-14  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (quoted-insert):
	Update the docstring here, syncing GNU's, especially mentioning
	read-quoted-char-radix.
	* cmdloop.el:
	* cmdloop.el (read-quoted-char-radix): Move this up here, outside
	the functions.
	* cmdloop.el (read-function-key-map): New label, reading and
	replacing characters from function-key-map if appropriate.
	* cmdloop.el (read-quoted-char): Multiple changes:
	-- Take advantage of help-event-list, but be careful not to have
	any keystrokes with character equivalents in it, so the user can
	type C-q C-h and have the expected result.
	-- Use function-key-map, as does #'read-char and
	#'read-exclusive-char, helpful for character composition under
	X11.
	-- Pop up the help window ourselves if, e.g. F1 arrives on a TTY
	via function-key-map, event-stream won't have done it.
	-- Error if no keystroke that can be converted into a character is
	specified, don't just insert ?\x00 as we used to and as does GNU
	-- Use #'digit-char-p instead of reimplementing it.
	-- Fix a bug of mine where I wasn't consistent about treating
	character codes as Unicode.

2015-03-14  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el (no-character-typed):
	New error, for those cases when a keystroke is to be treated as a
	character but has no character equivalent.
	* cmdloop.el (read-char-1): Use it.
	* keymap.el (synthesize-keysym): Use it.

2015-03-14  Aidan Kehoe  <kehoea@parhasard.net>

	* cus-start.el (all): Describe help-event-list for Custom.
	* keydefs.el (help-event-list): Initialise it.

2015-03-12  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (append-message): Be more careful about saving a
	non-nil value for START in message-stack.

2015-03-11  Aidan Kehoe  <kehoea@parhasard.net>

	* isearch-mode.el:
	* isearch-mode.el (isearch-fix-case):
	Use the new #'no-case-regexp-p function if treating ISEARCH-STRING
	as a regular expression; otherwise, use the [[:upper:]] character
	class.
	* isearch-mode.el (isearch-no-upper-case-p): Removed. 
	* isearch-mode.el (with-caps-disable-folding): Removed.
	These two haven't been used since 1998.
	* occur.el (occur-1):
	Use #'no-case-regexp-p here.
	* replace.el (perform-replace):
	Don't use #'no-upper-case-p, use #'no-case-regexp-p or
	(string-match "[[:upper:]]" ...) as appropriate.
	* simple.el:
	* simple.el (no-upper-case-p): Removed. This did two different
	things, and its secondary function (examining regular expressions)
	just became much more complicated; move the regular expression
	functionality to its own function, use character classes when
	examining non-regular-expressions instead.
	The code to look for character classes, and the design decision
	that this should be done, are from GNU, thank you Stefan Monnier.
	* simple.el (no-case-regexp-p): New.
	Given a REGEXP, return non-nil if it has nothing to suggest an
	interactive user wants a case-sensitive search.
	* simple.el (with-search-caps-disable-folding):
	* simple.el (with-interactive-search-caps-disable-folding):
	Update both these macros to use #'no-case-regexp-p.

2015-03-11  Aidan Kehoe  <kehoea@parhasard.net>

	Correct #'clear-message and friends so the START and END supplied
	to #'append-message are reflected when restoring messages from the
	message stack.
	* simple.el (remove-message-hook):
	Update this to reflect the START and END keyword arguments.
	* simple.el (log-message):
	Update this to take START and END keyword arguments.
	* simple.el (clear-message):
	Update this to reflect a changed `message-stack' alist structure.
	* simple.el (remove-message):
	Update this to reflect a changed `message-stack' alist structure;
	don't do `with-trapping-errors' and resignal use
	#'call-with-condition-handler directly instead, for better
	backtraces and easier debugging.
	* simple.el (append-message):
	Update this to reflect a changed message-stack structure.

2015-03-08  Aidan Kehoe  <kehoea@parhasard.net>
 
 	* mule/digit.el: New file, specifying integer weights for those
 	decimal digits specified by Unicode, and for the Latin characters
 	in ASCII.
 	* dumped-lisp.el (preloaded-file-list):
 	Dump this file, so those weights are available at runtime.
 
2015-02-25  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (digit-char-p): Moved to data.c.
	* cl-extra.el (digit-char): Moved to data.c.
	
2014-12-31  Michael Sperber  <mike@xemacs.org>

	* simple.el (line-move): Add `noerror' optional argument, as in
	GNU Emacs.

2014-11-10  Michael Sperber  <mike@xemacs.org>

	* custom.el (custom-add-package-version): The car of a
	:package-version is a symbol, not a string.

2014-10-11  Stephen J. Turnbull  <stephen@xemacs.org>

	* mule/korea-util.el (korean-key-bindings): 
	* mule/ethio-util.el (setup-ethiopic-environment-internal):
	Change invalid GNU-style key definitions to XEmacs format.

2014-10-07  Jerry James  <james@xemacs.org>

	* code-process.el (network-stream-get-response):
	(network-stream-command):
	(network-stream-open-plain):
	(network-stream-open-tls):
	(network-stream-certificate):
	(network-stream-open-starttls):
	(network-stream-open-shell): New functions.
	(open-network-stream): Accept Emacs-compatible arguments.

2014-09-27  Michael Sperber  <mike@xemacs.org>

	* custom.el (defcustom): 
	(custom-handle-keyword): Handle :package-version without bailing out.

2014-09-25  Jerry James  <james@xemacs.org>

	* bytecomp.el (byte-compile-insert-header): do not insert
	timestamps in .elc comments to get reproducible builds.

2014-08-05  Aidan Kehoe  <kehoea@parhasard.net>

	* keymap.el:
	* keymap.el (event-apply-modifiers):
	When a character keysym has case information, apply the shift
	modifier to it by upcasing it.
	* keymap.el (synthesize-keysym):
	Document this a little.
	* keymap.el (synthesize-unicode-codepoint): New.
	Like #'synthesize-keysym, but synthesizing a Unicode codepoint.
	* keymap.el (function-key-map-parent): Bind control shift u to
	synthesize a Unicode character input, as does GTK+ and as
	specified by ISO 14755.	

2014-08-06  Aidan Kehoe  <kehoea@parhasard.net>

	* fontconfig.el (fc-name-parse-harder):
	Improve style here, don't re-implement #'split-string-by-char with
	its ESCAPE-CHAR argument, look for a string prefix in a list of
	candidates in a more CL-idiomatic way, use the language's features
	for boolean or.

2014-07-14  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (raw-append-message):
	Use #'write-sequence in this, take its START and END keyword
	arguments, so our callers don't have to cons as much.
	* simple.el (append-message):
	Pass through START and END here.

2014-07-02  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (side-effect-free-fns):
	#'keymapp is not side-effect-free, it can autoload.

2014-07-02  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el:
	* cmdloop.el (read-char-1): New.
	* cmdloop.el (read-char, read-char-exclusive):
	Use #'read-char-1 in these function; sync their API with that of
	GNU, respect `function-key-map' where we didn't before, add
	initial support for Quail input methods.
	* keymap.el (next-key-event):
	Accept EVENT and PROMPT arguments, as does #'next-command-event.
	* keymap.el (event-apply-modifiers):
	Use #'functionp here, no need to exclude lambdas from
	`function-key-map'.
	* keymap.el (synthesize-keysym):
	Correct this function's docstring.

2014-04-19  Mats Lidell  <matsl@xemacs.org>

	* help.el: Sync from GNU - Link to customize if applicable and
	display version info. Other changes: Remove use of button-2.
	return and button-1 use activate-function. Move between
	activate-function-extents with tab.

2014-01-27  Michael Sperber  <mike@xemacs.org>

	* font-lock.el (font-lock-regexp-grouping-backslash,
	font-lock-regexp-grouping-construct): Add these, as in GNU Emacs.

2014-01-27  Michael Sperber  <mike@xemacs.org>

	* lisp.el (check-parens): Add, from GNU Emacs.
	
2014-01-27  Michael Sperber  <mike@xemacs.org>

	* custom.el (custom-declare-variable, defcustom): Add :risky and
	:safe options

2013-12-30  Byrel Mitchell <byrel.mitchell@gmail.com>

	* menubar.el (add-menu-item-1, delete-menu-item): Do not assume
	every top-level menu is on current-menubar.

2013-12-22  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (princ): New compiler macro.
	Transform #'princ to #'write-sequence if we can determine at
	compile time that it is being passed a string. Initialising the
	printer is expensive enough, but much of our code took this
	approach because #'write-sequence wasn't available.

2013-12-17  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (blink-matching-open):
	When showing the opening parenthesis in the minibiffer, use the
	isearch face for it, in case there are multiple parentheses in the
	text shown.
	When writing moderately involved macros, it's often not enough
	just to show the backquote context before the parenthesis
	(e.g. @,.`). Skip over that when searching for useful context in
	the same way we skip over space and tab.
	* simple.el (message):
	* simple.el (lmessage):
	If there are no ARGS, don't call #'format. This allows extent
	information to be passed through to the minibuffer.
	It's probably better still to update #'format to preserve extent
	info.

2013-12-17  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el:
	* cl-extra.el (write-string): New.
	* cl-extra.el (write-line): New.
	Add these here, implemented in terms of #'write-sequence in print.c.

2013-09-15  Mats Lidell  <matsl@cxemacs.org>

	* files.el (mode-require-final-newline): Variable synced from
	GNU. Thank you GNU. Allows modes to control final newlines.
	(require-final-newline): Add action on visiting and visiting or
	saving in sync with GNU.
	* text-mode.el (text-mode): Use mode-require-final-newline.

2013-09-10  Stephen J. Turnbull  <stephen@xemacs.org>

	* fontconfig.el (fc-name-parse-known-problem-attributes): New.
	(fc-name-parse-harder): New.

	* font.el (xft-font-create-object): Use fc-name-parse-harder.

2013-08-21  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el (normal-top-level):
	Use #'call-with-condition-handler here when calling
	#'command-line, giving better backtraces on error.
	Be careful about the current buffer in HANDLER.

2013-08-21  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (gensym):
	* bytecomp.el (byte-compile-gensym): New.
	Warn that gensym called in a for-effect context is unlikely to be
	useful.
	Warn about non-string non-integer ARGs, this is incorrect.
	Am not changing the function to error with same, most code that
	makes the mistake has no problems, which is why it has survived
	so long.
	* window-xemacs.el (save-window-excursion/mapping):
	* window.el (save-window-excursion):
	Call #'gensym with a string, not a symbol.

2013-08-05  Aidan Kehoe  <kehoea@parhasard.net>

	* isearch-mode.el (isearch-pre-command-hook):
	If this function is called and (this-command-keys) contains
	misc-user events, #'key-binding throws an error.
	Eddie Corns and Alex Belits describe this happening in tracker
	issue 336, and we can avoid this by catching the error and
	handling the misc-user event in the same way that #'dispatch-event
	does.
	I haven't reproduced the actual error they describe, and welcome
	testing to make sure it's gone.
	Thank you Eddie, thank you Alex!

2013-08-05  Aidan Kehoe  <kehoea@parhasard.net>

	* behavior.el:
	(override-behavior):
	Correct some spelling and formatting here, thank you Steven
	Mitchell in tracker issue 826.

2013-08-05  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/latin.el:
	Add a Latin-script Azeri language environment, with UTF-8 as the
	encoding and case information for schwa.

2013-06-23  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.34 "kale" is released.

2013-06-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* paragraphs.el (sentence-end-base):
	Fix stupid omission of cast to string.

2013-06-21  Stephen J. Turnbull  <stephen@xemacs.org>

	Fix no-Mule build.

	* paragraphs.el (sentence-end): Use octal, not Unicode, escapes.
	* (sentence-end-base): Use non-ASCII only in Mule.

2013-07-10  Aidan Kehoe  <kehoea@parhasard.net>

	* minibuf.el (get-user-response):
	* cmdloop.el (y-or-n-p-minibuf):
	No need to call #'events-to-keys in these two functions,
	#'lookup-key accepts events directly.
	* keymap.el:
	* keymap.el (events-to-keys):
	Document this function some more.
	Stop passing strings through unexamined, treat them as vectors of
	characters.
	Event keys are never integers, remove some code that only ran if
	(integerp (event-key ce)).
	Event keys are never numbers, don't check for that.
	Don't create (menu-selection call-interactively function-name)
	keystrokes for menu choices, #'character-to-event doesn't
	understand that syntax, so nothing uses it.
	Don't ever accept mouse events, #'character-to-event doesn't
	accept our synthesising of them.

2013-06-17  Aidan Kehoe  <kehoea@parhasard.net>

	* process.el (process-synchronize-point): Moved to a label.
	* process.el (call-process-internal):
	Now we have better language features, use them rather than
	creating a closure ourselves or exposing a utility function when
	there is no need for that with a well-implemented labels function.

2013-06-17  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (apply-partially):
	Be more intelligent about constructing (or not) compiled functions
	at runtime or compile time when making these closures.

2013-03-02  Michael Sperber  <mike@xemacs.org>

	* bytecomp.el (byte-compile-if): Port this patch from GNU Emacs:

	Author: Dave Love <fx@gnu.org>
	Date:   Thu Dec 12 20:27:43 2002 +0000

	    (byte-compile-if): Suppress warnings from
	    things protected by `(if (fboundp ...' or `(if (boundp ...'.

2013-02-20  Michael Sperber  <mike@xemacs.org>

	* files.el (file-remote-p): Remove an ancient piece of obsolete
	legacy code that looks at `efs-ftp-path'.

2013-02-20  Michael Sperber  <mike@xemacs.org>

	* font-lock.el (font-lock-beg)
	(font-lock-extend-region-functions)
	(font-lock-extend-region-multiline)
	(font-lock-extend-region-wholelines)
	(font-lock-default-fontify-region): Add and use
	`font-lock-extend-region-functions' from GNU Emacs.

2013-02-08  Michael Sperber  <mike@xemacs.org>

	* font-lock.el (font-lock-set-defaults-1):
	(font-lock-defaults): Allow the left-hand-side of a syntax-alist
	entry in `font-lock-defaults' to be a string, in addition to a
	char.  (This is a sync with GNU Emacs.)

2013-02-16  Stephen J. Turnbull  <stephen@xemacs.org>

	Thanks to Jeff Sparkes for suggestion and the original patches and
	to Mike Sperber for discussion.

	* obsolete.el (define-obsolete-function-alias):
	(define-compatible-function-alias):
	(define-obsolete-variable-alias):
	(define-compatible-variable-alias):
	Add optional WHEN and DOCSTRING arguments for GNU compatibility.
	Document WHEN as ignored.  Support DOCSTRING as well as the
	underlying functions allow.

2013-01-22  Jerry James  <james@xemacs.org>

	* glyphs.el (make-image-specifier): Document that :visible is a
	widget keyword.
	* menubar.el (check-menu-syntax): Allow :visible in menu specs.

2013-01-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.33 "horseradish" is released.

2012-12-28  Byrel Mitchell  <byrel.mitchell@gmail.com>

	* menubar.el (check-menu-syntax): Implement :active in submenu specs.

2012-08-03  Stephen J. Turnbull  <stephen@xemacs.org>

	* menubar-items.el (default-menubar): Reorganize.
	Add PROBLEMS to toplevel.
	New "More about XEmacs" submenu for NEWS, licensing, etc.
	New "Recent History" menu for messages, lossage, etc.
	Get rid of ugly and unexpressive ellipses.

2012-12-14  Mats Lidell  <matsl@xemacs.org>

	* register.el (describe-register-1): Fix erroneous regular
	expression. Thank you Stephen Turnbull.

2012-11-06  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (equal, member, assoc, rassoc):
	Never error at compile time in these compiler macros because of an
	incorrect number of arguments.

2012-10-14  Aidan Kehoe  <kehoea@parhasard.net>

	* help.el:
	* help.el (describe-function-1):
	Add some newlines here when dealing with remapped commands, thank
	you Robert Pluim.

2012-10-13  Mats Lidell  <matsl@xemacs.org>

	* process.el (call-process-shell-command): New function from GNU.

2012-09-18  Mats Lidell  <matsl@xemacs.org>

	* window-xemacs.el (recenter-positions): New defcustom.
	(recenter-top-bottom): New command.
	(recenter-last-op): New defvar.

	* replace.el (perform-replace): Let-bind recenter-last-op to nil.
	For def=recenter, replace `recenter' with `recenter-top-bottom'
	that is called with `this-command' and `last-command' let-bound to
	`recenter-top-bottom'.  When the last `def' was not `recenter',
	set `recenter-last-op' to nil.

	* keydefs.el (global-map): Make recenter-top-bottom new default
	for C-l.

2012-09-08  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el:
	* simple.el (delete-trailing-lines): New.
	* simple.el (delete-trailing-whitespace): New.
	Import this function and an associated variable from GNU, thank
	you GNU.
	Update its interactive spec to work correctly in XEmacs.

2012-09-07  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el:
	* files.el (find-coding-system-magic-cookie-in-file):
	Removed. Move this to C, so we can use
	look_for_coding_system_magic_cookie().

2012-09-02  Aidan Kehoe  <kehoea@parhasard.net>

	* help.el (describe-function-1):
	Document any command remapping that has been done in this function.

2012-08-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.32 "habanero" is released.

2012-05-14  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-optimize-letX):
	In (let ...) forms, group constant initialisations together, so we
	can just dup in the byte code.

2012-05-14  Aidan Kehoe  <kehoea@parhasard.net>

	Update minibuf.el to use #'test-completion, use the generality of
	recent completion changes to avoid some unnecessary consing when
	reading.
	* behavior.el (read-behavior):
	* cus-edit.el (custom-face-prompt):
	* cus-edit.el (widget-face-action):
	* faces.el (read-face-name):
	* minibuf.el:
	* minibuf.el (minibuffer-completion-table):
	* minibuf.el (exact-minibuffer-completion-p):
	Removed. #'test-completion is equivalent to this, but more
	general.
	* minibuf.el (minibuffer-do-completion-1): Use #'test-completion.
	* minibuf.el (completing-read): Update the documentation of the
	arguments used for completion.
	* minibuf.el (minibuffer-complete-and-exit): Use #'test-completion.
	* minibuf.el (exit-minibuffer): Use #'test-completion.
	* minibuf.el (minibuffer-smart-mouse-tracker): Use #'test-completion.
	* minibuf.el (read-color): No need to construct a completion table
	separate from the colour list.

2012-05-12  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el:
	* subr.el (truncate-string-to-width):
	Sync with GNU's version, use its test suite in mule-tests.el.
	Avoid args-out-of-range errors, this function is regularly called
	from menu code and with debug-on-signal non-nil, this can be very
	irritating.
	Don't bind ellipsis-len, we don't use it.

2012-05-12  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-compile-unfold-lambda):
	Fetch the bytecode before unfolding a compiled function, its body
	may have been compiled lazily thanks to
	byte-compile-dynamic. Thank you Mats Lidell and the package
	smoketest!

2012-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-category.el (word-combining-categories):
	Be better about default word boundaries when text contains
	just-in-time-allocated Unicode code points. Document what we
	should do instead once we have Unicode internally.
	* mule/misc-lang.el: IPA characters are Latin.

2012-05-08  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (rassoc): Remove a stray parenthesis here, thank you
	Vin!

2012-05-06  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (block): Comment on why we can't use &environment
	here.
	* cl-macs.el (defmacro*): Document &environment in more detail.
	* cl-macs.el (macrolet): Use &environment, instead of referencing
	byte-compile-macro-environment directly.
	* cl-macs.el (symbol-macrolet): Ditto.
	* cl-macs.el (lexical-let): Ditto.
	* cl-macs.el (labels): Ditto.

2012-05-06  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el:
	* byte-optimize.el (or):
	* byte-optimize.el (byte-optimize-or):
	Declare for-effect properly, it's not free.
	* byte-optimize.el (byte-optimize-condition-case): New.
	* byte-optimize.el (byte-optimize-form-code-walker):
	Be more exhaustive in descending special forms, for the sake of
	lexically-oriented optimizers such as that for #'labels.

2012-05-05  Aidan Kehoe  <kehoea@parhasard.net>

	Co-operate with the byte-optimizer in the bytecomp.el labels
	implementation, don't work against it.

	* byte-optimize.el:
	* byte-optimize.el (byte-compile-inline-expand):
	Call #'byte-compile-unfold-lambda explicitly here, don't assume
	that the byte-optimizer will do it.
	* byte-optimize.el (byte-compile-unfold-lambda):
	Call #'byte-optimize-body on the body, don't just mapcar
	#'byte-optimize-form along it.
	* byte-optimize.el (byte-optimize-lambda): New. Optimize a lambda
	form. 
	* byte-optimize.el (byte-optimize-form-code-walker):
	Descend lambda expressions, defun, and defmacro, relevant for
	lexically-oriented operators like #'labels.
	* byte-optimize.el (byte-optimize-body): Only return a non-eq
	object if we've actually optimized something
	* bytecomp.el (byte-compile-initial-macro-environment):
	In the labels implementation, work with the byte optimizer, not
	against it; warn when labels are defined but not used,
	automatically inline labels that are used only once.
	* bytecomp.el (byte-recompile-directory):
	No need to wrap #'byte-compile-report-error in a lambda with
	#'call-with-condition-handler here. 
	* bytecomp.el (byte-compile-form):
	Don't inline compiled-function objects, they're probably labels.
	* bytecomp.el (byte-compile-funcall):
	No longer inline lambdas, trust the byte optimizer to have done it
	properly, even for labels.
	* cl-extra.el (cl-macroexpand-all):
	Treat labels established by the byte compiler distinctly from
	those established by cl-macs.el.
	* cl-macs.el (cl-do-proclaim):
	Treat labels established by the byte compiler distinctly from
	those established by cl-macs.el.
	* gui.el (make-gui-button):
	When referring to the #'gui-button-action label, quote it using
	function, otherwise there's a warning from the byte compiler.

2012-05-05  Aidan Kehoe  <kehoea@parhasard.net>

	Remove some redundant functions; turn other utility functions into
	labels, avoiding visibility in the global namespace, and reducing
	the size of the dumped binary.

	* auto-save.el (auto-save-unhex): Removed.
	* auto-save.el (auto-save-unescape-name): Use #'string-to-number
	instead of #'auto-save-unhex.
	* files.el (save-some-buffers):
	* files.el (save-some-buffers-1): Changed to a label.
	* files.el (not-modified):
	* gui.el (make-gui-button):
	* gui.el (gui-button-action): Changed to a label.
	* gui.el (insert-gui-button):
	* indent.el (indent-for-tab-command):
	* indent.el (insert-tab): Changed to a label.
	* indent.el (indent-rigidly):
	* isearch-mode.el:
	* isearch-mode.el (isearch-ring-adjust):
	* isearch-mode.el (isearch-ring-adjust1): Changed to a label.
	* isearch-mode.el (isearch-pre-command-hook):
	* isearch-mode.el (isearch-maybe-frob-keyboard-macros): Changed to
	a label.
	* isearch-mode.el (isearch-highlight):
	* isearch-mode.el (isearch-make-extent): Changed to a label.
	* itimer.el:
	* itimer.el (itimer-decrement): Removed, replaced uses with decf.
	* itimer.el (itimer-increment): Removed, replaced uses with incf.
	* itimer.el (itimer-signum): Removed, replaced uses with minusp, plusp.
	* itimer.el (itimer-name):
	* itimer.el (check-itimer): Removed, replaced with #'check-type calls.
	* itimer.el (itimer-value):
	* itimer.el (check-itimer-coerce-string): Removed.
	* itimer.el (itimer-restart):
	* itimer.el (itimer-function):
	* itimer.el (check-nonnegative-number): Removed.
	* itimer.el (itimer-uses-arguments):
	* itimer.el (check-string): Removed.
	* itimer.el (itimer-function-arguments):
	* itimer.el (itimer-recorded-run-time):
	* itimer.el (set-itimer-name):
	* itimer.el (set-itimer-value):
	* itimer.el (set-itimer-value-internal):
	* itimer.el (set-itimer-restart):
	* itimer.el (set-itimer-function):
	* itimer.el (set-itimer-is-idle):
	* itimer.el (set-itimer-recorded-run-time):
	* itimer.el (get-itimer):
	* itimer.el (delete-itimer):
	* itimer.el (start-itimer):
	* itimer.el (activate-itimer):
	* itimer.el (itimer-edit-set-field):
	* itimer.el (itimer-edit-next-field):
	* itimer.el (itimer-edit-previous-field):
	Use incf, decf, plusp, minusp and the more general argument type
	checking macros.
	* lib-complete.el:
	* lib-complete.el (lib-complete:better-root): Changed to a label.
	* lib-complete.el (lib-complete:get-completion-table): Changed to
	a label.
	* lib-complete.el (read-library-internal): Include labels.
	* lib-complete.el (lib-complete:cache-completions): Changed to a
	label.
	* minibuf.el (read-buffer): Use #'set-difference, don't reinvent it.
	* newcomment.el (comment-padright): Use a label instead of
	repeating a lambda expression.
	* packages.el (package-get-key):
	* packages.el (package-get-key-1): Removed, use #'getf instead.
	* simple.el (kill-backward-chars): Removed; this isn't used.
	* simple.el (what-cursor-position):
	(lambda (arg) (format "%S" arg) -> #'prin1-to-string. 
	* simple.el (debug-print-1): Renamed to #'debug-print.
	* simple.el (debug-print): Removed, #'debug-print-1 was equivalent.
	* subr.el (integer-to-bit-vector): check-nonnegative-number no
	longer available.
	* widget.el (define-widget):
	* widget.el (define-widget-keywords): Removed, this was long obsolete.

2012-05-01  Aidan Kehoe  <kehoea@parhasard.net>

	Avoid #'delq in core code, for the sake of style and a (very
	slightly) smaller binary.

	* behavior.el (disable-behavior):
	* behavior.el (compute-behavior-group-children):
	* buff-menu.el (buffers-tab-items):
	* byte-optimize.el (byte-optimize-delay-constants-math):
	* byte-optimize.el (byte-optimize-logmumble):
	* byte-optimize.el (byte-decompile-bytecode-1):
	* byte-optimize.el (byte-optimize-lapcode):
	* bytecomp.el:
	* bytecomp.el (byte-compile-arglist-warn):
	* bytecomp.el (byte-compile-warn-about-unresolved-functions):
	* bytecomp.el (byte-compile-lambda):
	* bytecomp.el (byte-compile-out-toplevel):
	* bytecomp.el (byte-compile-insert):
	* bytecomp.el (byte-compile-defalias-warn):
	* cl-macs.el (cl-upcase-arg):
	* cl-macs.el (cl-transform-lambda):
	* cl-macs.el (cl-do-proclaim):
	* cl-macs.el (defstruct):
	* cl-macs.el (cl-make-type-test):
	* cl-macs.el (define-compiler-macro):
	* cl-macs.el (delete-duplicates):
	* cus-edit.el (widget-face-value-delete):
	* cus-edit.el (face-history):
	* easymenu.el (easy-menu-remove):
	* files.el (files-fetch-hook-value):
	* files.el (file-expand-wildcards):
	* font-lock.el (font-lock-update-removed-keyword-alist):
	* font-lock.el (font-lock-remove-keywords):
	* frame.el (frame-initialize):
	* frame.el (frame-notice-user-settings):
	* frame.el (set-frame-font):
	* frame.el (delete-other-frames):
	* frame.el (get-frame-for-buffer-noselect):
	* gnuserv.el (gnuserv-kill-buffer-function):
	* gnuserv.el (gnuserv-check-device):
	* gnuserv.el (gnuserv-kill-client):
	* gnuserv.el (gnuserv-buffer-done-1):
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* gutter-items.el (buffers-tab-items):
	* gutter.el (set-gutter-element-visible-p):
	* info.el (Info-find-file-node):
	* info.el (Info-history-add):
	* info.el (Info-build-annotation-completions):
	* info.el (Info-index):
	* info.el (Info-reannotate-node):
	* itimer.el (delete-itimer):
	* itimer.el (start-itimer):
	* lib-complete.el (lib-complete:cache-completions):
	* loadhist.el (unload-feature):
	* menubar-items.el (build-buffers-menu-internal):
	* menubar.el (delete-menu-item):
	* menubar.el (relabel-menu-item):
	* msw-font-menu.el (mswindows-reset-device-font-menus):
	* mule/make-coding-system.el (fixed-width-generate-helper):
	* next-error.el (next-error-find-buffer):
	* obsolete.el:
	* obsolete.el (find-non-ascii-charset-string):
	* obsolete.el (find-non-ascii-charset-region):
	* occur.el (multi-occur-by-filename-regexp):
	* occur.el (occur-1):
	* packages.el (packages-package-hierarchy-directory-names):
	* packages.el (package-get-key-1):
	* process.el (setenv):
	* simple.el (undo):
	* simple.el (handle-pre-motion-command-current-command-is-motion):
	* sound.el (load-sound-file):
	* wid-edit.el (widget-field-value-delete):
	* wid-edit.el (widget-checklist-match-inline):
	* wid-edit.el (widget-checklist-match-find):
	* wid-edit.el (widget-editable-list-delete-at):
	* wid-edit.el (widget-editable-list-entry-create):
	* window.el (quit-window):
	* x-font-menu.el (x-reset-device-font-menus-core):

	1. Replace (delq nil (mapcar ....)) with analogous (mapcan ...)
	forms; this is in non-dumped files, it was done previously in
	dumped files.
	2. Replace (delq FOO (copy-sequence BAR)) with (remove* FOO BAR),
	where #'eq and #'eql are equivalent
	3. Replace (delq FOO BAR) with (delete* FOO BAR), where FOO is not
	a non-fixnum number. Saves a little space in the dumped file
	(since the compiler macro adds :test #'eq to the delete* call if
	it's not clear that FOO is not a non-fixnum number).

2012-05-07  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (cl-non-fixnum-number-p): Rename, to
	cl-non-immediate-number-p. This is a little more informative as a
	name, though still not ideal, in that it will give t for some
	immediate fixnums on 64-bit builds.
	* cl-macs.el (eql):
	* cl-macs.el (define-star-compiler-macros):
	* cl-macs.el (delq):
	* cl-macs.el (remq):
	Use the new name.
	* cl-macs.el (cl-equal-equivalent-to-eq-p): New.
	* cl-macs.el (cl-car-or-pi): New.
	* cl-macs.el (cl-cdr-or-pi): New.
	* cl-macs.el (equal): New compiler macro.
	* cl-macs.el (member): New compiler macro.
	* cl-macs.el (assoc): New compiler macro.
	* cl-macs.el (rassoc): New compiler macro.
	If any of #'equal, #'member, #'assoc or #'rassoc has a constant
	argument such that #'eq, #'memq, #'assq or #'rassq, respectively,
	are equivalent, make the substitution. Relevant in files like
	ispell.el, there's a reasonable amount of code out there that
	doesn't quite get the distinction.

2012-05-01  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-optimize-form-code-walker):
	* byte-optimize.el (byte-optimize-or):
	Improve handling of for-effect here; we don't need to worry about
	discarding multiple values when for-effect is non-nil, this
	applies to both #'prog1 and #'or.
	* bytecomp.el (progn):
	* bytecomp.el (byte-compile-file-form-progn): New.
	Put back this function, since it's for-effect there's no need to
	worry about passing back multiple values.
	* cl-macs.el (cl-pop2):
	* cl-macs.el (cl-do-pop):
	* cl-macs.el (remf):
	* cl.el (pop):
	Expand to (prog1 (car-safe PLACE) (setq PLACE (cdr PLACE))) in all
	these macros, since that optimizes better (especially for-effect
	handling) when byte-compile-delete-errors is nil.

2012-04-23  Michael Sperber  <mike@xemacs.org>

	* bytecomp.el (batch-byte-recompile-directory): Accept an optional
	argument that's passed on to `byte-recompile-directory' as the
	prefix argument, thus imitating GNU Emacs's API.

2012-04-07  Aidan Kehoe  <kehoea@parhasard.net>

	Remove some utility functions from the global namespace, it's more
	appropriate to have them as labels (that is, lexically-visible
	functions.) 
	* behavior.el:
	* behavior.el (behavior-menu-filter-1): Moved to being a label.
	* behavior.el (behavior-menu-filter): Use the label.
	* cus-edit.el (custom-load-symbol-1): Moved to being a label.
	* cus-edit.el (custom-load-symbol): Use the label.
	* menubar.el (find-menu-item-1): Moved to being a label.
	* menubar.el (find-menu-item): Use the label.
	* window-xemacs.el:
	* window-xemacs.el (display-buffer-1): Moved to being a label.
	* window-xemacs.el (display-buffer): Use the label; use (block
	...) instead of (catch ...), use prog1 instead of needlessly
	binding a variable.

2012-03-02  Aidan Kehoe  <kehoea@parhasard.net>

	* select.el (select-coerce):
	Whoops, selection-coercion-alist, not selection-conversion-alist,
	thank you Philip Aston in 4F4A2CBC.1060709@mail.com .

2012-01-14  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-catch):
	Be more careful about non-quoted-symbol TAGs here; thank you
	Robert Pluim in
	CAMTcmTeLaZVrABnP-1MRUA3ZpZ=h2S_YVxKWDDNuc5bAyJD-gg@mail.gmail.com !

2012-01-08  Vin Shelton  <acs@xemacs.org>

	* cus-face.el: autoload custom-set-face-bold.

2012-01-08  Aidan Kehoe  <kehoea@parhasard.net>

	* x-init.el:
	* x-init.el (pseudo-canonicalize-keysym): New.
	* x-init.el: Move #'x-keysym-on-keyboard-sans-modifiers-p,
	#'x-keysym-on-keyboard-p here from device-x.c, some string
	manipulation it now needs to do is far easier in Lisp.
	* x-win-xfree86.el:
	* x-win-xfree86.el (x-win-init-xfree86):
	No longer call #'x-keysym-on-keyboard{,-sans-modifiers}-p,
	implement it ourselves cheaply.

2012-01-02  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (cl-compile-time-init): Add an autoload for this,
	some code supplies -no-autoloads when byte-compiling, making it
	necessary.

	* obsolete.el (cl-puthash): Put back a compatibility alias for
	this, setf-expansion of #'gethash calls it on 21.4, so it will
	occur in packages for a while to come.

2011-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (copy-symbol): Don't error with a non-list plist, as
	happens with symbols in abbrev tables.

2011-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	Call #'cl-compile-time-init explicitly here, don't rely on
	bytecomp-load-hook for what is core functionality.

	* cl-extra.el:
	* cl-extra.el (require):
	* cl-extra.el (make-random-state):
	* cl-extra.el (random-state-p):
	* cl-extra.el (make-hashtable): Removed.
	* cl-extra.el (make-weak-hashtable): Removed.
	* cl-extra.el (make-key-weak-hashtable): Removed.
	* cl-extra.el (make-value-weak-hashtable): Removed.
	* cl-extra.el ('hashtablep): Removed.
	* cl-extra.el ('hashtable-fullness): Removed.
	* cl-extra.el ('hashtable-test-function): Removed.
	* cl-extra.el ('hashtable-type): Removed.
	* cl-extra.el ('hashtable-size): Removed.
	* cl-extra.el ('copy-hashtable): Removed.
	* cl-extra.el (cl-builtin-gethash): Removed.
	* cl-extra.el (cl-builtin-remhash): Removed.
	* cl-extra.el (cl-builtin-clrhash): Removed.
	* cl-extra.el (cl-builtin-maphash): Removed.
	* cl-extra.el ('cl-gethash): Removed.
	* cl-extra.el ('cl-puthash): Removed.
	* cl-extra.el ('cl-remhash): Removed.
	* cl-extra.el ('cl-clrhash): Removed.
	* cl-extra.el ('cl-maphash): Removed.
	* cl-extra.el ('cl-make-hash-table): Removed.
	* cl-extra.el ('cl-hash-table-p): Removed.
	* cl-extra.el ('cl-hash-table-count): Removed.
	* cl-extra.el (cl-prettyexpand):
	* cl-extra.el (names):
	Remove compatibility aliases from this file.
	In #'cl-prettyexpand, if FULL is nil, don't expand return-from
	either, for symmetry with not expanding block.
	Drop cl-extra-load-hook, it's useless when cl-extra is dumped
	(since third-party code can't use it, and dumped code shouldn't
	use it.)

	* cl-macs.el:
	* cl-macs.el (cl-pop2):
	* cl-macs.el (defun*):
	* cl-macs.el (cl-parse-loop-clause):
	Remove some no-longer-needed compatibility kludges.

	* cl.el:
	* cl.el ('cl-map-extents): Removed.
	* cl.el (cl-random-time):
	* cl.el (list*): New, moved back from subr.el, given a shorter
	implementation. 
	* cl.el ('cl-member): Removed.
	* cl.el ('cl-floor): Removed.
	* cl.el ('cl-ceiling): Removed.
	* cl.el ('cl-truncate): Removed.
	* cl.el ('cl-round): Removed.
	* cl.el ('cl-mod): Removed.
	Remove some compatibility aliases; these may conflict with
	package usage, in which case the packages need to be updated, the
	new names are available in 21.4, and that's the most recent
	version we support.

	* cl.el (cl-hacked-flag): Removed.
	* cl.el (cl-hack-byte-compiler): Removed.
	* subr.el:
	* subr.el (list*): Moved back to cl.el.

	* update-elc-2.el (batch-update-elc-2):
	* update-elc.el (do-autoload-commands):
	Add an autoload for cl-compile-time-init in these two files, they
	run on bare temacs, auto-autoload isn't available to them, and now
	bytecomp calls cl-compile-time-init explicitly.

	* cl-compat.el: Removed. This file was long obsolete.

2011-12-27  Didier Verna  <didier@xemacs.org>

	* cl-macs.el (face-foreback): New defsetf.
	* faces.el (set-face-property): Document the foreback property.
	* faces.el (face-foreback):
	* faces.el (face-foreback-instance):
	* faces.el (face-foreback-name):
	* faces.el (set-face-foreback): New functions.
	* faces.el (face-equal):
	* faces.el (init-other-random-faces):
	* cus-face.el (custom-face-attributes):
	* x-faces.el (x-init-face-from-resources): Handle the foreback
	property.

2011-12-27  Didier Verna  <didier@xemacs.org>

	* faces.el (face-foreground-name): Fix docstring typo.

2011-12-27  Didier Verna  <didier@xemacs.org>

	* faces.el: Explicitely set the 'zmacs-region face to not shrink
	so as to override a shrink setting for a face under it (during
	face merging).

2011-12-27  Didier Verna  <didier@xemacs.org>

	* wid-edit.el (widget-field-face): Set this face to shrink. Fix
	incorrect specification.

2011-12-26  Didier Verna  <didier@xemacs.org>

	* cl-macs.el (face-flush-p): Removed.
	* cl-macs.el (face-shrink-p): New.
	* faces.el (face-flush-p): Removed.
	* faces.el (face-shrink-p): New.
	* faces.el (set-face-flush-p): Removed.
	* faces.el (set-face-shrink-p): New.
	* cus-face.el (custom-face-attributes):
	* faces.el (set-face-property):
	* faces.el (face-equal):
	* x-faces.el (x-init-face-from-resources):
	* x-faces.el (make-face-x-resource-internal): Replace the 'flush
	property with the opposite 'shrink one.

2011-12-23  Aidan Kehoe  <kehoea@parhasard.net>

	* select.el (activate-region-as-selection):
	* select.el (select-make-extent-for-selection):
	* select.el (select-convert-in):
	* select.el (select-convert-out):
	* select.el (select-coerce):
	* select.el (select-convert-to-targets):
	Improve Lisp style in a few places here; don't re-implement
	#'delete-duplicates, use #'funcall instead of consing up a list to
	pass to #'apply.

2011-12-23  Didier Verna  <didier@xemacs.org>

	* cl-macs.el (face-flush-p): New defsetf.
	* faces.el (set-face-property): Document the flush property.
	* faces.el (face-flush-p): New function.
	* faces.el (set-face-flush-p): New function.
	* faces.el (face-equal):
	* cus-face.el (custom-face-attributes):
	* x-faces.el (x-init-face-from-resources):
	* x-faces.el (make-face-x-resource-internal): Handle the flush
	property.

2011-12-22  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp-runtime.el:
	* bytecomp-runtime.el (byte-compile-macro-environment): Moved to
	eval.c.
	* cl.el:
	* cl.el ('cl-macroexpand): New alias.
	* cl.el ('macroexpand-internal): New alias.
	* cl.el (cl-macroexpand): Move the functionality of this to
	#'macroexpand (formerly #'macroexpand-internal) in eval.c; since
	CL is always loaded in XEmacs, it brings nothing and slows things
	down to have the two functions separate.

2011-12-21  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-transform-function-property):
	Call #'cl-macroexpand-all when doing this, avoiding unpleasantness
	with defsetf and lexical variables.
	* cl-macs.el (assert):
	The previous change meant #'remove-if isn't necessarily available
	yet; use the :key argument with #'remove* instead.

2011-12-10  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-cmds.el (posix-charset-to-coding-system-hash):
	Correct the docstring for this variable.

2011-12-13  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-eval):
	When evaluating code at compile time, don't put those macros in
	the macro environment that only make sense when creating
	byte-compiled output.

2011-12-13  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-initial-macro-environment):
	If lexical let has played with our lambas, give up on constructing
	the compiled functions at compiled time, that strategy doesn't
	work.

2011-12-09  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (load-time-value):
	Clarify the docstring here, thanks for pointing out its inaccuracy
	Julian Bradfield.

2011-11-14  Vin Shelton  <acs@xemacs.org>

	* faces.el: When the default background was changed from light to
	dark or vice versa, the custom-property cache maintained the old
	value, preventing face definitions from choosing the proper
	values.  Patch from Aidan Kehoe.

2011-11-09  Aidan Kehoe  <kehoea@parhasard.net>

	* help.el (describe-function-1):
	When printing compiled functions, mention whether they're
	built-in.

2011-11-02  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-lambda):
	Accept a new NAME argument here, have byte-compile-current-form
	reflect that if it's specified. 
	* bytecomp.el (byte-compile-initial-macro-environment):
	Specify the label name when byte-compiling it, so warning and
	errors are more helpful.

2011-10-17  Aidan Kehoe  <kehoea@parhasard.net>

	* startup.el (load-terminal-library):
	Don't (getenv "TERM") here, call #'console-tty-terminal-type
	instead, different gnuclient consoles can and should have
	different terminal type function maps effective.

2011-10-09  Aidan Kehoe  <kehoea@parhasard.net>

	* obsolete.el:
	* obsolete.el (assq-delete-all):
	* packages.el (package-provide):
	* packages.el (package-suppress):
	* mule/cyrillic.el ("Cyrillic-KOI8"):
	* mule/cyrillic.el (koi8-u):
	* mule/general-late.el (posix-charset-to-coding-system-hash):
	* mule/latin.el:
	* mule/latin.el (for):
	* cl-extra.el:
	* cl-extra.el (cl-extra):
	* loadup.el (load-history):
	Change any uses of #'remassq, #'remassoc and friends to calling
	#'delete* with an appropriate key argument. Provide compatibility
	implementations, mark them obsolete.

2011-10-08  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (load-time-value):
	* cl-macs.el (flet):
	* cl-macs.el (labels):
	* cl-macs.el (the):
	* cl-macs.el (declare):
	Move all these macros to the end of the file, since they're in
	byte-compile-initial-macro-environment, and we don't want their
	definitions to override that for the rest of the file during
	byte-compilation. Happens not to matter right now, but avoids
	surprises for anyone using the macros elsewhere in cl-macs down
	the line.

2011-10-08  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-initial-macro-environment):
	In the compiler implementation of load-time-value, don't
	byte-compile at macroexpansion time, delay that until
	byte-compilation time, giving, e.g. labels a chance to do its
	thing.

2011-10-04  Aidan Kehoe  <kehoea@parhasard.net>

	* autoload.el (make-autoload):
	Don't add arglist info to the autoload form's docstring if the
	arglist info is already there.

2011-10-04  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-funcall):
	Correct a comment here, explaining why the optimizer doesn't
	expand (funcall #'(lambda ...)) in some contexts with inline
	labels, and why it's reasonable to do it here.

2011-10-03  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (handle-pre-motion-command-current-command-is-motion):
	Implement #'keysyms-equal with #'labels + (declare (inline ...)),
	instead of abusing macrolet to the same end.
	* specifier.el (let-specifier):
	* mule/mule-cmds.el (describe-language-environment):
	* mule/mule-cmds.el (set-language-environment-coding-systems):
	* mule/mule-x-init.el (x-use-halfwidth-roman-font):
	* faces.el (Face-frob-property):
	* keymap.el (key-sequence-list-description):
	* lisp-mode.el (construct-lisp-mode-menu):
	* loadhist.el (unload-feature):
	* mouse.el (default-mouse-track-check-for-activation):
	Declare various labels inline in dumped files when that reduces
	the size of the dumped image. Declaring labels inline is normally
	only worthwhile for inner loops and so on, but it's reasonable
	exercise of the related code to have these changes in core.

2011-10-03  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-funcall):
	Sometimes the optimizer shirks its responsibility and doesn't
	unfold a lambda when it should. Do this here, if optimization is
	turned on; this makes inlining labels more consistent and
	trustworthy.

2011-10-02  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-initial-macro-environment):
	Add #'declare to this, so it doesn't need to rely on
	#'cl-compiling file to determine when we're byte-compiling.
	Update #'labels to support declaring labels inline, as Common Lisp
	requires.
	* bytecomp.el (byte-compile-function-form):
	Don't error if FUNCTION is quoting a non-lambda, non-symbol, just
	return it.
	* cl-extra.el (cl-macroexpand-all):
	If a label name has been quoted, expand to the label placeholder
	quoted with 'function. This allows the byte compiler to
	distinguish between uses of the placeholder as data and uses in
	contexts where it should be inlined.
	* cl-macs.el:
	* cl-macs.el (cl-do-proclaim):
	When proclaming something as inline, if it is bound as a label,
	don't modify the symbol's plist; instead, treat the first element
	of its placeholder constant vector as a place to store compile
	information.
	* cl-macs.el (declare):
	Leave processing declarations while compiling to the
	implementation of #'declare in
	byte-compile-initial-macro-environment.

2011-09-25  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el (binary-file-regexps):
	Remove ELC files from this, many of them are escape-quoted, and
	when opening them for viewing XEmacs should look at the coding
	cookie and respect that.
	* bytecomp.el (byte-compile-insert-header):
	Always insert a coding cookie, now ELC files are no longer in
	binary-file-regexps.

2011-09-21  Aidan Kehoe  <kehoea@parhasard.net>

	* files.el (binary-file-regexps):
	Update this, adding everything that maps to no-conversion or
	no-conversion-multibyte in GNU's auto-mode-alist.
	In particular, add PDFs, important given gnus' problem with them
	of http://mid.xemacs.org/m3r637lpm5.fsf@mikesoffice.com and the
	associated thread, and Uwe's recent re-reporting of the same
	problem.

2011-09-21  Aidan Kehoe  <kehoea@parhasard.net>

	* select.el (select-convert-to-text):
	* select.el (select-convert-to-utf-8-text):
	Ignore extent information in these functions, other programs can't
	do anything useful with it, and it actively interferes when
	copying from an ERC buffer to external programs--
	#'encode-coding-string complains that the string is read-only,
	which is arguably in itself a separate problem, since it allocates
	a new string there's no reason for it ever to throw that error.

2011-09-11  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-defsubst-expand):
	Be more careful still here, make sure that any references to
	variables in BODY don't access those values in the enclosing scope
	when that would be inappropriate.
	Add some documentation of a potential reasonable approach to
	avoiding the problems with our (non-Common Lisp-conformant)
	#'symbol-macrolet.

2011-09-10  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-defsubst-expand):
	Change set 2a6a8da4dd7c of
	http://mid.xemacs.org/19966.17522.332164.615228@parhasard.net
	wasn't sufficiently comprehensive, symbol macros can be mutually
	rather than simply recursive, and they can equally hang. Thanks
	for the bug report, Michael Sperber, and for the test case,
	Stephen Turnbull.

2011-09-09  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-from-buffer):
	If compiling a form has changed the current buffer (that is, some
	eval-when-compile form hasn't done save-excursion when
	appropriate), error and exit; we can't guarantee we'll give useful
	code in that context. See
	http://mid.xemacs.org/20110909110831.GD2875@acm.acm and related
	discussion. 

2011-09-07  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (transpose-subr):
	* specifier.el (let-specifier):
	* specifier.el (derive-device-type-from-tag-set):
	* test-harness.el (batch-test-emacs):
	* x-compose.el (alias-colon-to-doublequote):
	* mule/chinese.el (make-chinese-cns11643-charset):
	* mule/mule-cmds.el (set-locale-for-language-environment):
	* mule/mule-cmds.el (set-language-environment-coding-systems):
	* mule/mule-x-init.el (x-use-halfwidth-roman-font):
	* about.el (about-xemacs):
	* about.el (about-hackers):
	* diagnose.el (show-memory-usage):
	* diagnose.el (show-object-memory-usage-stats):
	* diagnose.el (show-mc-alloc-memory-usage):
	* diagnose.el (show-gc-stats):
	* dialog.el (make-dialog-box):
	* faces.el:
	* faces.el (Face-frob-property):
	* faces.el (set-face-stipple):
	* glyphs.el:
	* glyphs.el (init-glyphs): Removed.
	* help-macro.el (make-help-screen):
	* info.el (Info-construct-menu):
	* keymap.el (key-sequence-list-description):
	* lisp-mode.el (construct-lisp-mode-menu):
	* loadhist.el (unload-feature):
	* minibuf.el (get-user-response):
	* mouse.el (default-mouse-track-check-for-activation):
	* mouse.el (mouse-track-insert-1):
	Follow my own advice from the last commit and use #'labels instead
	of #'flet in core code.

2011-09-07  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (for-effect): Move this earlier in the file, it's
	referenced in byte-compile-initial-macro-environment.
	* bytecomp.el (byte-compile-initial-macro-environment):
	In the byte-compile-macro-environment definition for #'labels, put
	off the compiling the lambda bodies until the point where the rest
	of the form is being compiled, allowing the lambda bodies to
	access appropriate values for byte-compile-bound-variables, and
	reducing excessive warning about free variables.

	Add a byte-compile-macro-environment definition for #'flet. This
	modifies byte-compile-function-environment appropriately, and
	warns about bindings of functions that have macro definitions in
	the current environment, about functions that have byte codes, and
	about functions that have byte-compile methods (which may not do
	what the user wants at runtime).
	* bytecomp.el (byte-compile-funcall):
	If FUNCTION is constant, call #'byte-compile-callargs-warn if
	that's appropriate, giving warnings about problems with calling
	functions bound with #'labels.

	* cl-macs.el:
	* cl-macs.el (flet):
	Mention the main difference from Common Lisp, that the bindings
	are dynamic, not lexical. Counsel the use of #'labels, not #'flet,
	for this and other reasons. Explain the limited single use case for
	#'flet. Cross-reference to bytecomp.el in a comment.
	* cl-macs.el (labels):
	Go into detail on which functions may be called from
	where. Explain how to access the function definition of a label
	within FORM. Add a comment cross-referencing to bytecomp.el.

2011-09-06  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-cmds.el (set-language-environment-coding-systems):
	Set the input mode for TTY consoles to use the eighth bit for
	character information if the native coding system for the language
	environment needs that.

2011-09-04  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp-runtime.el:
	* bytecomp-runtime.el (byte-compile-macro-environment): Moved from
	bytecomp.el.
	* bytecomp.el:
	* bytecomp.el (byte-compile-initial-macro-environment):
	Add implementations for #'load-time-value, #'labels here, now
	cl-macs respects byte-compile-macro-environment.
	* bytecomp.el (byte-compile-function-environment):
	* bytecomp.el (byte-compile-macro-environment): Removed.
	* bytecomp.el (symbol-value):
	* bytecomp.el (byte-compile-symbol-value): Removed.
	* cl-extra.el (cl-macroexpand-all):
	* cl-macs.el:
	* cl-macs.el (bind-block):
	* cl-macs.el (cl-macro-environment): Removed.
	* cl-macs.el (cl-transform-lambda):
	* cl-macs.el (load-time-value):
	* cl-macs.el (block):
	* cl-macs.el (flet):
	* cl-macs.el (labels):
	* cl-macs.el (macrolet):
	* cl-macs.el (symbol-macrolet):
	* cl-macs.el (lexical-let):
	* cl-macs.el (apply):
	* cl-macs.el (nthcdr):
	* cl-macs.el (getf):
	* cl-macs.el (substring):
	* cl-macs.el (values):
	* cl-macs.el (get-setf-method):
	* cl-macs.el (cl-setf-do-modify):
	* cl.el:
	* cl.el (cl-macro-environment): Removed.
	* cl.el (cl-macroexpand):
	* obsolete.el (cl-macro-environment): Moved here.

	Drop cl-macro-environment, in favour of
	byte-compile-macro-environment; make the latter available in
	bytecomp-runtime.el. This makes byte-compile-macro-environment far
	less useless, since previously code that used cl-macs would ignore
	it when calling #'cl-macroexpand-all.

	Add byte-compiler-specific implementations for #'load-time-value,
	#'labels. The latter is very nice indeed; it avoids the run-time
	consing of the current implementation, is fully lexical and avoids
	the run-time shadowing of symbol function slots that flet uses. It
	would now be reasonable to move most core uses of flet to use
	labels instead. Non-core code can't rely on print-circle for
	mutually recursive functions, though, so it's less of an evident
	win.

2011-09-04  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (get-char-table): Add a defsetf for this.

2011-09-04  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-output-file-form):
	* bytecomp.el (byte-compile-output-docform):
	Bind print-circle, print-continuous-numbering in these functions,
	now those variables are available.
	* lisp.el (forward-sexp):
	* lisp.el (backward-sexp):
	Recognise leading #N= as being part of an expression.

2011-08-24  Aidan Kehoe  <kehoea@parhasard.net>

	* process.el (shell-command-on-region):
	Correct typo from the merge, nnot -> not.

2011-08-24  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (apply-partially):
	Add an assertion to this compiler macro, requiring that the order
	of the placeholders corresponding to the arguments in the
	constants vector of the constructed compiled function be the same
	as the order of the arguments to #'apply-partially.

2011-08-12  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (apply-partially): New compiler macro.
	* subr.el:
	* subr.el (apply-partially): New.
	Sync this function's API and docstring from GNU. The
	implementation is mine and trivial; the compiler macro in
	cl-macs.el ensures that partially-applied functions in compiled
	code are also compiled.

2011-08-10  Aidan Kehoe  <kehoea@parhasard.net>

	* keymap.el:
	* keymap.el (event-apply-alt-modifier):
	* keymap.el (event-apply-super-modifier):
	* keymap.el (event-apply-hyper-modifier):
	* keymap.el (event-apply-shift-modifier):
	* keymap.el (event-apply-control-modifier):
	* keymap.el (event-apply-meta-modifier):
	* keymap.el (event-apply-modifiers): New.
	* keymap.el (event-apply-modifier): Implement in terms of
	#'event-apply-modifier.

	Rework #'event-apply-modifier to take a list of modifiers, and
	change its name appropriately. Keep the old name around, too.

2011-08-10  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-normal-call):
	When a function takes :if, :if-not, :test, :test-not or :key
	arguments, do the quoted-lambda check there too.

2011-08-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* test-harness.el (test-harness-bug-expected):
	Update docstring.
	(Known-Bug-Expect-Failure, Known-Bug-Expect-Error):
	Ask if bug was fixed in PASS message.
	(Known-Bug-Expect-Error):
	Simplify code to produce clearer output.
	Make pass and failure correspond to Check-Error.
	(Print-Pass):
	Always print test result for known bugs.

2011-07-29  Mats Lidell  <matsl@xemacs.org>

	* process.el (shell-command): 
	* process.el (shell-command-on-region): API compatible/synced with
	FSF 23.3.1.

2011-07-22  Mats Lidell  <matsl@xemacs.or>

	* syntax-ppss.el: Synced up with Emacs 23.3 (syntax.el)

2011-07-03  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el (cl-macroexpand):
	Allow code to disable a given symbol macro while expanding code by
	prepending a cons with a nil cdr to the macro environment.

2011-06-25  Aidan Kehoe  <kehoea@parhasard.net>

	* gtk-init.el:
	* gtk-init.el (make-device-late-gtk-entry-point):
	* gtk-init.el (gtk-initialize-compose): Removed.
	* keymap.el:
	* keymap.el (function-key-map-parent):
	* x-init.el (x-initialize-compose): Removed.
	* x-init.el (make-device-late-x-entry-point):
	Make the bindings for dead-acute and friends in
	function-key-map-parent, rather than function-key-map; do this in
	keymap.el rather than in window-system-specific code, since the
	compose processing is generally useful and not X11-specific.
	It's probably reasonable to rename x-compose.el to compose.el at
	this point, but I haven't done that.

2011-06-23  Didier Verna  <didier@xemacs.org>

	From smitchel <smitchel@bnin.net>
	* frame.el (get-other-frame): Add missing first argument THIS to
	the call to NEXT-FRAME.

2011-06-24  Aidan Kehoe  <kehoea@parhasard.net>

	* view-less.el (view):
	Add a custom group to this file, so view-mode-line-string has an
	associated custom group automatically.

2011-06-19  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-defsubst-expand):
	It is occasionally the case that the symbol naming the argument
	co-incides with the value that it is replacing; in that case,
	using the symbol macro is counterproductive and hangs XEmacs (as
	does analogous code in SBCL), so don't.

2011-06-19  Aidan Kehoe  <kehoea@parhasard.net>

	* behavior.el (enable-behavior):
	* behavior.el (disable-behavior):
	Remove a couple of redundant lambdas here, and remove a cond
	clause that was never tripped (because nil is a list.)
	* behavior.el (behavior-menu-filter):
	Correct some indentation here.

2011-06-19  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (defsubst*):
	* cl-macs.el (cl-defsubst-expand):
	If defaults refer to earlier args, or if there's a &rest arg, use
	#'proclaim-inline.
	Use #'symbol-macrolet instead of #'subst when replacing argument
	names with their values in the inline expansion; this avoids
	(most) instances where the symbol's function slot is used.
	Document a bug that occurs if the symbol is being shadowed in a
	lexically-contained scope.

2011-06-19  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (assoc-ignore-case, assoc-ignore-representation):
	* cl-macs.el (member-ignore-case): New compiler macros.
	* subr.el (assoc-ignore-case):
	* subr.el (assoc-ignore-representation):
	* subr.el (member-ignore-case):
	* subr.el (split-path):
	* subr.el (delete-dups):
	Reimplement a few GNU functions in terms of their CL counterparts,
	for the sake of circularity checking and some speed; add type
	checking (used in interpreted code and with low speed and safety
	checking) for the sake of revealing incompatibilities when
	developing.
	* subr.el (remove-hook):
	There's no need for flet here, an explicit lambda is enough.

2011-06-04  Aidan Kehoe  <kehoea@parhasard.net>

	* gutter-items.el (add-tab-to-gutter):
	* toolbar-items.el (toolbar-add-item-data):
	Switch to #'dolist instead of #'mapcar in a couple of places where
	the result isn't used. (Committed now mostly to trigger a commit
	mail so Mats' buildbot gets woken up.)

2011-05-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-transform-lambda):
	Move the code to decide whether to add argument information to the
	docstring a little later, so the information about what the
	function's docstring ends up being is a little more exact.

2011-05-27  Aidan Kehoe  <kehoea@parhasard.net>

	* modeline.el (make-modeline-command-wrapper):
	Be more reasonable about the implementation of this wrapper, don't
	require that the value of COMMAND be available at macro-expansion
	time. (Basically, implement a closure.)
	* modeline.el (add-minor-mode):
	Remove a workaround and misguided comment that are no longer
	necessary or exact.

2011-05-25  Didier Verna  <didier@xemacs.org>

	* cl-macs.el (macrolet):
	* cl-macs.el (symbol-macrolet): Don't require one mandatory
	[symbol-]macro definition in the first argument. The Common Lisp
	standard allows the list of definitions to be empty.

2011-05-18  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (bind-inits)): Removed.
	* cl-macs.el (defun*):
	* cl-macs.el (defmacro*):
	* cl-macs.el (function*):
	* cl-macs.el (macrolet):
	* cl-macs.el (cl-transform-function-property):
	* cl-macs.el (destructuring-bind):
	Remove `bind-inits' from this file, and only ever return nil as
	the first element of cl-transform-lambda's result list; bind-inits
	hasn't been used since the support for non-self-quoting keywords
	was removed, and its absence (and the guarantee that the first
	element of the result of cl-transform-lambda is nil) make the
	implementations of various other macros easier and clearer.
	* cl-macs.el (cl-transform-lambda):
	Give this function a docstring.

2011-05-07  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp-runtime.el:
	* bytecomp.el (byte-compile-file-form-defmumble):
	* bytecomp-runtime.el (macro-declaration-function): New.
	* subr.el:
	* subr.el (macro-declaration-function): Removed.
	Add support for macro-declaration-function, which is a GNU
	mechanism for indicating indentation and edebug information in
	macros (and only in macros).

2011-05-07  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el:
	* subr.el (split-path): New.
	Moved here from fns.c. There's no need to have this in C, it's no
	longer used that early at startup.

2011-05-07  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (byte-compile-two-args-19->20): Removed.
	* bytecomp.el (byte-compile-emacs19-compatibility): Removed.
	* bytecomp.el (byte-defop-compiler20): Removed.
	* bytecomp.el (byte-defop-compiler-rmsfun): Removed.
	* bytecomp.el (emacs-lisp-file-regexp):
	* bytecomp.el (byte-compile-print-gensym):
	* bytecomp.el (byte-compiler-legal-options):
	* bytecomp.el (byte-compiler-obsolete-options):
	* bytecomp.el (byte-compile-close-variables):
	* bytecomp.el (byte-compile-insert-header):
	* bytecomp.el (byte-compile-output-file-form):
	* bytecomp.el (byte-compile-output-docform):
	* bytecomp.el (byte-compile-out-toplevel):
	* bytecomp.el (byte-compile-form):
	* bytecomp.el (byte-defop-compiler-1):
	* bytecomp.el (eq):
	* bytecomp.el (equal):
	* bytecomp.el (member):
	* bytecomp.el (byte-compile-noop):
	* bytecomp.el (byte-compile-save-current-buffer):
	Remove support for generating code appropriate to Emacs 19.

	* bytecomp.el (byte-compile-eval):
	Avoid erroring here if the car of some entry in the macro
	environment is not a symbol, as is the case for symbol macros.
	* bytecomp.el (or):
	Use slightly better style when compiling the most important
	functions if bytecomp.el has just been loaded interpreted.

2011-05-07  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el:
	* byte-optimize.el (byte-optimize-form-code-walker):
	Call #'byte-optimize-side-effect-free-p on the form, rather than
	just checking the plist of the form's car.
	* byte-optimize.el (side-effect-free-fns):
	Move the CL functions into their alphabetical place in the list.
	* byte-optimize.el (function):
	* byte-optimize.el (byte-optimize-side-effect-free-p): New.
	Function returning non-nil if a funcall has no side-effects, which
	handles things like (remove* item list :key 'car) and
	(remove-if-not #'integerp list).

2011-05-06  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (most-positive-fixnum-on-32-bit-machines):
	Correct this, I had an off-by-one error (because I was developing
	on a 64-bit machine). Thanks for the report, Raymond Toy!

2011-05-01  Aidan Kehoe  <kehoea@parhasard.net>

	* buff-menu.el (list-buffers-directory):
	* buff-menu.el (default-list-buffers-identification):
	* cus-file.el (custom-file-base):
	* cus-file.el (custom-file):
	* cus-file.el (make-custom-file-name):
	* menubar.el (menu-split-long-menu):
	* newcomment.el:
	* newcomment.el (indent-for-comment):
	* newcomment.el (comment-column):
	* newcomment.el (comment-start):
	* newcomment.el (comment-start-skip):
	* newcomment.el (comment-end-skip):
	* newcomment.el (comment-end):
	* newcomment.el (comment-indent-function):
	* newcomment.el (comment-style):
	* newcomment.el (comment-padding):
	* newcomment.el (comment-multi-line):
	* newcomment.el (comment-normalize-vars):
	* newcomment.el (comment-indent):
	* newcomment.el (comment-set-column):
	* newcomment.el (comment-kill):
	* newcomment.el (uncomment-region):
	* newcomment.el (comment-region):
	* newcomment.el (comment-or-uncomment-region):
	* newcomment.el (comment-dwim):
	* newcomment.el (comment-indent-new-line):
	* x-win-sun.el (x-win-init-sun):
	* x-win-xfree86.el (x-win-init-xfree86):
	* mule/mule-composite.el:
	* mule/mule-composite.el (reference-point-alist):
	* mule/mule-composite.el (compose-region):
	* mule/mule-composite.el (decompose-region):
	* mule/mule-composite.el (compose-string):
	* mule/mule-composite.el (decompose-string):
	* mule/mule-composite.el (compose-chars):
	* mule/mule-composite.el (find-composition):
	* mule/mule-composite.el (compose-chars-after):
	* mule/mule-composite.el (compose-last-chars):
	* mule/mule-composite.el (decompose-composite-char):
	Remove all autoload cookies from dumped files, they're needless
	and confusing.

2011-04-30  Didier Verna  <didier@xemacs.org>

	* subr.el (looking-back): New function.

2011-04-30  Didier Verna  <didier@xemacs.org>

	* special-mode.el: New file.
	* special-mode.el (special-mode-map): New variable.
	* special-mode.el (special-mode): New function.
	* dumped-lisp.el (preloaded-file-list): Add special-mode.

2011-04-30  Stephen J. Turnbull  <stephen@xemacs.org>

	* faces.el (face-property-matching-instance):
	Allow backward compatibility to the 21.4 API.  Update docstring.

2011-04-29  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.31 "ginger" is released.

2011-04-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.30 "garlic" is released.

2011-04-24  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (symbol-macrolet):
	* cl-macs.el (lexical-let):
	* cl.el:
	* cl.el (cl-macroexpand):
	Distinct symbol macros with identical string names should
	nonetheless expand to different things; implement this, storing
	the symbol's eq-hash in the macro environment, rather than its
	string name.

2011-04-23  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (define-char-comparisons):
	Add type-checking when the various character-specific comparison
	predicates are used; don't check types if
	byte-compile-delete-errors is non-nil at compile-time, instead use
	the corresponding built-in numeric byte codes.

2011-04-23  Aidan Kehoe  <kehoea@parhasard.net>

	* font.el:
	* font.el (font-warn): Removed.
	* font.el (font-hex-string-to-number): Removed.
	* font.el (internal-facep):
	* font.el (font-lookup-rgb-components):
	* font.el (font-parse-rgb-components):
	Use #'string-to-number with the BASE argument instead of
	#'font-hex-string-to-number, #'display-warning instead of
	#'font-warn.
	This entire file smells bitrotted, with lots of functions of very
	little relevance to XEmacs, but addressing that is more work than
	I can do today.

2011-04-17  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el:
	* cl-extra.el ('char<): New.
	* cl-extra.el ('char>=): New.
	* cl-extra.el ('char>): New.
	* cl-extra.el ('char<=): New.
	* cl-extra.el (alpha-char-p): New.
	* cl-extra.el (graphic-char-p): New.
	* cl-extra.el (standard-char-p): New.
	* cl-extra.el (char-name): New.
	* cl-extra.el (name-char): New.
	* cl-extra.el (upper-case-p): New.
	* cl-extra.el (lower-case-p): New.
	* cl-extra.el (both-case-p): New.
	* cl-extra.el (char-upcase): New.
	* cl-extra.el (char-downcase): New.
	* cl-extra.el (integer-length): New.
	Add various functions dealing (mainly) with characters, making
	some Common Lisp code easier to port.
	* descr-text.el (describe-char-unicode-data):
	Add an autoload for this function, used by #'char-name.

2011-04-12  Aidan Kehoe  <kehoea@parhasard.net>

	* mule/mule-win32-init.el (windows-874):
	No longer create this coding system, now it's provided by thai.el;
	thanks for the report of the associated Win32 build problem, Mats!

2011-04-08  Aidan Kehoe  <kehoea@parhasard.net>

	* unicode.el (load-unicode-tables):
	No longer include thai-xtis in the default Unicode precedence list.
	* mule/thai.el:
	* mule/thai.el (tis-620):
	* mule/thai.el (windows-874):
	* mule/thai.el ("Thai"):
	Move the Thai language environment and the TIS-620 coding system
	to this file; add support for Microsoft's code page 874.
	* mule/thai-util.el:
	* mule/thai-xtis.el:
	Remove these two files; XTIS was always non-standard and was never
	widely implemented, and we've never supported the character
	composition necessary for thai-util.el.
	* dumped-lisp.el (preloaded-file-list):
	Drop thai-xtis, dump thai.el instead.

2011-04-02  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el (cadr, caddr, cadddr):
	Document some equivalences for these functions.

2011-04-02  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-output-preface): New.
	* bytecomp.el (byte-compile-output-file-form):
	* bytecomp.el (byte-compile-output-docform):
	* bytecomp.el (byte-compile-file-form):
	* bytecomp.el (byte-compile-file-form-defmumble):
	* bytecomp.el (symbol-value):
	* bytecomp.el (byte-compile-symbol-value): New.
	* cl-macs.el (load-time-value):
	No longer implement load-time-value by very hackishly redefining
	#'byte-compile-file-form-defmumble, instead make the appropriate
	changes in #'byte-compile-file-form-defmumble and
	#'byte-compile-file-form instead. We also add a specific byte-compile
	method for #'symbol-value, using the add-properties-to-a-gensym
	approach that worked for #'block and #'return-from.

2011-03-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (cl-finite-do, cl-float-limits):
	Don't make these available as functions in the dumped image, since
	they're only called at dump time.
	* obsolete.el (cl-float-limits):
	Make this an alias to #'identity (since it's called at dump time),
	mark it as obsolete in 21.5.

2011-03-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el:
	* cl.el (least-positive-float):
	* cl.el (least-positive-normalized-float):
	* cl.el (least-negative-normalized-float):
	* cl.el (float-epsilon):
	* cl.el (float-negative-epsilon):
	Document some previously-undocumented float constants here.
	* cl.el (oddp):
	* cl.el (evenp):
	Change numeric comparison to use #'eql instead of #'eq in
	passing.

2011-03-24  Jerry James  <james@xemacs.org>

	* cl-macs.el (loop): "arbitary" -> "arbitrary".
	* coding.el (force-coding-system-equivalency): "compatiblity" ->
	"compatibility".
	* cus-edit.el (custom-variable-pre-reset-standard): "explictly" ->
	"explicitly" and fix grammar.
	(custom-face-pre-reset-standard): "explictly" -> "explicitly".
	* etags.el (pop-tag-mark): "seperate" -> "separate".
	* files.el (make-temp-file): "analagous" -> "analogous".
	* font-menu.el (font-menu-ignore-scaled-fonts): "noticably" ->
	"noticeably".
	* fontconfig.el (fc-pattern-get-or-compute-size): "unsucessful" ->
	"unsuccessful".
	* gnome-widgets.el: "writen" -> "written", "choosed" -> "chosen",
	"existance" -> "existence".
	* gtk-ffi.el (gtk-ffi-debug): "wiht" -> "with".
	* gtk-widgets.el: "wil" -> "will", "occure" -> "occur", "efficent" ->
	"efficient", "mannor" -> "manner", "negitive" -> "negative",
	"particulary" -> "particularly".
	* info.el (Info-suffixed-file): "independantly" -> "independently".
	* minibuf.el (minibuffer): "Controling" -> "Controlling".
	* mule/ccl.el (define-ccl-program): "correponding" -> "corresponding".
	* mule/indian.el: "apperance" -> "appearance" and correct grammar.
	* mule/kinsoku.el (kinsoku-process-extend): "permissable" ->
	"permissible", "deliberatly" -> "deliberately", and correct grammar.
	(kinsoku-process-shrink): "permissable" -> "permissible".
	* mule/lao-util.el (lao-vowel-reordering-rule): "follwoing" ->
	"following", "alwasy" -> "always".
	(lao-transcribe-single-roman-syllable-to-lao): "beggining" ->
	"beginning".
	* mule/latin.el: "idiosyncracy" -> "idiosyncrasy".
	* mule/thai-util.el: "repetion" -> "repetition".
	* package-get.el (package-get-require-base): "explictly" ->
	"explicitly".
	* packages.el (packages-find-package-data-path): "hierachies" ->
	"hierarchies".
	* paragraphs.el (use-hard-newlines): "preceeding" -> "preceding".
	* startup.el (command-line): "intial" -> "initial".
	* toolbar-itmes.el (toolbar-news): "Unkown" -> "Unknown".

2011-03-24  Aidan Kehoe  <kehoea@parhasard.net>

	* custom.el (custom-add-to-group):
	Warn if adding an option to the nil group; this is usually an
	error on the part of the programmer.
	* cmdloop.el (suggest-key-bindings):
	Specify a group for this variable, it didn't previously have one.

2011-03-21  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (revappend, nreconc):
	Add compiler macros for these two functions. (They used to be
	inline, but that involves needless binding of the arguments.)

2011-03-21  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-non-fixnum-number-p):
	This should return t under 64-bit builds for fixnums that would
	be bignums on a 32-bit machine; make it so.

2011-03-19  Stephen J. Turnbull  <stephen@xemacs.org>

	* faces.el (face-spec-set-match-display):
	Protect against `display-color-cells' returning nil.
	Delete unreferenced let-binding of `min-colors'.

2011-03-17  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-catch):
	* bytecomp.el (byte-compile-throw):
	Correct some minor problems in my last change. Happy St. Patrick's
	day, everyone!

2011-03-17  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-catch):
	* bytecomp.el (byte-compile-throw):
	* cl-macs.el (return-from):
	With `block' and `return-from', a nil NAME is perfectly
	legitimate, and the corresponding `catch' statements need be
	removed by the byte-compiler. 5dd1ba5e0113 , my change of
	2011-02-12, didn't do this; correct that now.

2011-03-15  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	Don't generate the old-eq, old-memq, old-equal bytecodes any more,
	but keep the information about them around for the sake of the
	disassembler.

2011-03-14  Jeff Sparkes  <jsparkes@gmail.com>

	* custom.el (defface): Document `min-colors' specifier.

	* faces.el (face-spec-set-match-display): Add `min-colors'
	specifer for defface.

2011-03-12  Aidan Kehoe  <kehoea@parhasard.net>

	* isearch-mode.el (isearch-mode-map):
	Document why we bind the ASCII characters to isearch-printing-char
	in more detail.
	* isearch-mode.el (isearch-maybe-frob-keyboard-macros):
	If `this-command' is nil and the keys typed would normally be
	bound to `self-insert-command' in the global map, force
	`isearch-printing-char' to be called with an appropriate value for
	last-command-event. Addresses an issue where searching for
	characters generated from x-compose.el and XIM threw errors for me
	in dired.

2011-03-10  Aidan Kehoe  <kehoea@parhasard.net>

	* etags.el (buffer-tag-table-list):
	* files.el (find-file-read-only):
	* files.el (find-file-read-only-other-window):
	* info.el (Info-dir-outdated-p):
	* info.el (Info-dump-dir-entries):
	* info.el (Info-rebuild-dir):
	* menubar-items.el (default-menubar):
	* mouse.el (drag-window-divider):
	* mouse.el (vertical-divider-map):
	* test-harness.el (emacs-lisp-file-regexp):
	Eliminate byte-compile warnings, again aside from those linked to
	Stephen's various non-defined fontconfig functions.

2011-03-10  Aidan Kehoe  <kehoea@parhasard.net>

	* cmdloop.el (yes-or-no-p):
	* cmdloop.el (y-or-n-p):
	* descr-text.el (describe-char):
	* diagnose.el (show-memory-usage):
	* diagnose.el (show-object-memory-usage-stats):
	* diagnose.el (show-mc-alloc-memory-usage):
	* diagnose.el (show-gc-stats):
	* faces.el (face-font-instance):
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* help.el (help-symbol-function-context-menu):
	* help.el (help-symbol-variable-context-menu):
	* help.el (help-symbol-function-and-variable-context-menu):
	* help.el (help-find-source-or-scroll-up):
	* help.el (help-mouse-find-source-or-track):
	* help.el (temp-buffer-resize-mode):
	* minibuf.el (mouse-read-file-name-1):
	* obsolete.el (find-non-ascii-charset-string):
	* obsolete.el (find-non-ascii-charset-region):
	* occur.el (occur-engine):
	* paragraphs.el (forward-paragraph):
	* paragraphs.el (forward-sentence):
	* select.el (activate-region-as-selection):
	* select.el (select-make-extent-for-selection):
	* simple.el (zmacs-make-extent-for-region):
	Use quote, not function, for quoting symbols that may not be
	fboundp at the point they are read (again, a style issue, since
	Common Lisp throws an error on this, but we don't, and have no
	plans to.)

2011-03-08  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el:
	* cl-macs.el (loop):
	* cl-macs.el (cl-expand-do-loop):
	* cl-macs.el (shiftf):
	* cl-macs.el (rotatef):
	* cl-macs.el (assert):
	* cl-macs.el (cl-defsubst-expand):
	* etags.el (buffer-tag-table-list):
	* frame.el:
	* frame.el (frame-notice-user-settings):
	* frame.el (minibuffer-frame-list):
	* frame.el (get-frame-for-buffer-noselect):
	Use Common Lisp-derived builtins in a few more places, none of
	them performance-critical, but the style is better.

2011-03-08  Aidan Kehoe  <kehoea@parhasard.net>

	* buff-menu.el (list-buffers-noselect):
	* byte-optimize.el (byte-optimize-identity):
	* byte-optimize.el (byte-optimize-if):
	* byte-optimize.el (byte-optimize-nth):
	* byte-optimize.el (byte-optimize-nthcdr):
	* bytecomp.el (byte-compile-warn-wrong-args):
	* bytecomp.el (byte-compile-two-args-19->20):
	* bytecomp.el (byte-compile-list):
	* bytecomp.el (byte-compile-beginning-of-line):
	* bytecomp.el (byte-compile-set):
	* bytecomp.el (byte-compile-set-default):
	* bytecomp.el (byte-compile-values):
	* bytecomp.el (byte-compile-values-list):
	* bytecomp.el (byte-compile-integerp):
	* bytecomp.el (byte-compile-multiple-value-list-internal):
	* bytecomp.el (byte-compile-throw):
	* cl-macs.el (cl-do-arglist):
	* cl-macs.el (cl-parse-loop-clause):
	* cl-macs.el (multiple-value-bind):
	* cl-macs.el (multiple-value-setq):
	* cl-macs.el (get-setf-method):
	* cmdloop.el (command-error):
	* cmdloop.el (y-or-n-p-minibuf):
	* cmdloop.el (yes-or-no-p-minibuf):
	* coding.el (unencodable-char-position):
	* cus-edit.el (custom-face-prompt):
	* cus-edit.el (custom-buffer-create-internal):
	* cus-edit.el (widget-face-action):
	* cus-edit.el (custom-group-value-create):
	* descr-text.el (describe-char-unicode-data):
	* dialog-gtk.el (popup-builtin-question-dialog):
	* dragdrop.el (experimental-dragdrop-drop-log-function):
	* dragdrop.el (experimental-dragdrop-drop-mime-default):
	* easymenu.el (easy-menu-add):
	* easymenu.el (easy-menu-remove):
	* faces.el (read-face-name):
	* faces.el (set-face-stipple):
	* files.el (file-name-non-special):
	* font.el (font-combine-fonts):
	* font.el (font-set-face-font):
	* font.el (font-parse-rgb-components):
	* font.el (font-rgb-color-p):
	* font.el (font-color-rgb-components):
	* gnuserv.el (gnuserv-edit-files):
	* help.el (key-or-menu-binding):
	* help.el (function-documentation-1):
	* help.el (function-documentation):
	* info.el (info):
	* isearch-mode.el (isearch-exit):
	* isearch-mode.el (isearch-edit-string):
	* isearch-mode.el (isearch-*-char):
	* isearch-mode.el (isearch-complete1):
	* ldap.el (ldap-encode-country-string):
	* ldap.el (ldap-decode-string):
	* minibuf.el (read-file-name-internal-1):
	* minibuf.el (read-non-nil-coding-system):
	* minibuf.el (get-user-response):
	* mouse.el (drag-window-divider):
	* mule/ccl.el:
	* mule/ccl.el (ccl-compile-if):
	* mule/ccl.el (ccl-compile-break):
	* mule/ccl.el (ccl-compile-repeat):
	* mule/ccl.el (ccl-compile-write-repeat):
	* mule/ccl.el (ccl-compile-call):
	* mule/ccl.el (ccl-compile-end):
	* mule/ccl.el (ccl-compile-read-multibyte-character):
	* mule/ccl.el (ccl-compile-write-multibyte-character):
	* mule/ccl.el (ccl-compile-translate-character):
	* mule/ccl.el (ccl-compile-mule-to-unicode):
	* mule/ccl.el (ccl-compile-unicode-to-mule):
	* mule/ccl.el (ccl-compile-lookup-integer):
	* mule/ccl.el (ccl-compile-lookup-character):
	* mule/ccl.el (ccl-compile-map-multiple):
	* mule/ccl.el (ccl-compile-map-single):
	* mule/devan-util.el (devanagari-compose-to-one-glyph):
	* mule/devan-util.el (devanagari-composition-component):
	* mule/mule-cmds.el (finish-set-language-environment):
	* mule/viet-util.el:
	* mule/viet-util.el (viet-encode-viscii-char):
	* multicast.el (open-multicast-group):
	* newcomment.el (comment-quote-nested):
	* newcomment.el (comment-region):
	* newcomment.el (comment-dwim):
	* regexp-opt.el (regexp-opt-group):
	* replace.el (map-query-replace-regexp):
	* specifier.el (derive-device-type-from-tag-set):
	* subr.el (skip-chars-quote):
	* test-harness.el (test-harness-from-buffer):
	* test-harness.el (batch-test-emacs):
	* wid-edit.el (widget-choice-action):
	* wid-edit.el (widget-symbol-prompt-internal):
	* wid-edit.el (widget-color-action):
	* window-xemacs.el (push-window-configuration):
	* window-xemacs.el (pop-window-configuration):
	* window.el (quit-window):
	* x-compose.el (electric-diacritic):
	It's better style, and cheaper (often one assembler instruction
	vs. a C funcall in the byte code), to use `eql' instead of `='
	when it's clear what numerical type a given result will be. Change
	much of our code to do this, with the help of a byte-compiler
	change (not comitted) that looked for calls to #'length (which
	always returns an integer) in its args.

2011-03-08  Aidan Kehoe  <kehoea@parhasard.net>

	* format.el (format-delq-cons): Removed.
	* format.el (format-make-relatively-unique): Removed.
	* format.el (format-common-tail): Removed.
	* format.el (format-reorder): Removed.
	* format.el (format-annotate-region):
	* format.el (format-annotate-single-property-change):
	* format.el (format-annotate-atomic-property-change):
	Remove various functions from this file that re-implemented Common
	Lisp functions that we have built-in.

2011-03-08  Aidan Kehoe  <kehoea@parhasard.net>

	* select.el (selection-preferred-types):
	* select.el (cut-copy-clear-internal):
	* select.el (create-image-functions):
	* select.el (select-convert-from-image/gif):
	* select.el (select-convert-from-image/jpeg):
	* select.el (select-convert-from-image/png):
	* select.el (select-convert-from-image/tiff):
	* select.el (select-convert-from-image/xpm):
	* select.el (select-convert-from-image/xbm):
	* select.el (selection-converter-in-alist):
	Make my Lisp a little more sophisticated in this file.

2011-03-08  Aidan Kehoe  <kehoea@parhasard.net>

	* package-ui.el (pui-add-required-packages):
	* packages.el (packages-handle-package-dumped-lisps):
	* bytecomp-runtime.el (byte-compile-with-fboundp):
	* bytecomp-runtime.el (globally-declare-fboundp):
	* bytecomp-runtime.el 
	(byte-compile-with-byte-compiler-warnings-suppressed):
	* mule/devan-util.el (devanagari-reorder-glyphs-for-composition):
	* mule/devan-util.el (devanagari-compose-to-one-glyph):
	* mule/japanese.el:
	* mule/japanese.el ("Japanese"):
	* mule/make-coding-system.el (fixed-width-generate-helper):
	* mule/mule-category.el (defined-category-list):
	* mule/mule-category.el (undefined-category-designator):
	Style change: remove redundant lambdas, things like (mapcar
	#'(lambda (pkg) (symbol-name pkg)) ...) => (mapcar #'symbol-name ...).

2011-02-16  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-normal-call):
	Check that the car of FORM is a symbol before examining its
	properties; it can be a lambda form if byte-optimize.el hasn't
	worked its magic and transformed such a lambda call into inline
	code.

2011-02-12  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (byte-compile-initial-macro-environment):
	* bytecomp.el (unwind-protect):
	* bytecomp.el (byte-compile-active-blocks):
	* bytecomp.el (byte-compile-catch):
	* bytecomp.el ('return-from-1): Removed.
	* bytecomp.el ('block-1): Removed.
	* bytecomp.el (byte-compile-block-1): Removed.
	* bytecomp.el (byte-compile-return-from-1): Removed.
	* bytecomp.el (byte-compile-throw):
	* cl-macs.el (block):
	* cl-macs.el (return-from):
	In my last change, the elimination of `block's that were never
	`return-from'd didn't work if `cl-macroexpand-all' was called
	explicitly, something much code in cl-macs.el does.  Change the
	implementation to something that doesn't require shadowing of the
	macros in `byte-compile-initial-macro-environment', putting a
	`cl-block-name' property on the gensym'd symbol argument to
	`catch' instead.

2011-02-09  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el (acons): Removed, make the implementation in alloc.c
	visible to Lisp instead.

2011-02-07  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el:
	* bytecomp.el (byte-compile-initial-macro-environment):
	Shadow `block', `return-from' here, we implement them differently
	when byte-compiling.

	* bytecomp.el (byte-compile-active-blocks): New.
	* bytecomp.el (byte-compile-block-1): New.
	* bytecomp.el (byte-compile-return-from-1): New.
	* bytecomp.el (return-from-1): New.
	* bytecomp.el (block-1): New.
	These are two aliases that exist to have their own associated
	byte-compile functions, which functions implement `block' and
	`return-from'.

	* cl-extra.el (cl-macroexpand-all):
	Fix a bug here when macros in the environment have been compiled.

	* cl-macs.el (block):
	* cl-macs.el (return):
	* cl-macs.el (return-from):
	Be more careful about lexical scope in these macros.

	* cl.el:
	* cl.el ('cl-block-wrapper): Removed.
	* cl.el ('cl-block-throw): Removed.
	These aren't needed in code generated by this XEmacs. They
	shouldn't be needed in code generated by XEmacs 21.4, but if it
	turns out the packages do need them, we can put them back.

2011-01-30  Mike Sperber  <mike@xemacs.org>

	* font-lock.el (font-lock-fontify-pending-extents): Don't fail if
	`font-lock-mode' is unset, which can happen in the middle of
	`revert-buffer'.

2011-01-23  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (delete):
	* cl-macs.el (delq):
	* cl-macs.el (remove):
	* cl-macs.el (remq):
	Don't use the compiler macro if these functions were given the
	wrong number of arguments, as happens in lisp-tests.el.
	* cl-seq.el (remove, remq): Removed.
	I added these to subr.el, and forgot to remove them from here.

2011-01-22  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-setq, byte-compile-set):
	Remove kludge allowing keywords' values to be set, all the code
	that does that is gone.

	* cl-compat.el (elt-satisfies-test-p):
	* faces.el (set-face-parent):
	* faces.el (face-doc-string):
	* gtk-font-menu.el:
	* gtk-font-menu.el (gtk-reset-device-font-menus):
	* msw-font-menu.el:
	* msw-font-menu.el (mswindows-reset-device-font-menus):
	* package-get.el (package-get-installedp):
	* select.el (select-convert-from-image-data):
	* sound.el:
	* sound.el (load-sound-file):
	* x-font-menu.el (x-reset-device-font-menus-core):
	Don't quote keywords, they're self-quoting, and the
	win from backward-compatibility is sufficiently small now that the
	style problem overrides it.

2011-01-22  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (block, return-from): Require that NAME be a symbol
	in these macros, as always documented in the #'block docstring and
	as required by Common Lisp.
	* descr-text.el (unidata-initialize-unihan-database):
	Correct the use of non-symbols in #'block and #'return-from in
	this function.

2011-01-15  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (concatenate): Accept more complicated TYPEs in this
	function, handing the sequences over to #'coerce if we don't
	understand them here.
	* cl-macs.el (inline): Don't proclaim #'concatenate as inline, its
	compiler macro is more useful than doing that.

2011-01-11  Aidan Kehoe  <kehoea@parhasard.net>

	* subr.el (delete, delq, remove, remq): Move #'remove, #'remq
	here, they don't belong in cl-seq.el; move #'delete, #'delq here
	from fns.c, implement them in terms of #'delete*, allowing support
	for sequences generally.
	* update-elc.el (do-autoload-commands): Use #'delete*, not #'delq
	here, now the latter's no longer dumped.
	* cl-macs.el (delete, delq): Add compiler macros transforming
	#'delete and #'delq to #'delete* calls.

2011-01-10  Aidan Kehoe  <kehoea@parhasard.net>

	* dialog.el (make-dialog-box): Correct a misplaced parenthesis
	here, thank you Mats Lidell in 87zkr9gqrh.fsf@mail.contactor.se !

2011-01-02  Aidan Kehoe  <kehoea@parhasard.net>

	* dialog.el (make-dialog-box):
	* list-mode.el (display-completion-list):
	These functions used to use cl-parsing-keywords; change them to
	use defun* instead, fixing the build. (Not sure what led to me
	not including this change in d1b17a33450b!)

2011-01-02  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (define-star-compiler-macros):
	Make sure the form has ITEM and LIST specified before attempting
	to change to calls with explicit tests; necessary for some tests
	in lisp-tests.el to compile correctly.
	(stable-union, stable-intersection): Add compiler macros for these
	functions, in the same way we do for most of the other functions
	in cl-seq.el.

2011-01-01  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (dolist, dotimes, do-symbols, macrolet)
	(symbol-macrolet):
	Define these macros with defmacro* instead of parsing the argument
	list by hand, for the sake of style and readability; use backquote
	where appropriate, instead of calling #'list and and friends, for
	the same reason.

2010-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* x-misc.el (device-x-display):
	Provide this function, documented in the Lispref for years, but
	not existing previously.  Thank you Julian Bradfield, thank you
	Jeff Mincy.

2010-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-seq.el:
	Move the heavy lifting from this file to C. Dump the
	cl-parsing-keywords macro, but don't use defun* for the functions
	we define that do take keywords, dynamic scope lossage makes that
	not practical.
	* subr.el (sort, fillarray): Move these aliases here.
	(map-plist): #'nsublis is now built-in, but at this point #'eql
	isn't necessarily available as a test; use #'eq.
	* obsolete.el (cl-delete-duplicates): Make this available for old
	compiler macros and old code.
	(memql): Document that this is equivalent to #'member*, and worse.
	* cl.el (adjoin, subst): Removed. These are in C.

2010-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* simple.el (assoc-ignore-case): Remove a duplicate definition of
	this function (it's already in subr.el).
	* iso8859-1.el (char-width):
	On non-Mule, make this function equivalent to that produced by
	(constantly 1), but preserve its docstring.
	* subr.el (subst-char-in-string): Define this in terms of
	#'substitute, #'nsubstitute.
	(string-width): Define this using #'reduce and #'char-width.
	(char-width): Give this a simpler definition, it makes far more
	sense to check for mule at load time and redefine, as we do in
	iso8859-1.el. 
	(store-substring): Implement this in terms of #'replace, now
	#'replace is cheap.

2010-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* update-elc.el (lisp-files-needed-for-byte-compilation)
	(lisp-files-needing-early-byte-compilation):
	cl-macs belongs in the former, not the latter, it is as
	fundamental as bytecomp.el.

2010-12-30  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el:
	Provde the Common Lisp program-error, type-error as error
	symbols. This doesn't nearly go far enough for anyone using the
	Common Lisp errors.

2010-12-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (delete-duplicates):
	If the form has an incorrect number of arguments, don't attempt a
	compiler macroexpansion.

2010-12-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (cl-safe-expr-p):
	Forms that start with the symbol lambda are also safe.

2010-12-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (= < > <= >=):
	For these functions' compiler macros, the optimisation is safe
	even if the first and the last arguments have side effects, since
	they're only used the once.

2010-12-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (inline-side-effect-free-compiler-macros):
	Unroll a loop here at macro-expansion time, so these compiler
	macros are compiled.  Use #'eql instead of #'eq in a couple of
	places for better style.

2010-12-29  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (notany, notevery): Avoid some dynamic scope
	stupidity with local variable names in these functions, when they
	weren't prefixed with cl-; go into some more detail in the doc
	strings.

2010-12-29  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (side-effect-free-fns): #'remove, #'remq are
	free of side-effects.
	(side-effect-and-error-free-fns):
	Drop dot, dot-marker from the list.

2010-11-17  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (coerce):
	In the argument list, name the first argument OBJECT, not X; the
	former name was always used in the doc string and is clearer.
	Handle vector type specifications which include the length of the
	target sequence, error if there's a mismatch.
	* cl-macs.el (cl-make-type-test): Handle type specifications
	starting with the symbol 'eql.

2010-11-14  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (eql): Don't remove the byte-compile property of this
	symbol. That was necessary to override a bug in bytecomp.el where
	#'eql was confused with #'eq, which bug we no longer have.
	If neither expression is constant, don't attempt to handle the
	expression in this compiler macro, leave it to byte-compile-eql,
	which produces better code anyway.
	* bytecomp.el (eq): #'eql is not the function associated with the
	byte-eq byte code.
	(byte-compile-eql): Add an explicit compile method for this
	function, for cases where the cl-macs compiler macro hasn't
	reduced it to #'eq or #'equal.

2010-10-25  Aidan Kehoe  <kehoea@parhasard.net>

	Add compiler macros and compilation sanity-checking for various
	functions that take keywords.

	* byte-optimize.el (side-effect-free-fns): #'symbol-value is
	side-effect free and not error free.
	* bytecomp.el (byte-compile-normal-call): Check keyword argument
	lists for sanity; store information about the positions where
	keyword arguments start using the new byte-compile-keyword-start
	property.
	* cl-macs.el (cl-const-expr-val): Take a new optional argument,
	cl-not-constant, defaulting to nil, in this function; return it if
	the expression is not constant.
	(cl-non-fixnum-number-p): Make this into a separate function, we
	want to pass it to #'every.
	(eql): Use it.
	(define-star-compiler-macros): Use the same code to generate the
	member*, assoc* and rassoc* compiler macros; special-case some
	code in #'add-to-list in subr.el.
	(remove, remq): Add compiler macros for these two functions, in
	preparation for #'remove being in C.
	(define-foo-if-compiler-macros): Transform (remove-if-not ...) calls to
	(remove ... :if-not) at compile time, which will be a real win
	once the latter is in C.
	(define-substitute-if-compiler-macros)
	(define-subst-if-compiler-macros): Similarly for these functions.
	(delete-duplicates): Change this compiler macro to use
	#'plists-equal; if we don't have information about the type of
	SEQUENCE at compile time, don't bother attempting to inline the
	call, the function will be in C soon enough.
	(equalp): Remove an old commented-out compiler macro for this, if
	we want to see it it's in version control.
	(subst-char-in-string): Transform this to a call to nsubstitute or
	nsubstitute, if that is appropriate.
	* cl.el (ldiff): Don't call setf here, this makes for a load-time
	dependency problem in cl-macs.el

2010-06-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* term/vt100.el:
	Refer to XEmacs, not GNU Emacs, in permissions.

	* term/bg-mouse.el:
	* term/sup-mouse.el:
	Put copyright notice in canonical "Copyright DATE AUTHOR" form.
	Refer to XEmacs, not GNU Emacs, in permissions.

	* site-load.el:
	Add permission boilerplate.

	* mule/canna-leim.el:
	* alist.el:
	Refer to XEmacs, not APEL/this program, in permissions.

	* mule/canna-leim.el:
	Remove my copyright, I've assigned it to the FSF.

2010-06-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* gtk.el:
	* gtk-widget-accessors.el:
	* gtk-package.el:
	* gtk-marshal.el:
	* gtk-compose.el:
	* gnome.el:
	Add copyright notice based on internal evidence.

2010-06-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* easymenu.el: Add reference to COPYING to permission notice.

	* gutter.el:
	* gutter-items.el:
	* menubar-items.el:
	Fix typo "Xmacs" in permissions notice.

2010-06-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* auto-save.el:
	* font.el:
	* fontconfig.el:
	* mule/kinsoku.el:
	Add "part of XEmacs" text to permission notice.

2010-10-14  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (side-effect-free-fns): 
	* cl-macs.el (remf, getf): 
	* cl-extra.el (tailp, cl-set-getf, cl-do-remf): 
	* cl.el (ldiff, endp):
	Tighten up Common Lisp compatibility for #'ldiff, #'endp, #'tailp;
	add circularity checking for the first two.

	#'cl-set-getf and #'cl-do-remf were Lisp implementations of
	#'plist-put and #'plist-remprop; change the names to aliases,
	changes the macros that use them to using #'plist-put and
	#'plist-remprop directly.

2010-10-12  Aidan Kehoe  <kehoea@parhasard.net>

	* abbrev.el (fundamental-mode-abbrev-table, global-abbrev-table):
	Create both these abbrev tables using the usual
	#'define-abbrev-table calls, rather than attempting to
	special-case them.
	* cl-extra.el: Force cl-macs to be loaded here, if cl-extra.el is
	being loaded interpreted.  Previously other, later files would
	redundantly call (load "cl-macs") when interpreted, it's more
	reasonable to do it here, once.
	* cmdloop.el (read-quoted-char-radix): Use defcustom here, we
	don't have any dump-order dependencies that would prevent that.
	* custom.el (eval-when-compile): Don't load cl-macs when
	interpreted or when byte-compiling, rely on cl-extra.el in the
	former case and the appropriate entry in bytecomp-load-hook in the
	latter.  Get rid of custom-declare-variable-list, we have no
	dump-time dependencies that would require it.
	* faces.el (eval-when-compile): Don't load cl-macs when
	interpreted or when byte-compiling.
	* packages.el: Remove some inaccurate comments. 
	* post-gc.el (cleanup-simple-finalizers): Use #'delete-if-not
	here, now the order of preloaded-file-list has been changed to
	make it available.
	* subr.el (custom-declare-variable-list): Remove. No need for it.
	Also remove a stub define-abbrev-table from this file, given the
	current order of preloaded-file-list there's no need for it.

2010-10-10  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-constp) Forms quoted with FUNCTION are
	also constant.
	(byte-compile-initial-macro-environment): In #'the, if FORM is
	constant and does not match TYPE, warn at byte-compile time.

2010-10-10  Aidan Kehoe  <kehoea@parhasard.net>

	* backquote.el (bq-vector-contents, bq-list*): Remove; the former
	is equivalent to (append VECTOR nil), the latter to (list* ...).
	(bq-process-2): Use (append VECTOR nil) instead of using
	#'bq-vector-contents to convert to a list.
	(bq-process-1): Now we use list* instead of bq-list
	* subr.el (list*): Moved from cl.el, since it is now required to
	be available the first time a backquoted form is encountered.
	* cl.el (list*): Move to subr.el.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* test-harness.el (Check-Message):
	Add an omitted comma here, thank you the buildbot.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* hash-table.el (hash-table-key-list, hash-table-value-list)
	(hash-table-key-value-alist, hash-table-key-value-plist):
	Remove some useless #'nreverse calls in these files; our hash
	tables have no order, it's not helpful to pretend they do.
	* behavior.el (read-behavior):
	Do the same in this file, in some code evidently copied from
	hash-table.el.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* info.el (Info-insert-dir):
	* format.el (format-deannotate-region):
	* files.el (cd, save-buffers-kill-emacs):
	Use #'some, #'every and related functions for applying boolean
	operations to lists, instead of rolling our own ones that cons and
	don't short-circuit.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-initial-macro-environment):
	* cl-macs.el (the):
	Rephrase the docstring, make its implementation when compiling
	files a little nicer.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* descr-text.el (unidata-initialize-unicodedata-database)
	(unidata-initialize-unihan-database, describe-char-unicode-data)
	(describe-char-unicode-data):
	Wrap calls to the database functions with (with-fboundp ...),
	avoiding byte compile warnings on builds without support for the
	database functions.
	(describe-char): (reduce #'max ...), not (apply #'max ...), no
	need to cons needlessly.
	(describe-char): Remove a redundant lambda wrapping
	#'extent-properties. 
	(describe-char-unicode-data): Call #'nsubst when replacing "" with
	nil in the result of #'split-string, instead of consing inside
	mapcar.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* x-faces.el (x-available-font-sizes): 
	* specifier.el (let-specifier): 
	* package-ui.el (pui-add-required-packages): 
	* msw-faces.el (mswindows-available-font-sizes): 
	* modeline.el (modeline-minor-mode-menu): 
	* minibuf.el (minibuf-directory-files):
	Replace the O2N (delq nil (mapcar (lambda (W) (and X Y)) Z)) with
	the ON (mapcan (lambda (W) (and X (list Y))) Z) in these files.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (= < > <= >=):
	When these functions are handed more than two arguments, and those
	arguments have no side effects, transform to a series of two
	argument calls, avoiding funcall in the byte-compiled code.
	* mule/mule-cmds.el (finish-set-language-environment):
	Take advantage of this change in a function called 256 times at
	startup.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-function-form, byte-compile-quote)
	(byte-compile-quote-form):
	Warn at compile time, and error at runtime, if a (quote ...) or a
	(function ...) form attempts to quote more than one object.

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* byte-optimize.el (byte-optimize-apply): Transform (apply 'nconc
	(mapcar ...)) to (mapcan ...); warn about use of the first idiom.

	* update-elc.el (do-autoload-commands): 
	* packages.el (packages-find-package-library-path): 
	* frame.el (frame-list): 
	* extents.el (extent-descendants): 
	* etags.el (buffer-tag-table-files): 
	* dumped-lisp.el (preloaded-file-list): 
	* device.el (device-list): 
	* bytecomp-runtime.el (proclaim-inline, proclaim-notinline)
	Use #'mapcan, not (apply #'nconc (mapcar ...) in all these files.

	* bytecomp-runtime.el (eval-when-compile, eval-and-compile):
	In passing, mention that these macros also evaluate the body when
	interpreted. 

2010-09-16  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (the): Add a docstring and an implementation for this
	macro.
	* bytecomp.el (byte-compile-initial-macro-environment): Add #'the
	to this, checking byte-compile-delete-errors to decide whether to
	make the type assertion. Change the initvalue to use backquote and
	preceding commas for the lambda expressions, to allow the latter
	to be compiled.

2010-09-06  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-seq.el (replace):
	Move this function, with added bounds-checking per ANSI Common
	Lisp, to fns.c.

2010-09-05  Aidan Kehoe  <kehoea@parhasard.net>

	* x-compose.el (define-compose-map, compose-map)
	(decide-on-bindings): Support the precomposed characters with
	stroke here too, necessary for Polish and Danish, among others.
	* x-init.el (x-initialize-compose): Add the appropriate map
	autoloads and bindings here.

2010-09-03  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (coerce):
	Add fixnum as an accepted destination type.

2010-09-02  Aidan Kehoe  <kehoea@parhasard.net>

	* obsolete.el (process-get):
	Make #'process-get, #'process-put, #'process-plist,
	#'set-process-plist available as aliases to the more general
	functions #'get, #'put, #'object-plist, #'object-setplist, for GNU
	compatibility.

2010-08-20  Mike Sperber  <mike@xemacs.org>

	* files.el (save-some-buffers-action-alist): Add.
	(save-some-buffers-1): Use (synching with (GPLv2) FSF Emacs.

2010-08-18  Mike Sperber  <mike@xemacs.org>

	* files.el (diff-files-for-recover): Abstract this out out
	`recover-file'.
	(diff-buffer-with-file): Add from (GPLv2) FSF Emacs.
	(recover-file): Use `diff-files-for-recover'.

2010-08-15  Aidan Kehoe  <kehoea@parhasard.net>

	* specifier.el (canonicalize-inst-pair, canonicalize-spec):
	If a specifier tag set is correct, but an instantiator is not in
	an accepted format, don't error with the message "Invalid
	specifier tag set".
	Also, when we error, use error-symbols, for better structured
	error handling and more ease when testing.

2010-07-24  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (concatenate):
	* cl-seq.el (remove*, cl-delete-duplicates):
	Bit vectors are also sequences; enforce this in these functions.
	* cl-macs.el (concatenate):
	If TYPE is constant, don't inline #'concatenate, replace it by a
	call to the appropriate C functions.

2010-06-13  Stephen J. Turnbull  <stephen@xemacs.org>

	* gnome.el:
	* gtk-compose.el:
	* gtk-marshal.el:
	* gtk-package.el:
	* gtk-widget-accessors.el:
	* gtk.el:
	* hyper-apropos.el:
	* multicast.el:
	* view-less.el:
	Correct FSF address in permission notice.

2010-06-08  Aidan Kehoe  <kehoea@parhasard.net>

	* diagnose.el (show-gc-stats):
	Fix a misspelling in a heading in this function.

2010-06-08  Aidan Kehoe  <kehoea@parhasard.net>

	* paragraphs.el (sentence-end):
	* gtk-faces.el:
	* custom.el (custom-declare-variable):
	Remove all core code calls to #'purecopy.
	* obsolete.el (purecopy):
	Make the function itself an obsolete alias to #'identity.

2010-06-06  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-seq.el (reduce):
	Move this to fns.c.

2010-06-02  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (complement):
	* cl-extra.el (complement):
	Add an implementation and a compiler macro for #'complement, as
	specified by CL. For discussion; the compiler macro may be a
	little too aggressive about taking the compile time argument lists
	of the functions it is inverting.

2010-06-02  Aidan Kehoe  <kehoea@parhasard.net>

	* version.el: 
	(emacs-version): 
	* startup.el (command-line): 
	* simple.el (display-warning, emacs-name): 
	* packages.el (packages-package-hierarchy-directory-names): 
	* loadup.el (Dumping): 
	* dumped-lisp.el (preloaded-file-list):
	Remove all InfoDock-specific code.

2010-05-31  Aidan Kehoe  <kehoea@parhasard.net>

	* specifier.el (current-display-table):
	Use keywords in the structure syntax here, now we've moved to that
	by default in C.

2010-05-30  Aidan Kehoe  <kehoea@parhasard.net>

	* cl.el: Remove extraneous empty lines.
	Remove the commented-out Lisp implementation of #'last,
	#'copy-list.
	Remove #'cl-maclisp-member.
	(acons, pairlis): Have the argument list reflect the docstring for
	these functions.

	* cl-macs.el (defun*): Have the argument list reflect the
	docstring.

2010-03-29  Ben Wing  <ben@xemacs.org>

	* mule/mule-category.el (describe-category-table):
	map-category-table and map-char-table can pass in a range, not
	just a char; fix calling code accordingly.

2010-03-29  Ben Wing  <ben@xemacs.org>

	* derived.el:
	* derived.el (derived-mode-merge-syntax-tables):
	map-char-table can pass in a range, not just a char; fix calling
	code accordingly.

2010-03-23  Ben Wing  <ben@xemacs.org>

	* mule/mule-category.el (describe-category-table):
	* mule/mule-category.el (describe-category-code):
	* mule/mule-category.el (predefined-category-list):
	Switch the representation in `describe-category' from bit vectors
	to lists of designators; fix the routines so that they correctly
	print out ranges of characters with the same designators.

2010-03-22  Ben Wing  <ben@xemacs.org>

	* mule/mule-category.el (modify-category-entry):
	* mule/mule-category.el (char-category-list):
	* mule/mule-category.el (describe-category):
	* mule/mule-category.el (make-category-table): Removed.
	* mule/mule-category.el (describe-category-table):
	* mule/mule-category.el (describe-category-code):
	Category tables are now a separate object type.  Various changes
	necessary.  Some functions moved into C (make-category-table,
	modify-category-entry-internal).

2010-03-19  Ben Wing  <ben@xemacs.org>

	* mule/chinese.el (make-chinese-cns11643-charset):
	* mule/chinese.el (chinese-sisheng):
	* mule/cyrillic.el (cyrillic-koi8-r):
	* mule/cyrillic.el (cyrillic-koi8-u):
	* mule/cyrillic.el (cyrillic-alternativnyj):
	* mule/cyrillic.el (cyrillic-koi8-ru):
	* mule/cyrillic.el (cyrillic-koi8-t):
	* mule/cyrillic.el (cyrillic-koi8-c):
	* mule/cyrillic.el (cyrillic-koi8-o):
	* mule/ethiopic.el:
	* mule/japanese.el (japanese-jisx0213-1):
	* mule/japanese.el (japanese-jisx0213-2):
	* mule/korean.el (korean-johab):
	* mule/latin.el (latin-iso8859-10):
	* mule/latin.el (latin-iso8859-13):
	* mule/latin.el (latin-iso8859-14):
	* mule/latin.el (latin-iso8859-16):
	* mule/latin.el (latin-macintosh-roman):
	* mule/misc-lang.el:
	* mule/mule-charset.el (make-128-byte-charset):
	* mule/mule-charset.el (make-internal-charset): Removed.
	* mule/mule-charset.el (make-iso8859-charset):
	* mule/mule-charset.el (katakana-jisx0201):
	* mule/mule-charset.el (latin-jisx0201):
	* mule/mule-charset.el (japanese-jisx0208-1978):
	* mule/mule-charset.el (japanese-jisx0208):
	* mule/mule-charset.el (japanese-jisx0212):
	* mule/mule-charset.el (featurep):
	* mule/mule-charset.el (chinese-gb2312):
	* mule/mule-charset.el (chinese-cns11643-1):
	* mule/mule-charset.el (chinese-cns11643-2):
	* mule/mule-charset.el (korean-ksc5601):
	* mule/mule-charset.el (thai-tis620):
	* mule/mule-charset.el (vietnamese-viscii-lower):
	* mule/mule-charset.el (vietnamese-viscii-upper):
	* mule/mule-charset.el (indian-is13194):
	* mule/mule-charset.el (indian-1-column):
	* mule/mule-charset.el (indian-2-column):
	* mule/mule-charset.el (lao):
	* mule/mule-charset.el (ethiopic):
	* mule/mule-charset.el (tibetan-1-column):
	* mule/mule-charset.el (tibetan):
	* mule/thai.el (thai-iso8859-11):
	* mule/vietnamese.el:
	* mule/vietnamese.el (vietnamese-viscii):
	* mule/windows.el (make-windows-charset):
	Remove `make-internal-charset', use plain `make-charset' instead.
	Rename `make-internal-128-byte-charset' to `make-128-byte-charset'.
	`make-internal-charset' no longer needed because
	`load-unicode-mapping-tables' now automatically looks relative
	to `data-directory'.

2010-03-14  Ben Wing  <ben@xemacs.org>

	* mule/chinese.el (cn-gb-2312):
	* mule/chinese.el (big5):
	* mule/devanagari.el:
	* mule/devanagari.el (in-is13194-devanagari):
	* mule/devanagari.el (devanagari):
	* mule/hebrew.el:
	* mule/hebrew.el (ctext-hebrew):
	* mule/hebrew.el ("Hebrew"):
	* mule/iso-with-esc.el:
	* mule/iso-with-esc.el (iso-latin-2-with-esc):
	* mule/iso-with-esc.el (iso-latin-3-with-esc):
	* mule/iso-with-esc.el (iso-latin-4-with-esc):
	* mule/iso-with-esc.el (iso-latin-9-with-esc):
	* mule/iso-with-esc.el (iso-latin-5-with-esc):
	* mule/iso-with-esc.el (cyrillic-iso-8bit-with-esc):
	* mule/iso-with-esc.el (hebrew-iso-8bit-with-esc):
	* mule/iso-with-esc.el (greek-iso-8bit-with-esc):
	* mule/iso-with-esc.el (arabic-iso-8bit-with-esc):
	* mule/japanese.el (iso-2022-jp):
	* mule/japanese.el (jis7):
	* mule/japanese.el (jis8):
	* mule/japanese.el (shift-jis):
	* mule/japanese.el (iso-2022-jp-1978-irv):
	* mule/japanese.el (euc-jp):
	* mule/korean.el (iso-2022-int-1):
	* mule/korean.el (euc-kr):
	* mule/korean.el (iso-2022-kr):
	* mule/lao.el:
	* mule/lao.el (lao):
	* mule/lao.el ("Lao"):
	* mule/mule-coding.el:
	* mule/mule-coding.el (ctext):
	* mule/mule-coding.el (iso-2022-8bit-ss2):
	* mule/mule-coding.el (iso-2022-7bit-ss2):
	* mule/mule-coding.el (iso-2022-jp-2):
	* mule/mule-coding.el (iso-2022-7bit):
	* mule/mule-coding.el (iso-2022-8):
	* mule/mule-coding.el (escape-quoted):
	* mule/mule-coding.el (iso-2022-lock):
	* mule/thai.el (thai-tis620):
	* mule/thai.el (th-tis620):
	* mule/tibetan.el:
	* mule/tibetan.el (tibetan-iso-8bit):
	* code-init.el:
	Remove `safe-charsets' property from most coding systems.

2010-03-14  Ben Wing  <ben@xemacs.org>

	* autoload.el (make-autoload):
	No make-8-bit-coding-system any more.
	
	* coding.el (encode-coding-char):
	query-coding-string no longer accepts characters so convert to string.
	
	* coding.el (featurep):
	Remove autoloading of make-coding-system, it's been moved back
	into C.
	
	* coding.el (query-coding-clear-highlights): Removed.
	* coding.el (query-coding-string): Removed.
	Moved into C.
	
	* mule/general-late.el:
	`set-unicode-query-skip-chars-args' no longer needed.

	* mule/make-coding-system.el:
	* mule/make-coding-system.el (fixed-width-generate-helper): Removed.
	* mule/make-coding-system.el (fixed-width-private-use-start): Removed.
	Deleted whole file, along with fixed-width coding system.  Move doc
	string back into C.
	
	* update-elc.el (additional-dump-dependencies):
	Not make-coding-system.el any more.
	
	* update-elc.el (lisp-files-dependent-on-configuration):
	general-late.el no longer dependent on --unicode-internal or not.

2010-03-07  Ben Wing  <ben@xemacs.org>

	* mule/japanese.el (for):
	Don't blindly set syntax of entire rows -- check to make sure we aren't
	changing syntax of Latin-1.

2010-03-06  Ben Wing  <ben@xemacs.org>

	* code-init.el (reset-coding-categories-to-default):
	Move some documentation here from file-coding.h.

2010-02-28  Ben Wing  <ben@xemacs.org>

	* mule/vietnamese.el (viscii):
	Don't have ASCII shadowing; overlapping charsets no longer allowed.
	
	* mule/windows.el:
	* mule/windows.el (make-windows-coding-system):
	* mule/windows.el (1361):
	Change `unicode-file' so it takes a filename relative to
	`data-directory' not a Microsoft-specific subdir.  Fix various charsets
	that use `unicode-file'.  Put proper bounds and add Unicode conversion
	file in `korean-johab' and `japanese-windows-10001' (Macintosh
	Japanese).  Make `windows-875' be `greek' not `latin', and comment
	out for the moment all the EBCDIC charsets because I didn't feel like
	fixing `make-windows-coding-system' (see comments in file).

2010-02-27  Ben Wing  <ben@xemacs.org>

	* mule/mule-charset.el:
	* mule/mule-charset.el (charset-tag-property): New.
	* mule/mule-charset.el (charset-tag-properties): New.
	* mule/mule-charset.el (charset-tag-to-charset-list):
	Add a couple of functions `charset-tag-property' and
	`charset-tag-properties'.  Modify charset-tag-to-charset-list to
	use these functions.  Also use :from-end property to
	`remove-duplicates' so that result is "stable" in that later extra
	elements rather than earlier ones get deleted.  Also reverse the
	order of charsets associated with a tag so that it matches the
	order that charsets were added. (Not strictly necessary but principle
	of least surprised.)

2010-02-27  Ben Wing  <ben@xemacs.org>

	* mule/latin.el (code):
	Use char codes rather than directly encoding the chars for the
	remaining few directly encoded chars (latin-15).

2010-02-26  Ben Wing  <ben@xemacs.org>

	* mule/hebrew.el:
	* mule/hebrew.el ("Hebrew"):
	* mule/lao.el:
	* mule/lao.el (make-char):
	Convert to utf-8.

2010-02-22  Ben Wing  <ben@xemacs.org>

	* mule/thai-util.el:
	* mule/thai-util.el (l):
	* mule/thai.el:
	* mule/thai.el ("Thai"):
	Convert to utf-8.

2010-02-22  Ben Wing  <ben@xemacs.org>

	* mule/thai.el ("Thai"):
	* mule/thai.el (thai):
	Don't set input method as thai-kesmanee, this isn't currently working
	in quail.

2010-02-20  Ben Wing  <ben@xemacs.org>

	* mule/general-late.el (eval-when-compile):
	map-charset-chars interface has changed.
	
	* mule/mule-category.el:
	* mule/mule-category.el (kanji-kanji-char):
	Separate double-width Kanji Greek and Cyrillic chars don't exist
	in Unicode-internal, so use decode-coding-string to encode them
	rather than doing it directly, to avoid problems when saving the
	file in Unicode-internal.
	
	* mule/mule-charset.el:
	* mule/mule-charset.el (map-charset-chars): Removed.
	map-charset-chars moved to C.

2010-02-20  Ben Wing  <ben@xemacs.org>

	* subr.el:
	* subr.el (backtrace-in-condition-handler-eliminating-handler):
	Use minimal matching to try to avoid possible stack-overflow errors.
	* subr.el (with-trapping-errors):
	Add :debug argument for calling the debugger.

2010-02-20  Ben Wing  <ben@xemacs.org>

	* mule/general-early.el (setup-case-pairs):
	Conditionalize on use-unidata-case-tables.
	
	* mule/mule-category.el:
	* mule/mule-category.el (predefined-category-list):
	Take out chinese-cns11643-1 for the moment, since it makes
	category ?t include ASCII and other stuff that shouldn't be there,
	which messes up word-across-newline, which messes up fill-paragraph.
	
	* mule/mule-category.el (kanji-Greek-Upper):
	* mule/mule-category.el (kanji-kanji-char):
	Bogus changes that will be reverted.
	
	* mule/mule-charset.el:
	* mule/mule-charset.el (charset-iso-2022-p): New.
	* mule/mule-charset.el (charset-ccl-program):
	Add author comment.  New function charset-iso-2022-p.
	
	* mule/uni-case-conv.el:
	* mule/uni-case-conv.el (for):
	Regenerate; nreverse case table mapping list, see comment in file.

2010-02-20  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (use-unidata-case-tables):
	* dumped-lisp.el (preloaded-file-list):
	New feature `use-unidata-case-tables', to control whether we
	use the new Unicode case table info from unicode.org.  When we're
	sure we've gotten this to work and it causes no bugs, get rid of
	this.

2010-02-04  Ben Wing  <ben@xemacs.org>

	* mule/general-early.el (setup-case-pairs):
	Turn off when Unicode, relying on uni-case-conv.el.
	* mule/uni-case-conv.el (for): Regenerate.

2010-02-04  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (preloaded-file-list):
	Load uni-case-conv.el.  It seems to work now, after all the various
	search and case-related fixes.

2010-02-07  Aidan Kehoe  <kehoea@parhasard.net>

	* make-docfile.el (format-decode): Remove this temporary function
	definition, now we check the symbol is bound in fileio.c
	* version.el (format-decode): Ditto.
	* format.el (car-less-than-car, cdr-less-than-cdr): Move these
	here from fileio.c, now they are only called once format.el is
	available.

2010-02-07  Aidan Kehoe  <kehoea@parhasard.net>

	* setup-paths.el (paths-find-emacs-roots)
	(paths-construct-info-path):
	* packages.el (packages-find-installation-package-directories):
	#'union doesn't guarantee that it will preserve the relative order
	of elements in its arguments; use #'delete-duplicates
	instead. Thank you for the bug reports, Robert Pluim, Stephen
	Turnbull.

2010-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	* x-win-xfree86.el (x-win-init-xfree86):
	If iso-left-tab (something ISO-specified and portable in theory;
	in practice only seen with XFree86 and derived non-US layouts)
	exists on the keyboard layout, make it equivalent to shift-tab,
	addressing the issue FKtPp sees in
	http://mid.xemacs.org/1269358206.4873.1.camel@fktpp-laptop .

2010-03-21  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (cl-prettyprint):
	Handle (function ...) specially here, as we do (quote ...).

2010-04-02  Aidan Kehoe  <kehoea@parhasard.net>

	* descr-text.el (describe-char-unicode-data):
	Don't give up if describe-char-use-cache is t and the database
	isn't readable, warn and insert the entire UnicodeData.txt file
	instead.

2010-04-01  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-seq.el (fill, sort*, merge): Move these functions to fns.c.
	(stable-sort): Make this docstring reflect the argument names used
	in the #'sort* docstring.
	* cl-macs.el (stable-sort): Make #'stable-sort exactly equivalent
	to #'sort* in compiled code.

	* bytecomp.el (byte-compile-maybe-add-*):
	New macro, for functions like #'sort and #'mapcar that, to be
	strictly compatible, should only take two args, but in our
	implementation can take more, because they're aliases of #'sort*
	and #'mapcar*.
	(byte-compile-mapcar, byte-compile-sort, byte-compile-fillarray):
	Use this new macro.
	(map-into): Add a byte-compile method for #'map-into in passing.

	* apropos.el (apropos-print): Use #'sort* with a :key argument,
	now it's in C.
	* compat.el (extent-at): Ditto.
	* register.el (list-registers): Ditto.
	* package-ui.el (pui-list-packages): Ditto.
	* help.el (sorted-key-descriptions): Ditto. 

2010-02-22  Ben Wing  <ben@xemacs.org>

	* dumped-lisp.el (preloaded-file-list):
	* font.el (font-tty-find-closest-color):
	* fontcolor.el:
	* fontcolor.el (ws-object-property-1): Removed.
	* fontcolor.el (fontcolor-property-1): New.
	* fontcolor.el (font-name):
	* fontcolor.el (font-ascent):
	* fontcolor.el (font-descent):
	* fontcolor.el (font-width):
	* fontcolor.el (font-height):
	* fontcolor.el (font-proportional-p):
	* fontcolor.el (font-properties):
	* fontcolor.el (font-truename):
	* fontcolor.el (color-name):
	* fontcolor.el (color-rgb-components):
	* x-faces.el:
	Rename objects.el -> fontcolor.el.

2010-02-22  Ben Wing  <ben@xemacs.org>

	* obsolete.el:
	* obsolete.el ('show-buffer): New.
	* obsolete.el ('buffer-flush-undo): New.
	* obsolete.el (buffer-local-value): New.
	* obsolete.el (Info-default-directory-list): Removed.
	* obsolete.el (x-color-values): New.
	* obsolete.el (mswindows-color-list):
	* obsolete.el (init-file-user): Removed.
	* obsolete.el ('pui-add-install-directory): Removed.
	* obsolete.el (line-beginning-position):
	* obsolete.el ('line-beginning-position): New.
	* obsolete.el ('line-end-position): New.
	* obsolete.el (obsolete-throw): New.
	* obsolete.el ('cl-mapc): New.
	* obsolete.el ('byte-code-function-p): New.
	* obsolete.el ('interactive-form): New.
	* obsolete.el ('assq-delete-all): New.
	* obsolete.el (makehash): New.
	* obsolete.el ('user-original-login-name): Removed.
	* obsolete.el ('isearch-yank-x-selection): Removed.
	* obsolete.el ('isearch-yank-x-clipboard): Removed.
	* obsolete.el ('display-column-mode): New.
	Rearrange; create some new categories out of "misc" stuff,
	put categories in alphabetical order, move remaning "misc"
	stuff to bottom.

2010-03-29  Aidan Kehoe  <kehoea@parhasard.net>

	* hyper-apropos.el (hyper-apropos-get-doc):
	Use help.el's #'function-arglist, #'function-documentation,
	#'symbol-file in this function, instead of rolling our own.

2010-03-25  Ben Wing  <ben@xemacs.org>

	* diagnose.el (show-memory-usage):
	* diagnose.el (show-object-memory-usage-stats):
	Further changes to correspond with changes in the C code;
	add an additional column in show-object-memory-usage-stats showing
	the ancillary Lisp overhead used with each type; shrink columns for
	windows in show-memory-usage to get it to fit in 79 chars.

2010-03-26  Aidan Kehoe  <kehoea@parhasard.net>

	* descr-text.el (describe-char-display):
	Behave better on builds without database support, and for
	characters where no font is available. Especially relevant on
	Win32.

2010-03-23  Aidan Kehoe  <kehoea@parhasard.net>

	* x-win-xfree86.el (x-win-init-xfree86):
	If iso-left-tab (something ISO-specified and portable in theory;
	in practice only seen with XFree86 and derived non-US layouts)
	exists on the keyboard layout, make it equivalent to shift-tab,
	addressing the issue FKtPp sees in
	http://mid.xemacs.org/1269358206.4873.1.camel@fktpp-laptop .

2010-03-21  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (cl-prettyprint):
	Handle (function ...) specially here, as we do (quote ...).

2010-03-20  Ben Wing  <ben@xemacs.org>

	* diagnose.el (show-memory-usage):
	* diagnose.el (show-object-memory-usage-stats):
	Further changes to correspond with changes in the C code;
	add an additional column showing the overhead used with each type,
	and add it into the grand total memory usage.

2010-03-19  Ben Wing  <ben@xemacs.org>

	* diagnose.el (show-object-memory-usage-stats):
	Rewrite to take into account non-lisp-storage statistics
	returned by garbage-collect-1 and friends.

2010-03-18  Ben Wing  <ben@xemacs.org>

	* diagnose.el (show-memory-usage):
	Rewrite to take into account API changes in memory-usage functions.

2010-03-20  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (notany, notevery):
	Correct these compiler macros.

2010-03-15  Ben Wing  <ben@xemacs.org>

	* mule/mule-cmds.el:
	* mule/mule-cmds.el (finish-set-language-environment):
	Fix bug in generating display-table entries for error octet characters.

2010-03-12  Ben Wing  <ben@xemacs.org>

	* test-harness.el (test-harness-from-buffer):
	Undo change of e.g. (Assert (equalp ...)) to (Assert-equalp ...).
	Get rid of `Assert-equalp' and friends, `Assert-test', and
	`Assert-test-not'.  Instead, make `Assert' smart enough to do the
	equivalent functionality when an expression like (Assert (equalp ...))
	is seen.

2010-03-11  Aidan Kehoe  <kehoea@parhasard.net>

	* setup-paths.el (paths-find-emacs-roots)
	(paths-construct-info-path):
	Pass :from-end t to the delete-duplicates calls in these
	functions, now the compiler macro no longer defaults it to t.

2010-03-07  Ben Wing  <ben@xemacs.org>

	* disp-table.el:
	* disp-table.el (standard-display-g1):
	* disp-table.el (standard-display-graphic):
	Fix up docs; add comments about authorship.

2010-03-06  Ben Wing  <ben@xemacs.org>

	* test-harness.el:
	* test-harness.el (test-harness-backtrace): New.
	* test-harness.el (test-harness-assertion-failure-do-debug):
	* test-harness.el (test-harness-unexpected-error-do-debug):
	Use the print settings from edebug.el to make backtraces not
	be so huge.

2010-03-06  Aidan Kehoe  <kehoea@parhasard.net>

	* bytecomp.el (byte-compile-compiled-obj-to-list):
	Remove this function, printing a compiled object to a string and
	then reading back a substring is senseless, just use the
	compiled-function slot accessor functions.

2010-03-05  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (delete-duplicates):
	Correct the logic of this compiler macro when :from-end is nil,
	avoiding a hang in query-coding-tests.el. Thanks for the reports,
	Vin and Mats!

2010-03-04  Aidan Kehoe  <kehoea@parhasard.net>

	* make-docfile.el (process-args):
	Use #'subseq here, not #'substring, fixing the native Windows
	build. Thank you for the error report, Vin!

2010-03-03  Aidan Kehoe  <kehoea@parhasard.net>

	Move byte code #o117 to #'subseq, not #'substring.
	Make #'substring available as an alias for #'subseq in Lisp.
	* bytecomp.el (79, subseq, substring):
	* bytecomp.el (byte-compile-subseq): New.
	* update-elc.el (update-elc-chop-extension): Use #'subseq, not
	#'substring, the latter is not yet available.
	* subr.el (substring): New alias, to #'subseq.

2010-03-02  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-macs.el (delete-dups): New compiler macro for this function,
	expanding to inline byte codes.
	(delete-duplicates): Handle the :from-end argument correctly in
	this compiler macro.

2010-03-01  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-seq.el (cl-parsing-keywords):
	* cl-macs.el (cl-do-arglist):
	Use the new invalid-keyword-argument error here.

2010-02-26  Aidan Kehoe  <kehoea@parhasard.net>

	Back out Ben's revision c673987f5f3d.
	* coding.el:
	Add a compiler macro for #'make-coding-system on non-Mule builds
	too, to fix the problem he addressed with that changeset.
	* mule/make-coding-system.el (fixed-width-private-use-start):
	Don't call (decode-char ... 'ucs) here, it can make bootstrapping
	harder.

2010-02-26  Ben Wing  <ben@xemacs.org>

	* autoload.el (autoload-featurep-protect-autoloads):
	Always insert a coding-system cookie, either raw-text-unix or
	escape-quoted.  As before, insert an error statement when an
	escape-quoted auto-autoload is loaded in a non-Mule XEmacs.

	This fixes problems when the default coding system is UTF-8,
	as in Cygwin.  Under some circumstances, the file can get
	written out as raw text and read in as UTF-8, where invididual
	high-bytes are usually invalid UTF-8 sequences and lead to
	error octets in the buffer; when written out again, these
	force escape-quoted.  Result: auto-autoloads.el for the
	source-tree lisp/ directory would end up as escape-quoted.

2010-02-25  Didier Verna  <didier@xemacs.org>

	The background-placement face property.
	* cl-macs.el (face-background-placement): New defsetf.
	* cus-face.el (custom-face-attributes):
	* faces.el (face-interactive):
	* faces.el (set-face-property):
	* faces.el (face-equal):
	* faces.el (init-other-random-faces): Update.
	* faces.el (face-background-placement):
	* faces.el (set-face-background-placement):
	* faces.el (face-background-placement-instance):
	* faces.el (face-background-placement-instance-p):
	* frame.el (set-frame-background-placement):
	* frame.el (frame-background-placement):
	* frame.el (frame-background-placement-instance):
	* objects.el (make-face-background-placement-specifier): New.

2010-02-25  Ben Wing  <ben@xemacs.org>

	* autoload.el (make-autoload):
	Call cl-function-arglist with one arg.
	
	* cl-macs.el (cl-function-arglist):
	* cl-macs.el (cl-transform-lambda):
	Make cl-function-arglist take only one arg, the arglist; no
	function name passed.  Also make sure to print () instead of nil
	when empty arglist, or function-documentation-1 won't recognize
	the arguments: line.
	* help.el (function-arglist): If empty arg, don't display extra
	space after function name.

2010-02-24  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (constantly):
	Normally return a compiled function from #'constantly if we are
	handed a single argument. Shouldn't actually matter, the overhead
	for returning a single constant in a lambda form vs. in a compiled
	function is minuscule, but using compiled functions as much as
	possible is good style in XEmacs, our interpreter is not stellar
	(nor indeed should it need to be).

2010-02-23  Ben Wing  <ben@xemacs.org>

	* help.el: fux typo in comment. (oops)

2010-02-23  Ben Wing  <ben@xemacs.org>

	* autoload.el:
	* autoload.el (make-autoload):
	* cl-macs.el (cl-function-arglist):
	* cl-macs.el (cl-transform-lambda):
	Don't add argument list with the tag "Common Lisp lambda list:";
	instead add in "standard" form using "arguments:" and omitting the
	function name.  Add an arg to `cl-function-arglist' to omit the
	name and use it in autoload.el instead of just hacking it off.
	
	* help.el:
	* help.el (function-arglist):
	* help.el (function-documentation-1): New.
	Extract out common code to recognize and/or strip the arglist from
	documentation into `function-documentation-1'.  Use in
	`function-arglist' and `function-documentation'.  Modify
	`function-arglist' so it looks for the `arguments: ' stuff in all
	doc strings, not just subrs/autoloads, so that CL functions get
	recognized properly.  Change the regexp used to match "arguments: "
	specs to allow nested parens inside the arg list (happens when you
	have a default value specified in a CL arglist).

2010-02-22  Ben Wing  <ben@xemacs.org>

	* test-harness.el:
	* test-harness.el (test-harness-from-buffer):
	* test-harness.el (batch-test-emacs):
	Move file from tests/automated into lisp/ so it gets
	byte-compiled.  This significantly reduces the amount of extra
	crap in outputted backtraces.  Delete hack in batch-test-emacs to
	look for test-harness.el in the test directory since it's not there
	any more.

	Also, in `Check-Message', incorporate call to `Skip-Test-Unless'
	in the macro output rather than its body, to avoid problems byte-
	compiling the file -- `Skip-Test-Unless' isn't available in the
	environment during byte-compilation so we can't call it then.
	
2010-02-22  Ben Wing  <ben@xemacs.org>

	* cl-seq.el:
	* cl-seq.el (stable-union): New.
	* cl-seq.el (stable-intersection): New.
	New functions to do stable set operations, i.e. preserve the order
	of the elements in the argument lists, and prefer LIST1 over LIST2
	when ordering the combined result.  The result looks as much like
	LIST1 as possible, followed (in the case of `stable-union') by
	any necessary elements from LIST2, in order.  This is contrary to
	`union' and `intersection', which are not required to be order-
	preserving and are not -- they prefer LIST2 and output results in
	backwards order.

2010-02-22  Ben Wing  <ben@xemacs.org>

	* cl-seq.el:
	* cl-seq.el (reduce):
	* cl-seq.el (fill):
	* cl-seq.el (replace):
	* cl-seq.el (remove*):
	* cl-seq.el (remove-if):
	* cl-seq.el (remove-if-not):
	* cl-seq.el (delete*):
	* cl-seq.el (delete-if):
	* cl-seq.el (delete-if-not):
	* cl-seq.el (remove-duplicates):
	* cl-seq.el (delete-duplicates):
	* cl-seq.el (substitute):
	* cl-seq.el (substitute-if):
	* cl-seq.el (substitute-if-not):
	* cl-seq.el (nsubstitute):
	* cl-seq.el (nsubstitute-if):
	* cl-seq.el (nsubstitute-if-not):
	* cl-seq.el (find):
	* cl-seq.el (find-if):
	* cl-seq.el (find-if-not):
	* cl-seq.el (position):
	* cl-seq.el (position-if):
	* cl-seq.el (position-if-not):
	* cl-seq.el (count):
	* cl-seq.el (count-if):
	* cl-seq.el (count-if-not):
	* cl-seq.el (mismatch):
	* cl-seq.el (search):
	* cl-seq.el (sort*):
	* cl-seq.el (stable-sort):
	* cl-seq.el (merge):
	* cl-seq.el (member*):
	* cl-seq.el (member-if):
	* cl-seq.el (member-if-not):
	* cl-seq.el (assoc*):
	* cl-seq.el (assoc-if):
	* cl-seq.el (assoc-if-not):
	* cl-seq.el (rassoc*):
	* cl-seq.el (rassoc-if):
	* cl-seq.el (rassoc-if-not):
	* cl-seq.el (union):
	* cl-seq.el (nunion):
	* cl-seq.el (intersection):
	* cl-seq.el (nintersection):
	* cl-seq.el (set-difference):
	* cl-seq.el (nset-difference):
	* cl-seq.el (set-exclusive-or):
	* cl-seq.el (nset-exclusive-or):
	* cl-seq.el (subsetp):
	* cl-seq.el (subst-if):
	* cl-seq.el (subst-if-not):
	* cl-seq.el (nsubst):
	* cl-seq.el (nsubst-if):
	* cl-seq.el (nsubst-if-not):
	* cl-seq.el (sublis):
	* cl-seq.el (nsublis):
	* cl-seq.el (tree-equal):
	* cl-seq.el (cl-tree-equal-rec):
	* cl.el:
	* cl.el (pushnew):
	* cl.el (adjoin):
	* cl.el (subst):
	Document the keywords to the various sequence/list functions.

2010-02-21  Ben Wing  <ben@xemacs.org>

	* diagnose.el:
	* diagnose.el (show-object-memory-usage-stats):
	Fix errors preventing this from working properly, account for
	words like "entry" pluralized to "entries".

2010-02-22  Aidan Kehoe  <kehoea@parhasard.net>

	* cl-extra.el (constantly): 
	Add this function, from ANSI Common Lisp, using the SBCL extension
	that extra arguments to it are passed back as multiple values in
	the constructed function.
	* cl-macs.el (constantly):
	In the compiler macro for #'constantly, construct a
	compiled-function object almost every time, at compile time when
	all arguments are constant, and at runtime when they vary.

2010-02-19  Ben Wing  <ben@xemacs.org>

	* paragraphs.el:
	* paragraphs.el (use-hard-newlines):
	* paragraphs.el (paragraph-start):
	* paragraphs.el (paragraph-separate):
	* paragraphs.el (sentence-end-double-space):
	* paragraphs.el (sentence-end-without-period):
	* paragraphs.el (sentence-end-without-space): New.
	* paragraphs.el (sentence-end):
	* paragraphs.el (sentence-end-base): New.
	* paragraphs.el (page-delimiter):
	* paragraphs.el (paragraph-ignore-fill-prefix):
	* paragraphs.el (forward-paragraph):
	* paragraphs.el (backward-paragraph):
	* paragraphs.el (mark-paragraph):
	* paragraphs.el (forward-sentence):
	* paragraphs.el (repunctuate-sentences): New.
	Sync with FSF 23.1.92.

2010-02-08  Ben Wing  <ben@xemacs.org>

	* help.el (describe-function-1):
	Don't use compiled-function-annotation to retrieve the file name
	for a function since it doesn't provide this info and load-history
	already does provide it.

2010-02-07  Aidan Kehoe  <kehoea@parhasard.net>

	* make-docfile.el (format-decode): Remove this temporary function
	definition, now we check the symbol is bound in fileio.c
	* version.el (format-decode): Ditto.
	* format.el (car-less-than-car, cdr-less-than-cdr): Move these
